---------------------------------------------------------------------
--[[ license agreement >>
---------------------------------------------------------------------

Copyright  2007-2009 Bulldozer

Ledokol is free software; You can redistribute it
and modify it under the terms of the GNU General
Public License as published by the Free Software
Foundation, either version 3 of the license, or at
your option any later version.

Ledokol is distributed in the hope that it will be
useful, but without any warranty, without even the
implied warranty of merchantability or fitness for
a particular purpose. See the GNU General Public
License for more details.

Please see http://www.gnu.org/licenses/ for a copy
of the GNU General Public License.

---------------------------------------------------------------------
]]-- license agreement <<
---------------------------------------------------------------------

---------------------------------------------------------------------
--[[ script information >>
---------------------------------------------------------------------

Author: Bulldozer
License: GNU General Public License
Description: Multifunctional Lua script for Verlihub
Official website: http://hundrambit.info/?menu=ledokol
Alternative website: http://code.google.com/p/ledokol/
Translations: http://hundrambit.info/?menu=ledokol&page=translate
Report a bug: http://forum.hundrambit.info/viewforum.php?f=39
Request a feature: http://forum.hundrambit.info/viewforum.php?f=40
Support hub: dchub://ledokol.hundrambit.info:2007/

---------------------------------------------------------------------
]]-- script information <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- global storage variables and tables >>
---------------------------------------------------------------------

ver_ledo = "2.6.0" -- ledokol version

---------------------------------------------------------------------
-- default custom settings table >>
---------------------------------------------------------------------

table_sets = {

["mincommandclass"] = 5,
["minusrcommandclass"] = 0,
["commandstopm"] = 1,
["scanbelowclass"] = 3,
["regkickaction"] = 1,
["thirdacttime"] = "1d",
["sixthactaddr"] = "ledokol.hundrambit.info:2007",
["seventhacttime"] = "",
["enableantispam"] = 0,
["allowspamtoops"] = 0,
["antikreason"] = "Forbidden message detected: *",
["antimessage"] = "Your message wasn't sent due spam detection. In case you disagree with this decision you will need to contact hub administration.",
["enablesearfilt"] = 0,
["sefireason"] = "Forbidden search request detected: *",
["searfiltmsg"] = "Your search request is forbidden and therefore was discarded: *",
["classnotianti"] = 3,
["classnotiex"] = 3,
["classnotisefi"] = 3,
["classnoticom"] = 10,
["classnotisay"] = 3,
["classnotikick"] = 3,
["classnotiban"] = 3,
["classnotireg"] = 3,
["classnoticonfig"] = 10,
["classnotiredir"] = 3,
["classnotiunk"] = 3,
["classnotioff"] = 3,
["classnotiledoact"] = 10,
["classnotiauth"] = 3,
["classnotiwelcome"] = 3,
["classnotibotpm"] = 3,
["micheck"] = 0,
["micallall"] = 0,
["michnick"] = 0,
["michdesc"] = 0,
["michtag"] = 0,
["michconn"] = 0,
["michemail"] = 0,
["michshare"] = 0,
["michip"] = 0,
["michfake"] = 0,
["michclone"] = 0,
["michsameip"] = 0,
["minickmessage"] = "Forbidden nick detected: *",
["midescmessage"] = "Forbidden description detected: *",
["mitagmessage"] = "Forbidden tag detected: *",
["miconnmessage"] = "Forbidden connection type detected: *",
["miemailmessage"] = "Forbidden email detected: *",
["misharemessage"] = "Forbidden share size detected: *",
["miipmessage"] = "Forbidden IP address detected: *",
["mifakemessage"] = "Fake share detected: *",
["miclonemessage"] = "Clone of yourself detected: *",
["misameipmessage"] = "Connection from same IP detected: *",
["mitbantime"] = "3h",
["kickunkusers"] = 0,
["unktbantime"] = "3h",
["unkkickreason"] = "Unknown protocol command detected from your client: *",
["authrunning"] = 0,
["authmessage"] = "Your IP doesn't match the authorization IP set for your nick.",
["custnickclass"] = 3,
["custmaxlen"] = 32,
["savecustnicks"] = 1,
["releaseclass"] = 11,
["welcomeclass"] = 3,
["offmsgclass"] = 3,
["sayclass"] = 3,
["chatrunning"] = 0,
["remrunning"] = 0,
["resprunning"] = 0,
["respdelay"] = 5,
["newsclass"] = 11,
["newsautolines"] = 0,
["chatrankclass"] = 11,
["sharerankclass"] = 11,
["shareranmin"] = 100,
["oprankclass"] = 11,
["wordrankclass"] = 11,
["wordranmin"] = 5,
["wordranmax"] = 25,
["ranklimit"] = 25,
["histlimit"] = 0,
["histbotmsg"] = 0,
["histautolines"] = 0,
["histautolinemax"] = 65,
["addledobot"] = 1,
["ledobotnick"] = "-="..string.char (160).."Ledokol"..string.char (160).."=-",
["useextrafeed"] = 0,
["extrafeednick"] = "-="..string.char (160).."Feed"..string.char (160).."=-",
["timebotint"] = 0,
["timebotnick"] = "-="..string.char (160).."%Y-%m-%d"..string.char (160).."%H:%M"..string.char (160).."=-",
["srvtimediff"] = 0,
["dateformat"] = "%Y-%m-%d",
["timeformat"] = "%H:%M:%S",
["rolltopicint"] = 0,
["rolltopicspace"] = 5,
["showtopicowner"] = 1,
["ipconantiflint"] = 15,
["pmminclass"] = 0,
["enableuserlog"] = 0,
["logallmyinfos"] = 0,
["funrandomchat"] = 0,
["langfileprefix"] = "en",
["translitmode"] = 0

}

---------------------------------------------------------------------
-- default custom settings table <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- hidden settings table >>
---------------------------------------------------------------------

table_hidsets = {

["ver_ledo"] = ver_ledo,
["lastcleankicks"] = "0000-00-00",
["dayscleankicks"] = "-1",
["lastcleanbans"] = "0000-00-00",
["dayscleanbans"] = "-1",
["lastcleanunbans"] = "0000-00-00",
["dayscleanunbans"] = "-1",
["lastcleanregs"] = "0000-00-00",
["dayscleanregs"] = "-1",
["lastcleaniplog"] = "0000-00-00",
["dayscleaniplog"] = "-1",
["lastcleanstats"] = "0000-00-00",
["dayscleanstats"] = "-1",
["lastcleanchrank"] = "0000-00-00",
["limcleanchrank"] = "-1",
["lastcleanshrank"] = "0000-00-00",
["limcleanshrank"] = "-1",
["lastcleanoprank"] = "0000-00-00",
["limcleanoprank"] = "-1",
["lastcleanwordrank"] = "0000-00-00",
["limcleanwordrank"] = "-1",
["lastcleanusrlog"] = "0000-00-00",
["limcleanusrlog"] = "-1",
["cmdinstalled"] = "1",
["cmdexinstalled"] = "1"

}

---------------------------------------------------------------------
-- hidden settings table <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- private settings table >>
---------------------------------------------------------------------

table_othsets = {

["ver_ledo"] = ver_ledo,
["ledobottag"] = "<Ledokol V:"..ver_ledo..",M:A,H:0/0/1,S:0>",
["ledobotdesc"] = "Hub security",
["timebotdesc"] = "Time bot",
["dns_downl"] = "hundrambit.info",
["ledotmpdir"] = "/tmp/",
["ledotmpfile"] = "ledokol.tmp",
["dif_vhcfg"] = "",
["feednick"] = "-="..string.char (160).."Ledokol"..string.char (160).."=-",
["sendfrom"] = "-="..string.char (160).."Ledokol"..string.char (160).."=-",
["botnick"] = "VerliHub",
["opchatnick"] = "OpChat",
["optrig"] = "!",
["ustrig"] = "+",
["topicowner"] = nil,
["topicvalue"] = nil,
["remseconds"] = 0,
["srvtimer"] = 1,
["timebotseconds"] = 0,
["rolltopicsecs"] = 0,
["rolltopiclen"] = 1,
["uptime"] = os.time (),
["lasttimenick"] = nil,
["ver_lua"] = nil,
["ver_sock"] = nil,
["ver_sql"] = nil,
["locked"] = false

}

---------------------------------------------------------------------
-- private settings table <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- ledokol sql tables >>
---------------------------------------------------------------------

tbl_sql = {

["conf"] = "lua_ledo_conf",
["anti"] = "lua_ledo_anti",
["antiex"] = "lua_ledo_antiex",
["sefi"] = "lua_ledo_sefi",
["sefiex"] = "lua_ledo_sefiex",
["minick"] = "lua_ledo_minick",
["midesc"] = "lua_ledo_midesc",
["mitag"] = "lua_ledo_mitag",
["miconn"] = "lua_ledo_miconn",
["miemail"] = "lua_ledo_miemail",
["mishare"] = "lua_ledo_mishare",
["miip"] = "lua_ledo_miip",
["miex"] = "lua_ledo_miex",
["wm"] = "lua_ledo_wm",
["cust"] = "lua_ledo_cust",
["chat"] = "lua_ledo_chat",
["rem"] = "lua_ledo_rem",
["news"] = "lua_ledo_news",
["mcresp"] = "lua_ledo_mcresp",
["respex"] = "lua_ledo_respex",
["auth"] = "lua_ledo_auth",
["rel"] = "lua_ledo_rel",
["chran"] = "lua_ledo_chran",
["opran"] = "lua_ledo_opran",
["shran"] = "lua_ledo_shran",
["wdran"] = "lua_ledo_wdran",
["ranex"] = "lua_ledo_ranex",
["off"] = "lua_ledo_off",
["mchist"] = "lua_ledo_mchist",
["ophist"] = "lua_ledo_ophist",
["ledocmd"] = "lua_ledo_ledocmd",
["cmd"] = "lua_ledo_cmd",
["cmdex"] = "lua_ledo_cmdex",
["ulog"] = "lua_ledo_ulog"

}

---------------------------------------------------------------------
-- ledokol sql tables <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- ledokol commands table >>
---------------------------------------------------------------------

table_cmnds = {

["antiadd"] = "antiadd",
["antidel"] = "antidel",
["antilist"] = "antilist",
["antiexadd"] = "antiexadd",
["antiexdel"] = "antiexdel",
["antiexlist"] = "antiexlist",
["sefiadd"] = "sefiadd",
["sefidel"] = "sefidel",
["sefilist"] = "sefilist",
["sefiexadd"] = "sefiexadd",
["sefiexdel"] = "sefiexdel",
["sefiexlist"] = "sefiexlist",
["myinfadd"] = "myinfadd",
["myinfdel"] = "myinfdel",
["myinflist"] = "myinflist",
["authadd"] = "authadd",
["authdel"] = "authdel",
["authlist"] = "authlist",
["offlist"] = "offlist",
["offdel"] = "offdel",
["offclean"] = "offclean",
["offmsg"] = "offmsg",
["showtopic"] = "showtopic",
["respadd"] = "respadd",
["respdel"] = "respdel",
["resplist"] = "resplist",
["respexadd"] = "respexadd",
["respexdel"] = "respexdel",
["respexlist"] = "respexlist",
["remadd"] = "remadd",
["remdel"] = "remdel",
["remlist"] = "remlist",
["remshow"] = "remshow",
["newsadd"] = "newsadd",
["newsdel"] = "newsdel",
["hubnews"] = "hubnews",
["reladd"] = "reladd",
["reldel"] = "reldel",
["rellist"] = "rellist",
["relfind"] = "relfind",
["histclean"] = "histclean",
["ophistory"] = "ophistory",
["history"] = "history",
["myhistory"] = "myhistory",
["regname"] = "regname",
["reglist"] = "reglist",
["readlog"] = "readlog",
["cmndset"] = "cmndset",
["cmndreset"] = "cmndreset",
["cmndadd"] = "cmndadd",
["cmnddel"] = "cmnddel",
["cmndlist"] = "cmndlist",
["cmndexadd"] = "cmndexadd",
["cmndexdel"] = "cmndexdel",
["cmndexlist"] = "cmndexlist",
["say"] = "say",
["calculate"] = "calculate",
["mychatrank"] = "mychatrank",
["mysharerank"] = "mysharerank",
["myoprank"] = "myoprank",
["chatranks"] = "chatranks",
["shareranks"] = "shareranks",
["opranks"] = "opranks",
["wordranks"] = "wordranks",
["ranexadd"] = "ranexadd",
["ranexdel"] = "ranexdel",
["ranexlist"] = "ranexlist",
["randel"] = "randel",
["ranclean"] = "ranclean",
["cleanup"] = "cleanup",
["custnick"] = "custnick",
["realnick"] = "realnick",
["custlist"] = "custlist",
["custforce"] = "custforce",
["custdel"] = "custdel",
["chatadd"] = "chatadd",
["chatdel"] = "chatdel",
["chatlist"] = "chatlist",
["wmforce"] = "wmforce",
["wmlist"] = "wmlist",
["wmdel"] = "wmdel",
["wmset"] = "wmset",
["wmshow"] = "wmshow",
["ulog"] = "ulog",
["ledohelp"] = "ledohelp",
["ledostats"] = "ledostats",
["ledover"] = "ledover",
["ledoconf"] = "ledoconf",
["ledoset"] = "ledoset",
["ledouninst"] = "ledokoluninstallisconfirmed",
["ledosql"] = "ledosql",
["ledoshell"] = "ledoshell"

}

---------------------------------------------------------------------
-- ledokol commands table <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- verlihub commands table >>
---------------------------------------------------------------------

table_othcmnds = {

["set"] = "set",
["equals"] = "=",
["kick"] = "kick",
["ban"] = "ban",
["unban"] = "unban",
["me"] = "me",
["report"] = "report",
["topic"] = "topic",
["hubtopic"] = "hubtopic",
["rn"] = "rn",
["rnew"] = "rnew",
["regn"] = "regn",
["regnew"] = "regnew",
["rdel"] = "rdel",
["rdelete"] = "rdelete",
["regdel"] = "regdel",
["regdelete"] = "regdelete",
["rclass"] = "rclass",
["regclass"] = "regclass",
["restart"] = "restart",
["quit"] = "quit"

}

---------------------------------------------------------------------
-- verlihub commands table <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- default language table >>
---------------------------------------------------------------------

table_lang_def = {

[1] = "Current topic: %s",
[2] = "Current topic set by %s: %s",
[3] = "This operation might take very long time depending on how much is going to be removed. Please be patient.",
[4] = "days",
[5] = "%s with class %s deleted %s IP logger plugin entries older than %s days.",
[6] = "%s with class %s deleted %s unbans older than %s days.",
[7] = "%s with class %s deleted %s bans older than %s days.",
[8] = "%s with class %s deleted %s kicks older than %s days.",
[9] = "I'm a bot and therefore don't speak. Would you like to teach me?",
[10] = "Perform script update",
[11] = "Successfully deleted %s main chat history messages.",
[12] = "There are no main chat history messages to remove.",
[13] = "Successfully deleted %s operator chat history messages.",
[14] = "There are no operator chat history messages to remove.",
[15] = "%s with class %s deleted %s main chat history messages.",
[16] = "Couldn't connect to target server. Please try again later.",
[17] = "Last %s main chat messages",
[18] = "Main chat history is empty.",
[19] = "Requested file couldn't be found on target server. Please try again later.",
[20] = "%s is now known as: %s",
[21] = "Last %s operator chat messages",
[22] = "Operator chat history is empty.",
[23] = "Valid priority is a number from %s to %s.",
[24] = "Ledokol version %s has been released. Downloading script file...",
[25] = "You are currently running latest version of Ledokol. No update is required.",
[26] = "Why would you send offline message to yourself?",
[27] = "User %s is online. Sending message directly.",
[28] = "Your offline message was successfully stored for user: %s",
[29] = "%s with IP %s and class %s sent offline message.",
[30] = "priority",
[31] = "Offline",
[32] = "Online",
[33] = "I sent following offline message to you on %s",
[34] = "My current status",
[35] = "%s with IP %s and class %s received offline messages.",
[36] = "Stored offline messages",
[37] = "Offline message list is empty.",
[38] = "Successfully deleted %s offline messages.",
[39] = "Couldn't delete offline messages because not found: %s",
[40] = "%s with class %s deleted all offline messages.",
[41] = "There are no offline messages to remove.",
[42] = "No topic is set.",
[43] = "%s with IP %s and class %s was allowed due forbidden nick exception: %s",
[44] = "message",
[45] = "%s with IP %s and class %s was allowed due forbidden description exception: %s",
[46] = "%s with class %s had bad luck redirecting offline user: %s",
[47] = "%s with IP %s and class %s was allowed due forbidden tag exception: %s",
[48] = "type",
[49] = "%s with IP %s and class %s was allowed due forbidden connection type exception: %s",
[50] = "%s with class %s changed configuration variable %s: %s => %s",
[51] = "%s with IP %s and class %s was allowed due forbidden email exception: %s",
[52] = "%s received own message.",
[53] = "%s with IP %s and class %s was allowed due forbidden share size exception: %s",
[54] = "Successfully deleted %s releases from category: %s",
[55] = "Why would you want to set empty topic?",
[56] = "Couldn't add forbidden nick because already exists: %s",
[57] = "Successfully added forbidden nick: %s",
[58] = "Couldn't add forbidden description because already exists: %s",
[59] = "Successfully added forbidden description: %s",
[60] = "Couldn't add forbidden tag because already exists: %s",
[61] = "Successfully added forbidden tag: %s",
[62] = "Couldn't add forbidden connection type because already exists: %s",
[63] = "Successfully added forbidden connection type: %s",
[64] = "Couldn't add forbidden email because already exists: %s",
[65] = "Successfully added forbidden email: %s",
[66] = "Couldn't add forbidden share size because already exists: %s",
[67] = "Successfully added forbidden share size: %s",
[68] = "Couldn't add MyINFO exception because already exists: %s",
[69] = "Successfully added MyINFO exception: %s",
[70] = "and",
[71] = "Successfully deleted forbidden nick: %s",
[72] = "Couldn't delete forbidden nick because not found: %s",
[73] = "Successfully deleted forbidden description: %s",
[74] = "Couldn't delete forbidden description because not found: %s",
[75] = "Successfully deleted forbidden tag: %s",
[76] = "Couldn't delete forbidden tag because not found: %s",
[77] = "Successfully deleted forbidden connection type: %s",
[78] = "Couldn't delete forbidden connection type because not found: %s",
[79] = "Successfully deleted forbidden email: %s",
[80] = "Couldn't delete forbidden email because not found: %s",
[81] = "Successfully deleted forbidden share size: %s",
[82] = "Couldn't delete forbidden share size because not found: %s",
[83] = "Successfully deleted MyINFO exception: %s",
[84] = "Couldn't delete MyINFO exception because not found: %s",
[85] = "Forbidden nick list",
[86] = "Forbidden nick list is empty.",
[87] = "Forbidden description list",
[88] = "Forbidden description list is empty.",
[89] = "Forbidden tag list",
[90] = "Forbidden tag list is empty.",
[91] = "Forbidden connection type list",
[92] = "Forbidden connection type list is empty.",
[93] = "Forbidden email list",
[94] = "Forbidden email list is empty.",
[95] = "Forbidden share size list",
[96] = "Forbidden share size list is empty.",
[97] = "MyINFO exception list",
[98] = "MyINFO exception list is empty.",
[99] = "Successfully deleted %s rows: %s",
[100] = "Known types are: %s",
[101] = "No rows to remove: %s",
[102] = "date",
[103] = "%s with class %s used following command: %s",
[104] = "%s was permanently banned: <%s> %s",
[105] = "User was successfully deleted from chat rank list: %s",
[106] = "User was not found in chat rank list: %s",
[107] = "User was successfully deleted from operator rank list: %s",
[108] = "User was not found in operator rank list: %s",
[109] = "Number of rows: %s",
[110] = "Your chat rank is: %s",
[111] = "You have to write something in main chat to get started.",
[112] = "Custom nick list is empty.",
[113] = "Total share rank size: %s",
[114] = "Your operator rank is: %s",
[115] = "You have to do some operator actions to get started.",
[116] = "Top %s chat rankers",
[117] = "Chat rank list is empty.",
[118] = "Top %s operator rankers",
[119] = "Operator rank list is empty.",
[120] = "string",
[121] = "No user results found.",
[122] = "Showing %s user log results",
[123] = "Size of user log table: %s [%s: %s @ %s]",
[124] = "Successfully modified antispam entry with %s action and priority number %s to scan in %s: %s",
[125] = "Successfully added antispam entry with %s action and priority number %s to scan in %s: %s",
[126] = "flags",
[127] = "%s was dropped due bad search request.",
[128] = "This command is either disabled or you don't have access to it.",
[129] = "Successfully deleted antispam entry: %s",
[130] = "Couldn't delete antispam entry because not found: %s",
[131] = "Antispam list",
[132] = "Antispam list is empty.",
[133] = "Couldn't add antispam exception entry because already exists: %s",
[134] = "Successfully added antispam exception entry: %s",
[135] = "Successfully deleted antispam exception entry: %s",
[136] = "Couldn't delete antispam exception entry because not found: %s",
[137] = "Antispam exception list",
[138] = "Antispam exception list is empty.",
[139] = "The user you're trying to send offline message to is a bot. Message is discarded.",
[140] = "You can't start at user number %s when you only have %s accounts with class %s.",
[141] = "Showing %s out of total %s accounts with class %s starting at user number %s",
[142] = "There are no accounts with class: %s",
[143] = "Known classes are: %s",
[144] = "%s with class %s sent following say message: <%s> %s",
[145] = "%s with class %s had bad luck sending following say message: <%s> %s",
[146] = "You can't talk from nick whose class is higher or equals your own.",
[147] = "%s with IP %s and class %s was kicked: <%s> %s",
[148] = "%s with class %s deleted %s statistics plugin entries older than %s days.",
[149] = "offset",
[150] = "%s was unbanned: <%s> %s",
[151] = "%s didn't get any search results.",
[152] = "%s with IP %s and class %s was redirected to %s: <%s> %s",
[153] = "%s with IP %s and class %s sent unknown protocol command: %s",
[154] = "Custom nick list",
[155] = "Ledokol operator commands",
[156] = "Add antispam entry",
[157] = "Showing last %s lines out of total %s found in %s file",
[158] = "Delete antispam entry",
[159] = "Add antispam exception entry",
[160] = "Delete antispam exception entry",
[161] = "Add MyINFO entry",
[162] = "Delete MyINFO entry",
[163] = "MyINFO list",
[164] = "List of registered users by class",
[165] = "Speak from other nick",
[166] = "Remove user or word from rank list",
[167] = "%s with class %s deleted %s user log entries older than %s days.",
[168] = "List stored offline messages",
[169] = "Delete offline messages by date",
[170] = "Delete all offline messages",
[171] = "class",
[172] = "Clean up tables",
[173] = "Operator chat history",
[174] = "Delete all history messages",
[175] = "Your operator rank",
[176] = "Script configuration variables",
[177] = "Change configuration variable",
[178] = "nick",
[179] = "This commands help",
[180] = "Ledokol user commands",
[181] = "Current topic",
[182] = "Your chat rank",
[183] = "You're not allowed to send private messages.",
[184] = "Unknown",
[185] = "identifier",
[186] = "Offline message to user",
[187] = "Main chat history",
[188] = "Ledokol statistics",
[189] = "Script version: %s",
[190] = "Total chat rank points: %s",
[191] = "Total operator rank points: %s",
[192] = "Average message count per user: %s",
[193] = "pattern",
[194] = "action",
[195] = "Successfully changed configuration variable %s: %s => %s",
[196] = "Configuration variable %s can only be set to: %s",
[197] = "or",
[198] = "Configuration variable %s must be a number.",
[199] = "to",
[200] = "Unknown configuration variable: %s",
[201] = "MySQL version: %s",
[202] = "Not installed",
[203] = "%s was dropped due spam.",
[204] = "variable",
[205] = "value",
[206] = "LuaSocket version: %s",
[207] = "Lua version: %s",
[208] = "%s was temporary banned for %s: <%s> %s",
[209] = "lines",
[210] = "Couldn't add rank exception because already exists: %s",
[211] = "Successfully added rank exception: %s",
[212] = "Successfully deleted rank exception: %s",
[213] = "Couldn't delete rank exception because not found: %s",
[214] = "Rank exception list",
[215] = "Rank exception list is empty.",
[216] = "Add rank exception",
[217] = "Delete rank exception",
[218] = "In order to use this feature you must turn off registered users list cache. Do it by setting hub configuration varibale use_reglist_cache to 0 and restarting the hub. Please note: Turning cache off is not recommended with large list of registered users.",
[219] = "Both",
[220] = "Successfully deleted search filter: %s",
[221] = "Couldn't delete search filter because not found: %s",
[222] = "Search filter list",
[223] = "Search filter list is empty.",
[224] = "Magnet link: %s",
[225] = "Add search filter",
[226] = "Delete search filter",
[227] = "Known actions are: %s",
[228] = "Known flags are: %s",
[229] = "Downloading version file...",
[230] = "Size of kicks table: %s [%s: %s @ %s]",
[231] = "Size of bans table: %s [%s: %s @ %s]",
[232] = "Size of unbans table: %s [%s: %s @ %s]",
[233] = "Size of IP logger plugin table: %s [%s: %s @ %s]",
[234] = "Size of statistics plugin table: %s [%s: %s @ %s]",
[235] = "Successfully modified authorization entry: %s @ %s",
[236] = "Successfully added authorization entry: %s @ %s",
[237] = "Successfully deleted authorization entry: %s",
[238] = "Couldn't delete authorization entry because not found: %s",
[239] = "Authorization list",
[240] = "Authorization list is empty.",
[241] = "Add authorization entry",
[242] = "Delete authorization entry",
[243] = "ip",
[244] = "%s with IP %s and class %s was successfully authorized.",
[245] = "%s with IP %s and class %s had bad luck during authorization and was therefore disconnected.",
[246] = "Category: %s",
[247] = "Set custom nick for yourself",
[248] = "This nick is registered or in use and therefore can't be used as custom nick: %s",
[249] = "Set your welcome message",
[250] = "Division by zero is forbidden.",
[251] = "Show your welcome messages",
[252] = "Welcome message list",
[253] = "Delete user and his welcome messages",
[254] = "Nick",
[255] = "Login message",
[256] = "Logout message",
[257] = "Welcome message list is empty.",
[258] = "Welcome messages were successfully deleted for user: %s",
[259] = "Couldn't delete user from welcome message list because not found: %s",
[260] = "Your login message was successfully set: %s",
[261] = "%s with class %s changed his login message: %s",
[262] = "Your logout message was successfully set: %s",
[263] = "%s with class %s changed his logout message: %s",
[264] = "You don't have any welcome messages.",
[265] = "Your login message: %s",
[266] = "Add chatroom",
[267] = "Chatroom list",
[268] = "Delete chatroom",
[269] = "description",
[270] = "minclass",
[271] = "maxclass",
[272] = "Successfully modified chatroom: %s",
[273] = "Successfully added chatroom: %s",
[274] = "Successfully deleted chatroom: %s",
[275] = "Couldn't delete chatroom because not found: %s",
[276] = "Chatroom",
[277] = "Description",
[278] = "Chatroom list is empty.",
[279] = "You don't have the rights to access this chatroom.",
[280] = "Custom nick %s is now owned by real user and therefore has been reset for user: %s",
[281] = "%s is registered with class %s.",
[282] = "Query was executed but didn't return any results.",
[283] = "Published: %s",
[284] = "Add search filter exception entry",
[285] = "Delete search filter exception entry",
[286] = "Search filter exception list",
[287] = "Couldn't add search filter exception entry because already exists: %s",
[288] = "Successfully added search filter exception entry: %s",
[289] = "Successfully deleted search filter exception entry: %s",
[290] = "Couldn't delete search filter exception entry because not found: %s",
[291] = "Search filter exception list is empty.",
[292] = "file",
[293] = "Read hub logs",
[294] = "Known files are: %s",
[295] = "Requested file is empty or couldn't be found.",
[296] = "Add command notification exception",
[297] = "Delete command notification exception",
[298] = "Command notification exception list",
[299] = "Successfully added command notification exception entry: %s",
[300] = "Couldn't add command notification exception entry because already exists: %s",
[301] = "Successfully deleted command notification exception entry: %s",
[302] = "Couldn't delete command notification exception entry because not found: %s",
[303] = "Command notification exception list is empty.",
[304] = "Couldn't add chatroom because nick is already in use: %s",
[305] = "Query results",
[306] = "Connections from your IP aren't allowed for another %s seconds.",
[307] = "Executed shell command didn't return anything.",
[308] = "Executed shell command returned following status code: %s",
[309] = "Added by: %s",
[310] = "publisher",
[311] = "Release list is empty.",
[312] = "Last %s releases",
[313] = "No releases by requested publisher were found: %s",
[314] = "Last %s releases published by %s",
[315] = "No releases by requested category were found: %s",
[316] = "Last %s releases by category %s",
[317] = "No releases by requested search string were found: %s",
[318] = "unknown file type",
[319] = "Known search types are: %s",
[320] = "Configuration variable %s can't be empty.",
[321] = "User was successfully deleted from share rank list: %s",
[322] = "User was not found in share rank list: %s",
[323] = "Your share rank",
[324] = "Top %s share rankers",
[325] = "You have to share %s and reconnect to get started.",
[326] = "Share rank list is empty.",
[327] = "Your share rank is: %s",
[328] = "Custom nick can't be longer than %s characters.",
[329] = "Delete custom nick",
[330] = "Successfully deleted user from custom nick list: %s",
[331] = "Couldn't delete user from custom nick list because not found: %s",
[332] = "Selected type requires extra variables. Please refer to manual for more information.",
[333] = "Size of registered users table: %s [%s: %s @ %s]",
[334] = "Successfully deleted %s accounts with class %s",
[335] = "%s with class %s deleted %s accounts with class %s that has been inactive for %s days.",
[336] = "Add command permission",
[337] = "Delete command permission",
[338] = "Command permission list",
[339] = "Successfully modified command permission with class %s: %s",
[340] = "Successfully added command permission with class %s: %s",
[341] = "Successfully deleted command permission: %s",
[342] = "Couldn't delete command permission because not found: %s",
[343] = "Command permission list is empty.",
[344] = "Removing temporary file...",
[345] = "Everything is done. Now please use the commands below to complete the update process.",
[346] = "Copying file...",
[347] = "Please visit %s to download the script manually.",
[348] = "Couldn't add forbidden IP address because already exists: %s",
[349] = "Successfully added forbidden IP address: %s",
[350] = "Successfully deleted forbidden IP address: %s",
[351] = "Couldn't delete forbidden IP address because not found: %s",
[352] = "Forbidden IP address list",
[353] = "Forbidden IP address list is empty.",
[354] = "%s with IP %s and class %s was allowed due forbidden IP address exception: %s",
[355] = "Couldn't delete category because not found: %s",
[356] = "%s was redirected due spam.",
[357] = "%s was redirected due bad search request.",
[358] = "I'm a bot with no ability of peer to peer connection. Stop trying to connect to me.",
[359] = "%s is registered with class %s and has therefore been automatically unregistered and deleted from other tables.",
[360] = "PiB",
[361] = "TiB",
[362] = "GiB",
[363] = "MiB",
[364] = "KiB",
[365] = "B",
[366] = "EiB",
[367] = "Get users real nick",
[368] = "Requested nick wasn't found in custom nick list.",
[369] = "Requested nick belongs to a user who is %s: %s",
[370] = "offline",
[371] = "online",
[372] = "Clean up ranks",
[373] = "limit",
[374] = "%s with class %s deleted %s chat ranks lower than %s.",
[375] = "%s with class %s deleted %s share ranks lower than %s GiB.",
[376] = "%s with class %s deleted %s operator ranks lower than %s.",
[377] = "Size of chat ranks table: %s [%s: %s @ %s]",
[378] = "Size of share ranks table: %s [%s: %s @ %s]",
[379] = "Size of operator ranks table: %s [%s: %s @ %s]",
[380] = "content",
[381] = "destination",
[382] = "interval",
[383] = "Add reminder",
[384] = "Delete reminder",
[385] = "Reminder list",
[386] = "Reminder list is empty.",
[387] = "Known destinanions are: %s",
[388] = "Known interval is: %s",
[389] = "Successfully modified reminder: %s",
[390] = "Successfully added reminder: %s",
[391] = "Successfully deleted reminder: %s",
[392] = "Reminder not found: %s",
[393] = "Identifier",
[394] = "Content",
[395] = "Interval",
[396] = "Send to PM",
[397] = "of",
[398] = "Yes",
[399] = "No",
[400] = "reply",
[401] = "Add chat responder",
[402] = "Delete chat responder",
[403] = "Main chat responder list",
[404] = "Main chat responder list is empty.",
[405] = "%s with class %s deleted %s operator chat history messages.",
[406] = "Search in user log",
[407] = "Successfully added chat responder: %s",
[408] = "Successfully deleted chat responder with ID: %s",
[409] = "Couldn't delete chat responder because ID not found: %s",
[410] = "Responder",
[411] = "Reply",
[412] = "Add chat responder exception",
[413] = "Delete chat responder exception",
[414] = "Chat responder exception list",
[415] = "Chat responder exception list is empty.",
[416] = "Couldn't add chat responder exception because already exists: %s",
[417] = "Successfully added chat responder exception: %s",
[418] = "Successfully deleted chat responder exception: %s",
[419] = "Couldn't delete chat responder exception because not found: %s",
[420] = "command",
[421] = "Change script command",
[422] = "Successfully customized script command: %s => %s",
[423] = "Unknown script command: %s",
[424] = "Requested nick is real.",
[425] = "%s with class %s customized script command: %s => %s",
[426] = "Reset all custom commands",
[427] = "%s custom commands were successfully reset.",
[428] = "Ledokol tables are now deleted and script is locked.",
[429] = "Please unload the script and remove it from scripts directory.",
[430] = "Good luck.",
[431] = "Please unload the script to finish.",
[432] = "%s with IP %s and class %s sent following message to the bot: %s",
[433] = "Script uptime: %s",
[434] = "months",
[435] = "weeks",
[436] = "hours",
[437] = "minutes",
[438] = "seconds",
[439] = "Top %s used words",
[440] = "Word was successfully deleted from word rank list: %s",
[441] = "Word was not found in word rank list: %s",
[442] = "%s with class %s deleted %s word ranks lower than %s.",
[443] = "Size of word ranks table: %s [%s: %s @ %s]",
[444] = "Total word rank points: %s",
[445] = "Word rank list is empty.",
[446] = "%s with class %s registered new user with class %s: %s",
[447] = "%s with class %s deleted registered user with class %s: %s",
[448] = "%s with class %s changed user class from %s to %s: %s",
[449] = "%s with IP %s and class %s was allowed due fake share exception: %s",
[450] = "%s with IP %s and class %s was allowed due clone exception: %s",
[451] = "%s with IP %s and class %s was allowed due same IP exception: %s",
[452] = "text",
[453] = "Add news item",
[454] = "Delete news items",
[455] = "Read hub news",
[456] = "Successfully added news item: %s",
[457] = "Hub news list is empty.",
[458] = "Successfully deleted %s news items.",
[459] = "Couldn't delete news items because not found: %s",
[460] = "Last %s news items",
[461] = "By %s on %s: %s",
[462] = "There are no main chat history messages written by you.",
[463] = "Last %s main chat messages written by you",
[464] = "Your main chat history",
[465] = "Memory usage: %s",
[466] = "The language file doesn't exist or has syntax errors. Resetting to default value.",
[467] = "Force custom nick for user",
[468] = "Following user is not in userlist: %s",
[469] = "Either the feature is disabled or user that you're trying to edit doesn't have access to it.",
[470] = "name",
[471] = "category",
[472] = "tth",
[473] = "Add new release",
[474] = "Delete releases",
[475] = "List of available releases",
[476] = "Find release by name or category",
[477] = "Hub is now going for a very quick restart. Please be patient.",
[478] = "Hub is now going to shut down. Please be patient.",
[479] = "equation",
[480] = "Calculate an equation",
[481] = "Both numbers must be either pi or numbers.",
[482] = "Known operations are: %s",
[483] = "Your logout message: %s",
[484] = "Force welcome message for user",
[485] = "Login message was successfully set for %s: %s",
[486] = "Change nick of an registered user",
[487] = "Following user is not registered: %s",
[488] = "You are now going to be disconnected from the hub in order for your new nick to apply: %s",
[489] = "Successfully renamed account %s: %s",
[490] = "%s with class %s renamed account %s: %s",
[491] = "Your login message was successfully deleted.",
[492] = "Your logout message was successfully deleted.",
[493] = "%s with class %s deleted his login message.",
[494] = "%s with class %s deleted his logout message.",
[495] = "Logout message was successfully set for %s: %s",
[496] = "%s with class %s changed login message for %s: %s",
[497] = "%s with class %s changed logout message for %s: %s",
[498] = "Login message was successfully deleted for user: %s",
[499] = "Logout message was successfully deleted for user: %s",
[500] = "%s with class %s deleted login message for user: %s",
[501] = "%s with class %s deleted logout message for user: %s",
[502] = "%s with class %s deleted welcome messages for user: %s",
[503] = "days",
[504] = "Last %s releases by search string %s",
[505] = "Successfully modified release: %s",
[506] = "Successfully added release: %s",
[507] = "Successfully deleted release: %s",
[508] = "Couldn't delete release because not found: %s",
[509] = "Reminder preview",
[510] = "Preview of %s reminder",
[511] = "Specified nick is already used by another bot.",
[512] = "",
[513] = "",
[514] = "",
[515] = "",
[516] = "",
[517] = "",
[518] = "",
[519] = "",
[520] = "",
[521] = "",
[522] = "",
[523] = "",
[524] = "",
[525] = "",
[526] = "",
[527] = "",
[528] = "",
[529] = "",
[530] = "",
[531] = "",
[532] = "",
[533] = "",
[534] = "",
[535] = "",
[536] = "",
[537] = "",
[538] = "",
[539] = "",
[540] = "Spam exception from %s with IP %s and class %s in MC: %s",
[541] = "Spam exception from %s with IP %s and class %s in PM: %s",
[542] = "Spam exception from %s with IP %s and class %s in offline message: %s",
[543] = "Spam exception from %s with IP %s and class %s in report: %s",
[544] = "Spam notification from %s with IP %s and class %s in MC: %s",
[545] = "Spam notification from %s with IP %s and class %s in PM: %s",
[546] = "Spam notification from %s with IP %s and class %s in offline message: %s",
[547] = "Spam notification from %s with IP %s and class %s in report: %s",
[548] = "Spam from %s with IP %s and class %s in MC: %s",
[549] = "Spam from %s with IP %s and class %s in PM: %s",
[550] = "Spam from %s with IP %s and class %s in offline message: %s",
[551] = "Spam from %s with IP %s and class %s in report: %s",
[552] = "Modified antispam entry with action %s and priority %s to scan in MC: %s",
[553] = "Modified antispam entry with action %s and priority %s to scan in PM: %s",
[554] = "Modified antispam entry with action %s and priority %s to scan in MC and PM: %s",
[555] = "Added antispam entry with action %s and priority %s to scan in MC: %s",
[556] = "Added antispam entry with action %s and priority %s to scan in PM: %s",
[557] = "Added antispam entry with action %s and priority %s to scan in MC and PM: %s",
[558] = "Search request exception from %s with IP %s and class %s as any file: %s",
[559] = "Search request exception from %s with IP %s and class %s as audio file: %s",
[560] = "Search request exception from %s with IP %s and class %s as compressed file: %s",
[561] = "Search request exception from %s with IP %s and class %s as document: %s",
[562] = "Search request exception from %s with IP %s and class %s as executable: %s",
[563] = "Search request exception from %s with IP %s and class %s as picture: %s",
[564] = "Search request exception from %s with IP %s and class %s as video: %s",
[565] = "Search request exception from %s with IP %s and class %s as folder: %s",
[566] = "Search request exception from %s with IP %s and class %s as TTH: %s",
[567] = "Search request notification from %s with IP %s and class %s as any file: %s",
[568] = "Search request notification from %s with IP %s and class %s as audio file: %s",
[569] = "Search request notification from %s with IP %s and class %s as compressed file: %s",
[570] = "Search request notification from %s with IP %s and class %s as document: %s",
[571] = "Search request notification from %s with IP %s and class %s as executable: %s",
[572] = "Search request notification from %s with IP %s and class %s as picture: %s",
[573] = "Search request notification from %s with IP %s and class %s as video: %s",
[574] = "Search request notification from %s with IP %s and class %s as folder: %s",
[575] = "Search request notification from %s with IP %s and class %s as TTH: %s",
[576] = "Bad search request from %s with IP %s and class %s as any file: %s",
[577] = "Bad search request from %s with IP %s and class %s as audio file: %s",
[578] = "Bad search request from %s with IP %s and class %s as compressed file: %s",
[579] = "Bad search request from %s with IP %s and class %s as document: %s",
[580] = "Bad search request from %s with IP %s and class %s as executable: %s",
[581] = "Bad search request from %s with IP %s and class %s as picture: %s",
[582] = "Bad search request from %s with IP %s and class %s as video: %s",
[583] = "Bad search request from %s with IP %s and class %s as folder: %s",
[584] = "Bad search request from %s with IP %s and class %s as TTH: %s",
[585] = "Modified search filter with action %s and priority %s as any file: %s",
[586] = "Modified search filter with action %s and priority %s as audio file: %s",
[587] = "Modified search filter with action %s and priority %s as compressed file: %s",
[588] = "Modified search filter with action %s and priority %s as document: %s",
[589] = "Modified search filter with action %s and priority %s as executable: %s",
[590] = "Modified search filter with action %s and priority %s as picture: %s",
[591] = "Modified search filter with action %s and priority %s as video: %s",
[592] = "Modified search filter with action %s and priority %s as folder: %s",
[593] = "Modified search filter with action %s and priority %s as TTH: %s",
[594] = "Added search filter with action %s and priority %s as any file: %s",
[595] = "Added search filter with action %s and priority %s as audio file: %s",
[596] = "Added search filter with action %s and priority %s as compressed file: %s",
[597] = "Added search filter with action %s and priority %s as document: %s",
[598] = "Added search filter with action %s and priority %s as executable: %s",
[599] = "Added search filter with action %s and priority %s as picture: %s",
[600] = "Added search filter with action %s and priority %s as video: %s",
[601] = "Added search filter with action %s and priority %s as folder: %s",
[602] = "Added search filter with action %s and priority %s as TTH: %s"

}

---------------------------------------------------------------------
-- default language table <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- translit table >>
---------------------------------------------------------------------

tbl_translit = {

{["cyr"] = "", ["lat"] = "a"},
{["cyr"] = "", ["lat"] = "A"},
{["cyr"] = "", ["lat"] = "b"},
{["cyr"] = "", ["lat"] = "B"},
{["cyr"] = "", ["lat"] = "v"},
{["cyr"] = "", ["lat"] = "V"},
{["cyr"] = "", ["lat"] = "g"},
{["cyr"] = "", ["lat"] = "G"},
{["cyr"] = "", ["lat"] = "d"},
{["cyr"] = "", ["lat"] = "D"},
{["cyr"] = "", ["lat"] = "e"},
{["cyr"] = "", ["lat"] = "E"},
{["cyr"] = "", ["lat"] = "e"},
{["cyr"] = "", ["lat"] = "E"},
{["cyr"] = "", ["lat"] = "zh"},
{["cyr"] = "", ["lat"] = "Zh"},
{["cyr"] = "", ["lat"] = "z"},
{["cyr"] = "", ["lat"] = "Z"},
{["cyr"] = "", ["lat"] = "i"},
{["cyr"] = "", ["lat"] = "I"},
{["cyr"] = "", ["lat"] = "y"},
{["cyr"] = "", ["lat"] = "Y"},
{["cyr"] = "", ["lat"] = "k"},
{["cyr"] = "", ["lat"] = "K"},
{["cyr"] = "", ["lat"] = "l"},
{["cyr"] = "", ["lat"] = "L"},
{["cyr"] = "", ["lat"] = "m"},
{["cyr"] = "", ["lat"] = "M"},
{["cyr"] = "", ["lat"] = "n"},
{["cyr"] = "", ["lat"] = "N"},
{["cyr"] = "", ["lat"] = "o"},
{["cyr"] = "", ["lat"] = "O"},
{["cyr"] = "", ["lat"] = "p"},
{["cyr"] = "", ["lat"] = "P"},
{["cyr"] = "", ["lat"] = "r"},
{["cyr"] = "", ["lat"] = "R"},
{["cyr"] = "", ["lat"] = "s"},
{["cyr"] = "", ["lat"] = "S"},
{["cyr"] = "", ["lat"] = "t"},
{["cyr"] = "", ["lat"] = "T"},
{["cyr"] = "", ["lat"] = "u"},
{["cyr"] = "", ["lat"] = "U"},
{["cyr"] = "", ["lat"] = "f"},
{["cyr"] = "", ["lat"] = "F"},
{["cyr"] = "", ["lat"] = "h"},
{["cyr"] = "", ["lat"] = "H"},
{["cyr"] = "", ["lat"] = "ts"},
{["cyr"] = "", ["lat"] = "Ts"},
{["cyr"] = "", ["lat"] = "ch"},
{["cyr"] = "", ["lat"] = "Ch"},
{["cyr"] = "", ["lat"] = "sh"},
{["cyr"] = "", ["lat"] = "Sh"},
{["cyr"] = "", ["lat"] = "sh'"},
{["cyr"] = "", ["lat"] = "Sh'"},
{["cyr"] = "", ["lat"] = "'"},
{["cyr"] = "", ["lat"] = "'"},
{["cyr"] = "", ["lat"] = "y"},
{["cyr"] = "", ["lat"] = "Y"},
{["cyr"] = "", ["lat"] = "'"},
{["cyr"] = "", ["lat"] = "'"},
{["cyr"] = "", ["lat"] = "e"},
{["cyr"] = "", ["lat"] = "E"},
{["cyr"] = "", ["lat"] = "yu"},
{["cyr"] = "", ["lat"] = "Yu"},
{["cyr"] = "", ["lat"] = "ya"},
{["cyr"] = "", ["lat"] = "Ya"}

}

---------------------------------------------------------------------
-- translit table <<
---------------------------------------------------------------------

table_lang = {}
table_resp = {}
table_rcnn = {}
table_faau = {}
table_chig = {}

---------------------------------------------------------------------
-- global storage variables and tables <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- verlihub event functions >>
---------------------------------------------------------------------

function Main ()
table_othsets ["locked"] = loadcomponents ()
if table_othsets ["locked"] == true then return 1 end
renametables ()
createtables ()
altertables ()
createsettings ()
loadsettings ()
loadlangfile (nil)

table_othsets ["optrig"] = getconfig ("cmd_start_op")
table_othsets ["ustrig"] = getconfig ("cmd_start_user")
table_othsets ["botnick"] = getconfig ("hub_security")
table_othsets ["opchatnick"] = getconfig ("opchat_name")
table_othsets ["srvtimer"] = getconfig ("timer_serv_period")

if table_sets ["addledobot"] == 1 then
if getstatus (table_sets ["ledobotnick"]) == 0 then
addhubrobot (table_sets ["ledobotnick"], table_othsets ["ledobotdesc"]..table_othsets ["ledobottag"], getownsize ())
end

if table_sets ["useextrafeed"] == 1 then
table_othsets ["feednick"] = table_sets ["extrafeednick"]
else
table_othsets ["feednick"] = table_sets ["ledobotnick"]
end

table_othsets ["sendfrom"] = table_sets ["ledobotnick"]
else

if table_sets ["useextrafeed"] == 1 then
table_othsets ["feednick"] = table_sets ["extrafeednick"]
else
table_othsets ["feednick"] = table_othsets ["opchatnick"]
end

table_othsets ["sendfrom"] = table_othsets ["botnick"]
end

if table_sets ["chatrunning"] == 1 then
installchatrooms ()
end

if table_sets ["timebotint"] > 0 then
installtimebot ()
end

math.randomseed (os.time ()) -- random is used by few functions

return 1
end

----- ---- --- -- -

function UnLoad ()
if table_othsets ["locked"] == true then return 1 end

if (table_sets ["custnickclass"] < 11) and (table_sets ["savecustnicks"] == 0) then -- only when not saving
resetcustnicks ()
end

if table_sets ["chatrunning"] == 1 then
uninstallchatrooms ()
end

if table_sets ["timebotint"] > 0 then
uninstalltimebot ()
end

if (table_sets ["addledobot"] == 1) and (getstatus (table_sets ["ledobotnick"]) == 1) then
delhubrobot (table_sets ["ledobotnick"])
end

return 1
end

----- ---- --- -- -

function VH_OnNewConn (ip)
if table_othsets ["locked"] == true then return 1 end

return 1
end

----- ---- --- -- -

function VH_OnCloseConn (ip)
if table_othsets ["locked"] == true then return 1 end

return 1
end

----- ---- --- -- -

function VH_OnOperatorCommand (nick, data)
if table_othsets ["locked"] == true then return 1 end
local ucl = getclass (nick)
if ucl < 3 then return 0 end
if checkcmd (nick, ucl, data) == 0 then return 0 end -- command permissions

if string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["kick"].."%s+%S+ .*$") then
if table_sets ["classnotikick"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["chatadd"].." %S+ .* %d+ %d+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addchatroom (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["chatadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["chatdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delchatroom (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["chatdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["chatlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listchatroom (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["remadd"].." %S+ .+ %d+ %d+ %d+ %d+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addreminder (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["remadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["remdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delreminder (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["remdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["remlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listreminder (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["remshow"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
showreminder (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["remshow"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["newsadd"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addnews (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["newsadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["newsdel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delnews (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["newsdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["reladd"].." \".+\" \".+\"$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["reladd"].." \".+\" \".+\" %S+$")) then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addrelease (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["reladd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["reldel"].." %S+ .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delrelease (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["reldel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["respadd"].." \".+\" \".+\" %d+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addresponder (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["respadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["respdel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delresponder (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["respdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["resplist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listresponder (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["respexadd"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addrespex (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["respexadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["respexdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delrespex (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["respexdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["respexlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listrespex (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["antiadd"].." .+ %d %d %d$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addantientry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["antiadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["antidel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delantientry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["antidel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["antilist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listantientry (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["antiexadd"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addexentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["antiexadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["antiexdel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delexentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["antiexdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["antiexlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listexentry (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["sefiadd"].." .+ %d %d %d$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addsefientry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["sefiadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["sefidel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delsefientry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["sefidel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["sefilist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listsefientry (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["sefiexadd"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addsefiexentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["sefiexadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["sefiexdel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delsefiexentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["sefiexdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["sefiexlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listsefiexentry (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndset"].." %S+ %S+$") then
if ucl >= table_sets ["mincommandclass"] then
setledocmd (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cmndset"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndreset"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
resetledocmd (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndadd"].." .+ %d+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addcmdentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cmndadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmnddel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delcmdentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cmnddel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listcmdentry (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndexadd"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addcmdexentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cmndexadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndexdel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delcmdexentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cmndexdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cmndexlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listcmdexentry (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["authadd"].." %S+ %d+%.%d+%.%d+%.%d+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addauthentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["authadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["authdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delauthentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["authdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["authlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listauthentry (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["wmforce"].." %S+ %S+ .+$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["wmforce"].." %S+ %S+$")) then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiwelcome"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

forcewelcome (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["wmforce"]) + 2, -1), ucl)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["wmlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listwelcome (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["myhistory"].." %d+$") then
if (ucl >= table_sets ["minusrcommandclass"]) and (table_sets ["histlimit"] > 0) then
donotifycmd (nick, data, 0, ucl)
sendownhistory (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["myhistory"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["history"].." %d+$") then
if (ucl >= table_sets ["minusrcommandclass"]) and (table_sets ["histlimit"] > 0) then
donotifycmd (nick, data, 0, ucl)
sendmchistory (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["history"]) + 2, -1), 0)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["hubnews"].." %d+$") then
if ucl >= table_sets ["newsclass"] then
donotifycmd (nick, data, 0, ucl)
sendnews (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["hubnews"]) + 2, -1), 0)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["calculate"].." %S+ %S %S+$") then
if ucl >= table_sets ["minusrcommandclass"] then
donotifycmd (nick, data, 0, ucl)
calculate (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["calculate"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["showtopic"].."$") then
if ucl >= table_sets ["minusrcommandclass"] then
donotifycmd (nick, data, 0, ucl)
sendtopic (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["offmsg"].." %S+ .+$") then
if ucl >= table_sets ["offmsgclass"] then
sendoffmsg (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["offmsg"]) + 2, -1), ucl)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["custlist"].."$") then
if table_sets ["custnickclass"] ~= 11 then
donotifycmd (nick, data, 0, ucl)
listcustnick (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["realnick"].." %S+$") then
if table_sets ["custnickclass"] ~= 11 then
donotifycmd (nick, data, 0, ucl)
getrealnick (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["realnick"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["custnick"].."$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["custnick"].." .+$")) then
if ucl >= table_sets ["custnickclass"] then
setcustnick (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["custnick"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["wmshow"].."$") then
if ucl >= table_sets ["welcomeclass"] then
donotifycmd (nick, data, 0, ucl)
showwelcome (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["wmset"].." %S+ .+$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["wmset"].." %S+$")) then
if ucl >= table_sets ["welcomeclass"] then
if table_sets ["classnotiwelcome"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

setwelcome (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["wmset"]) + 2, -1), ucl)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["relfind"].." .+$") then
if ucl >= table_sets ["releaseclass"] then
donotifycmd (nick, data, 0, ucl)
findrelease (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["relfind"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["rellist"].." %S+ %d+$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["rellist"].." %S+ %d+ .+$")) then
if ucl >= table_sets ["releaseclass"] then
donotifycmd (nick, data, 0, ucl)
listrelease (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["rellist"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["wordranks"].."$") then
if ucl >= table_sets ["wordrankclass"] then
donotifycmd (nick, data, 0, ucl)
wordranksendall (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["opranks"].."$") then
if ucl >= table_sets ["oprankclass"] then
donotifycmd (nick, data, 0, ucl)
opranksendall (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["shareranks"].."$") then
if ucl >= table_sets ["sharerankclass"] then
donotifycmd (nick, data, 0, ucl)
shareranksendall (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["chatranks"].."$") then
if ucl >= table_sets ["chatrankclass"] then
donotifycmd (nick, data, 0, ucl)
chatranksendall (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["mysharerank"].."$") then
if ucl >= table_sets ["sharerankclass"] then
donotifycmd (nick, data, 0, ucl)
shareranksendown (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["mychatrank"].."$") then
if ucl >= table_sets ["chatrankclass"] then
donotifycmd (nick, data, 0, ucl)
chatranksendown (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ulog"].." %S+ .+ %d+$") then
if (ucl >= table_sets ["mincommandclass"]) and (table_sets ["enableuserlog"] == 1) then
donotifycmd (nick, data, 0, ucl)
showuserlog (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ulog"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["wmdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiwelcome"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

delwelcome (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["wmdel"]) + 2, -1), ucl)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["regname"].." %S+ %S+$") then
if ucl >= table_sets ["mincommandclass"] then
if getconfig ("use_reglist_cache") == 1 then -- reglist cache is on
commandanswer (nick, getlang (218))
else

if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

namereg (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["regname"]) + 2, -1), ucl)
end

else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["reglist"].." %d+ %d+x%d+$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["reglist"].." %-%d %d+x%d+$")) then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
sendreglist (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["reglist"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["readlog"].." %S+ %d+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
logsread (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["readlog"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["randel"].." %S+ %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delrank (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["randel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ranexadd"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addrankex (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ranexadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ranexdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delrankex (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ranexdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ranexlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listrankex (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ranclean"].." %S+ %d+$") then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiledoact"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

cleanupranks (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ranclean"]) + 2, -1), ucl)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["myoprank"].."$") then
if ucl >= table_sets ["oprankclass"] then
donotifycmd (nick, data, 0, ucl)
opranksendown (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["say"].." %S* .*$") then
if ucl >= table_sets ["sayclass"] then
if table_sets ["classnotisay"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

sendsay (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["say"]) + 2, -1), ucl)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledohelp"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
sendhelp (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledostats"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
sendstats (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledover"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
updatescript (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledouninst"].."$") then

-- dont use it unless you know what it does, you can fuck up all ledokol tables in one step
-- this action completely deletes all ledokol tables and files, and locks the script

if ucl >= 10 then
table_othsets ["locked"] = true -- lock the script
donotifycmd (nick, data, 10, ucl)

if table_sets ["chatrunning"] == 1 then
uninstallchatrooms ()
end

if table_sets ["timebotint"] > 0 then
uninstalltimebot ()
end

if (table_sets ["addledobot"] == 1) and (getstatus (table_sets ["ledobotnick"]) == 1) then
delhubrobot (table_sets ["ledobotnick"])
end

droptables () -- drop all tables
local lfile = io.open (table_othsets ["dif_vhcfg"].."scripts/ledokol.lua", "r") -- try to open script file

if lfile then
lfile:close ()
os.remove (table_othsets ["dif_vhcfg"].."scripts/ledokol.lua") -- delete script file
-- delete language files too
commandanswer (nick, getlang (428).." "..getlang (431).."\n\n"..getlang (430)) -- tell bye
else
commandanswer (nick, getlang (428).." "..getlang (429).."\n\n"..getlang (430)) -- tell bye
end

else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledoset"].." %S+ .*$") then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnoticonfig"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

setledoconf (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ledoset"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledoconf"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
showledoconf (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledosql"].." .+$") then

-- dont use it unless you know what it does, you can f*ck up your hub database in one step
-- executes any text written after the command and first space as mysql query
-- single quote and backslash characters in your query values must be escaped (not mysql syntax itself)

if ucl >= 10 then
donotifycmd (nick, data, 10, ucl)
local _, rows = VH:SQLQuery (repnmdcinchars (string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ledosql"]) + 2, -1)))

if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)
anentry = anentry.." "..repnmdcoutchars (entry or "NULL").."\n"
end

commandanswer (nick, getlang (305)..":\n\n"..anentry)
commandanswer (nick, string.format (getlang (109), rows))
else
commandanswer (nick, getlang (282))
end

else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ledoshell"].." .+$") then

-- dont use it unless you know what it does, you can f*ck up your operating system in one step
-- executes any text written after the command and first space as system shell command

if ucl >= 10 then
donotifycmd (nick, data, 10, ucl)
local res = os.execute (repnmdcinchars (string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ledoshell"]) + 2, -1)))

if res then
commandanswer (nick, string.format (getlang (308), repnmdcoutchars (res)))
else
commandanswer (nick, getlang (307))
end

else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cleanup"].." %S+ %d+$") then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiledoact"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

cleanuptable (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cleanup"]) + 2, -1), ucl)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cleanup"].." %S+ %d+ %d+$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["cleanup"].." %S+ %d+ %-%d$")) then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiledoact"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

altcleanuptable (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["cleanup"]) + 2, -1), ucl)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["myinfadd"].." %S+ .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
addmyinfoentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["myinfadd"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["myinfdel"].." %S+ .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
delmyinfoentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["myinfdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["myinflist"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listmyinfoentry (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["myinflist"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["custdel"].." %S+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
opdelcustnick (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["custdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["custforce"].." %S+ .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
opforcecustnick (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["custforce"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["offlist"].."$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
listoffline (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["offdel"].." .+$") then
if ucl >= table_sets ["mincommandclass"] then
donotifycmd (nick, data, 0, ucl)
deloffline (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["offdel"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["offclean"].."$") then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiledoact"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

cleanoffline (nick, ucl)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["histclean"].."$") then
if ucl >= table_sets ["mincommandclass"] then
if table_sets ["classnotiledoact"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

cleanhistory (nick, 0, 0, ucl)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_cmnds ["ophistory"].." %d+$") then
if (ucl >= 3) and (table_sets ["histlimit"] > 0) then
donotifycmd (nick, data, 0, ucl)
sendophistory (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_cmnds ["ophistory"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["topic"].."$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["topic"].." .+$")) then
savetopic (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["topic"]) + 2, -1), ucl)

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["hubtopic"].."$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["hubtopic"].." .+$")) then
savetopic (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["hubtopic"]) + 2, -1), ucl)

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["topic"].." $")) or (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["hubtopic"].." $")) then
commandanswer (nick, getlang (55))

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["rn"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregnew (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["rn"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["rnew"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregnew (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["rnew"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["regnew"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregnew (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["regnew"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["regn"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregnew (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["regn"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["rdel"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregdel (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["rdel"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["rdelete"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregdel (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["rdelete"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["regdel"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregdel (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["regdel"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["regdelete"].."%s+%S+.*$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregdel (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["regdelete"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["rclass"].."%s+%S+%s+.+$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregclass (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["rclass"]) + 2, -1))

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["regclass"].."%s+%S+%s+.+$") then
if table_sets ["classnotireg"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyregclass (nick, ucl, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["regclass"]) + 2, -1))

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["ban"].."%S*%s+%S+$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["ban"].."%S*%s+%S+ .*$")) then
if table_sets ["classnotiban"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyban (nick, ucl, data)

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["unban"].."%S*%s+%S+ .*$") then
if table_sets ["classnotiban"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyunban (nick, ucl, data)

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["set"].."%s+%S+ .*$") then
if ucl >= 5 then
sethubconf (string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["set"]) + 2, -1))

if table_sets ["classnoticonfig"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyconfig (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["set"]) + 2, -1), ucl)
end

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["equals"].."%s+%S+ .*$") then
if ucl >= 5 then
sethubconf (string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["equals"]) + 2, -1))

if table_sets ["classnoticonfig"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

donotifyconfig (nick, string.sub (data, string.len (table_othsets ["optrig"]..table_othcmnds ["equals"]) + 2, -1), ucl)
end

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["restart"].."$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["restart"].." .*$")) then
if ucl >= 10 then
maintoall (getlang (477), 0, 10)
donotifycmd (nick, data, 0, ucl)
end

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["quit"].."$")) or (string.find (data, "^"..table_othsets ["optrig"]..table_othcmnds ["quit"].." .*$")) then
if ucl >= 10 then
maintoall (getlang (478), 0, 10)
donotifycmd (nick, data, 0, ucl)
end

----- ---- --- -- -

else -- unknown command
donotifycmd (nick, data, 0, ucl)
end

return 1
end

----- ---- --- -- -

function VH_OnUserCommand (nick, data)
if table_othsets ["locked"] == true then return 1 end
local ucl = getclass (nick)
if ucl < 0 then return 0 end
if getconfig ("disable_usr_cmds") ~= 0 then return 1 end
if checkcmd (nick, ucl, data) == 0 then return 0 end -- command permissions

-- process +me command begin

if string.find (data, "^"..table_othsets ["ustrig"]..table_othcmnds ["me"].." .*$") then -- scan for spam
if getconfig ("disable_me_cmd") ~= 0 then return 1 end
if antiscan (nick, ucl, string.sub (data, string.len (table_othsets ["ustrig"]..table_othcmnds ["me"]) + 2, -1), 1, nil, nil) == 0 then return 0 end
local retval = 1
local fakenick = nick
local realnick = nick

if table_sets ["funrandomchat"] == 1 then
fakenick = getrandomnick (nick)
realnick = fakenick

if getclass (fakenick) >= table_sets ["custnickclass"] then
fakenick = getcustnick (fakenick) or fakenick -- use custom nick here too
end

VH:SendDataToAll ("** "..fakenick.." "..string.sub (data, string.len (table_othsets ["ustrig"]..table_othcmnds ["me"]) + 2, -1).."|", 0, 10)
retval = 0 -- dont return original message when fake is sent
else

if ucl >= table_sets ["custnickclass"] then
fakenick = getcustnick (nick)

if fakenick == nil then -- nick is not in custom nick list
fakenick = nick
else
VH:SendDataToAll ("** "..fakenick.." "..string.sub (data, string.len (table_othsets ["ustrig"]..table_othcmnds ["me"]) + 2, -1).."|", 0, 10)
retval = 0 -- dont return original message when fake is sent
end
end
end

addmchistoryline (fakenick, realnick, data)
chatrankaccept (nick, ucl)
wordrankaccept (nick, ucl, string.sub (data, string.len (table_othsets ["ustrig"]..table_othcmnds ["me"]) + 2, -1))

return retval

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_othcmnds ["me"].."$") then
if getconfig ("disable_me_cmd") ~= 0 then return 1 end
local retval = 1
local fakenick = nick
local realnick = nick

if table_sets ["funrandomchat"] == 1 then
fakenick = getrandomnick (nick)
realnick = fakenick

if getclass (fakenick) >= table_sets ["custnickclass"] then
fakenick = getcustnick (fakenick) or fakenick -- use custom nick here too
end

VH:SendDataToAll ("** "..fakenick.."|", 0, 10)
retval = 0 -- dont return original message when fake is sent
else

if ucl >= table_sets ["custnickclass"] then
fakenick = getcustnick (nick)

if fakenick == nil then -- nick is not in custom nick list
fakenick = nick
else
VH:SendDataToAll ("** "..fakenick.."|", 0, 10)
retval = 0 -- dont return original message when fake is sent
end
end
end

addmchistoryline (fakenick, realnick, data)
chatrankaccept (nick, ucl)

return retval
end

-- process +me command end

if string.find (data, "^"..table_othsets ["ustrig"]..table_othcmnds ["report"].." .+$") then -- scan for spam
local cfg = getconfig ("disable_report_cmd") -- available since 0.9.8e
if cfg and (cfg ~= 0) then return 1 end

return antiscan (nick, ucl, string.sub (data, string.len (table_othsets ["ustrig"]..table_othcmnds ["report"]) + 2, -1), 4, nil, nil)

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["showtopic"].."$") then
if ucl >= table_sets ["minusrcommandclass"] then
donotifycmd (nick, data, 0, ucl)
sendtopic (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["mychatrank"].."$") then
if ucl >= table_sets ["chatrankclass"] then
donotifycmd (nick, data, 0, ucl)
chatranksendown (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["mysharerank"].."$") then
if ucl >= table_sets ["sharerankclass"] then
donotifycmd (nick, data, 0, ucl)
shareranksendown (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["chatranks"].."$") then
if ucl >= table_sets ["chatrankclass"] then
donotifycmd (nick, data, 0, ucl)
chatranksendall (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["shareranks"].."$") then
if ucl >= table_sets ["sharerankclass"] then
donotifycmd (nick, data, 0, ucl)
shareranksendall (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["opranks"].."$") then
if ucl >= table_sets ["oprankclass"] then
donotifycmd (nick, data, 0, ucl)
opranksendall (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["wordranks"].."$") then
if ucl >= table_sets ["wordrankclass"] then
donotifycmd (nick, data, 0, ucl)
wordranksendall (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["offmsg"].." %S+ .+$") then
if ucl >= table_sets ["offmsgclass"] then
sendoffmsg (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["offmsg"]) + 2, -1), ucl)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["hubnews"].." %d+$") then
if ucl >= table_sets ["newsclass"] then
donotifycmd (nick, data, 0, ucl)
sendnews (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["hubnews"]) + 2, -1), 0)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["calculate"].." %S+ %S %S+$") then
if ucl >= table_sets ["minusrcommandclass"] then
donotifycmd (nick, data, 0, ucl)
calculate (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["calculate"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["rellist"].." %S+ %d+$")) or (string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["rellist"].." %S+ %d+ .+$")) then
if ucl >= table_sets ["releaseclass"] then
donotifycmd (nick, data, 0, ucl)
listrelease (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["rellist"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["relfind"].." .+$") then
if ucl >= table_sets ["releaseclass"] then
donotifycmd (nick, data, 0, ucl)
findrelease (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["relfind"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["history"].." %d+$") then
if (ucl >= table_sets ["minusrcommandclass"]) and (table_sets ["histlimit"] > 0) then
donotifycmd (nick, data, 0, ucl)
sendmchistory (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["history"]) + 2, -1), 0)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["myhistory"].." %d+$") then
if (ucl >= table_sets ["minusrcommandclass"]) and (table_sets ["histlimit"] > 0) then
donotifycmd (nick, data, 0, ucl)
sendownhistory (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["myhistory"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["custnick"].."$")) or (string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["custnick"].." .+$")) then
if ucl >= table_sets ["custnickclass"] then
setcustnick (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["custnick"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["realnick"].." %S+$") then
if table_sets ["custnickclass"] ~= 11 then
donotifycmd (nick, data, 0, ucl)
getrealnick (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["realnick"]) + 2, -1))
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["custlist"].."$") then
if table_sets ["custnickclass"] ~= 11 then
donotifycmd (nick, data, 0, ucl)
listcustnick (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif (string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["wmset"].." %S+ .+$")) or (string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["wmset"].." %S+$")) then
if ucl >= table_sets ["welcomeclass"] then
if table_sets ["classnotiwelcome"] == 11 then
donotifycmd (nick, data, 0, ucl)
end

setwelcome (nick, string.sub (data, string.len (table_othsets ["ustrig"]..table_cmnds ["wmset"]) + 2, -1), ucl)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

elseif string.find (data, "^"..table_othsets ["ustrig"]..table_cmnds ["wmshow"].."$") then
if ucl >= table_sets ["welcomeclass"] then
donotifycmd (nick, data, 0, ucl)
showwelcome (nick)
else
commandanswer (nick, getlang (128))
end

return 0

----- ---- --- -- -

else -- unknown command
donotifycmd (nick, data, 0, ucl)
end

return 1
end

----- ---- --- -- -

function VH_OnParsedMsgMyINFO (nick, data)
if table_othsets ["locked"] == true then return 1 end
if (table_sets ["micheck"] == 0) and ((table_sets ["enableuserlog"] == 0) or (table_sets ["logallmyinfos"] == 0)) then return 1 end
local desc, tag, conn, email, size = parsemyinfo (data)
local ip = getip (nick)

if (table_sets ["enableuserlog"] == 1) and (table_sets ["logallmyinfos"] == 1) then -- user logger
local _, rows = VH:SQLQuery ("select `id` from `"..tbl_sql ["ulog"].."` where `nick` = '"..repsqlchars (nick).."' and `ip` = '"..repsqlchars (ip).."' and `desc` = '"..repsqlchars (desc).."' and `tag` = '"..repsqlchars (tag).."' and `conn` = '"..repsqlchars (conn).."' and `email` = '"..repsqlchars (email).."' and `share` = '"..repsqlchars (size).."' limit 1")

if rows == 0 then -- dont duplicate
VH:SQLQuery ("insert into `"..tbl_sql ["ulog"].."` (`time`, `nick`, `ip`, `desc`, `tag`, `conn`, `email`, `share`) values ('"..(os.time () + table_sets ["srvtimediff"]).."', '"..repsqlchars (nick).."', '"..repsqlchars (ip).."', '"..repsqlchars (desc).."', '"..repsqlchars (tag).."', '"..repsqlchars (conn).."', '"..repsqlchars (email).."', '"..repsqlchars (size).."')")
end
end

if (table_sets ["micheck"] == 0) or (table_sets ["micallall"] == 0) then return 1 end
local cls = getclass (nick)
if (cls < 0) or (cls >= table_sets ["scanbelowclass"]) then return 1 end -- dont check pingers
if checkdesc (nick, desc, cls, ip) == 1 then return 0 end
if checktag (nick, tag, cls, ip) == 1 then return 0 end
if checkconn (nick, conn, cls, ip) == 1 then return 0 end
if checkemail (nick, email, cls, ip) == 1 then return 0 end
if checkshare (nick, size, cls, ip) == 1 then return 0 end
if checkfake (nick, size, cls, ip) == 1 then return 0 end
if checkclone (nick, size, ip, cls) == 1 then return 0 end

return 1
end

----- ---- --- -- -

function VH_OnUserLogin (nick)
if table_othsets ["locked"] == true then return 1 end
local ip = getip (nick)
local desc, tag, conn, email, size = parsemyinfo (getmyinfo (nick))

if table_sets ["enableuserlog"] == 1 then -- user logger
local _, rows = VH:SQLQuery ("select `id` from `"..tbl_sql ["ulog"].."` where `nick` = '"..repsqlchars (nick).."' and `ip` = '[unknown]' and `desc` = '"..repsqlchars (desc).."' and `tag` = '"..repsqlchars (tag).."' and `conn` = '"..repsqlchars (conn).."' and `email` = '"..repsqlchars (email).."' and `share` = '"..repsqlchars (size).."'")

if rows > 0 then -- try to update ip instead of adding extra rows
local t = {}

for x = 0, rows - 1 do
local _, id = VH:SQLFetch (x)
table.insert (t, id)
end

for _, v in pairs (t) do
VH:SQLQuery ("update `"..tbl_sql ["ulog"].."` set `time` = '"..(os.time () + table_sets ["srvtimediff"]).."', `ip` = '"..repsqlchars (ip).."' where `id` = '"..v.."' limit 1")
end

else
VH:SQLQuery ("insert into `"..tbl_sql ["ulog"].."` (`time`, `nick`, `ip`, `desc`, `tag`, `conn`, `email`, `share`) values ('"..(os.time () + table_sets ["srvtimediff"]).."', '"..repsqlchars (nick).."', '"..repsqlchars (ip).."', '"..repsqlchars (desc).."', '"..repsqlchars (tag).."', '"..repsqlchars (conn).."', '"..repsqlchars (email).."', '"..repsqlchars (size).."')")
end
end

local cls = getclass (nick)
if cls < 0 then return 1 end -- dont check pingers

if (table_sets ["ipconantiflint"] > 0) and (cls < table_sets ["scanbelowclass"]) then -- ip connect antiflood
if table_rcnn [ip] then
local dif = os.difftime (os.time (), table_rcnn [ip])

if dif >= table_sets ["ipconantiflint"] then
table_rcnn [ip] = nil -- delete
else
maintouser (nick, string.format (getlang (306), table_sets ["ipconantiflint"] - dif))
VH:CloseConnection (nick) -- drop user

return 0 -- dont allow
end

else -- add
table_rcnn [ip] = os.time ()
end
end

if authcheck (nick, cls, ip) == 1 then -- continue only if user is still online after authorization
if cls >= table_sets ["welcomeclass"] then -- dont send logout message
table_faau [nick] = 1
end

return 0
end

if (table_sets ["micheck"] == 1) and (cls < table_sets ["scanbelowclass"]) then
if checknick (nick, cls, ip) == 1 then return 0 end
if checkdesc (nick, desc, cls, ip) == 1 then return 0 end
if checktag (nick, tag, cls, ip) == 1 then return 0 end
if checkconn (nick, conn, cls, ip) == 1 then return 0 end
if checkemail (nick, email, cls, ip) == 1 then return 0 end
if checkshare (nick, size, cls, ip) == 1 then return 0 end
if checkip (nick, ip, cls) == 1 then return 0 end
if checkfake (nick, size, cls, ip) == 1 then return 0 end
if checkclone (nick, size, ip, cls) == 1 then return 0 end
if checksameip (nick, ip, cls) == 1 then return 0 end
end

sharerankaccept (nick, size, cls)
local custom = findcustnick (nick)

if custom ~= nil then
delcustnick (custom)
maintoall (string.format (getlang (280), nick, custom), 0, 10)
end

if (cls >= table_sets ["newsclass"]) and (table_sets ["newsautolines"] > 0) then
sendnews (nick, table_sets ["newsautolines"], 1)
end

if (table_sets ["histlimit"] > 0) and (table_sets ["histautolines"] > 0) then
sendmchistory (nick, table_sets ["histautolines"], 1)
end

sendwelcomein (nick, cls)
autosendoffmsg (nick, cls, ip)

return 1
end

----- ---- --- -- -

function VH_OnUserLogout (nick)
if table_othsets ["locked"] == true then return 1 end
local cls = getclass (nick)

if table_faau [nick] then
sendwelcomeout (nick, cls)
table_faau [nick] = nil -- delete
end

if (cls >= table_sets ["custnickclass"]) and (table_sets ["savecustnicks"] == 0) then -- only if not saving
delcustnick (nick)
end

if (table_sets ["ipconantiflint"] > 0) and (cls < table_sets ["scanbelowclass"]) then -- ip connect antiflood
local ip = getip (nick)

if (not table_rcnn [ip]) or (os.difftime (os.time (), table_rcnn [ip]) >= table_sets ["ipconantiflint"]) then
table_rcnn [ip] = os.time () -- set delay
end
end

return 1
end

----- ---- --- -- -

function VH_OnParsedMsgSearch (nick, data)
if table_othsets ["locked"] == true then return 1 end

return sefiscan (nick, data)
end

----- ---- --- -- -

function VH_OnParsedMsgSR (nick, data)
if table_othsets ["locked"] == true then return 1 end

return 1
end

----- ---- --- -- -

function VH_OnParsedMsgValidateNick (data)
if table_othsets ["locked"] == true then return 1 end
-- move ip autorization here when callback is fixed

return 1
end

----- ---- --- -- -

function VH_OnNewReg (nick, class)
if table_othsets ["locked"] == true then return 1 end
-- use registration notification from here in future

return 1
end

----- ---- --- -- -

function VH_OnDelReg (nick, class)
if table_othsets ["locked"] == true then return 1 end
-- use registration notification from here in future

return 1
end

----- ---- --- -- -

function VH_OnUpdateClass (nick, oldclass, newclass)
if table_othsets ["locked"] == true then return 1 end
-- use registration notification from here in future

return 1
end

----- ---- --- -- -

function VH_OnNewBan (op, ip, nick, reason)
if table_othsets ["locked"] == true then return 1 end
-- use ban notification from here in future

return 1
end

----- ---- --- -- -

function VH_OnUnBan (op, ip, nick, reason)
if table_othsets ["locked"] == true then return 1 end
-- use unban notification from here in future

return 1
end

----- ---- --- -- -

function VH_OnHubName (nick, name)
if table_othsets ["locked"] == true then return 1 end
-- use this for rolling topic in future

return 1
end

----- ---- --- -- -

function VH_OnTimer ()
if table_othsets ["locked"] == true then return 1 end
local st = os.time () -- current system time

if table_sets ["remrunning"] == 1 then
if os.difftime (st, table_othsets ["remseconds"]) >= 60 then
table_othsets ["remseconds"] = st
sendreminder ()
end
end

if table_sets ["timebotint"] > 0 then
if os.difftime (st, table_othsets ["timebotseconds"]) >= table_sets ["timebotint"] then
installtimebot ()
end
end

if (table_sets ["rolltopicint"] > 0) and table_othsets ["topicvalue"] then -- only if set
if os.difftime (st, table_othsets ["rolltopicsecs"]) >= table_sets ["rolltopicint"] then
rolltopic ()
end
end

if table_sets ["resprunning"] == 1 then
for k, v in pairs (table_resp) do
for t, s in pairs (v) do
if os.difftime (st, t) >= table_sets ["respdelay"] then
maintoall (s, 0, 10) -- finally send the responder message
table_resp [k] = nil -- free up queue
break
end
end
end
end

return 1
end

----- ---- --- -- -

function VH_OnUnknownMsg (nick, data)
if table_othsets ["locked"] == true then return 1 end
local retval = 1

if string.len (data) < 1 then
-- empty protocol message? :)

elseif string.find (data, "^%$UserIP .+$") then
-- skip since its not implemented in verlihub yet

else
local ucl = getclass (nick)
opsnotify (table_sets ["classnotiunk"], string.format (getlang (153), nick, getip (nick), ucl, repnmdcoutchars (data)))

if (table_sets ["kickunkusers"] == 1) and (ucl < table_sets ["scanbelowclass"]) then -- kick only unprotected users
local rsn = string.gsub (table_sets ["unkkickreason"], "%*", reprexpchars (repnmdcoutchars (data)))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["unktbantime"])
retval = 0
end
end

return retval
end

----- ---- --- -- -

function VH_OnParsedMsgAny (nick, data)
if table_othsets ["locked"] == true then return 1 end

-- command notifications begin

if string.find (data, "^<"..nick.."> "..table_othsets ["optrig"].."lua.+$") then
local ucl = getclass (nick)
if ucl >= 3 then donotifycmd (nick, string.sub (data, string.len ("<"..nick.."> ") + 1, -1), 0, ucl) end
end

-- command notifications end

if string.find (data, "^%$OpForceMove %$Who:.+%$Where:.+%$Msg:.+$") then
local cls = getclass (nick)
if cls >= getconfig ("min_class_redir") then donotifyredir (nick, cls, string.sub (data, 14, -1)) end
end

return 1
end

----- ---- --- -- -

function VH_OnParsedMsgConnectToMe (nick, othernick)
if table_othsets ["locked"] == true then return 1 end

if (table_sets ["addledobot"] == 1) and (othernick == table_sets ["ledobotnick"]) then
maintouser (nick, getlang (358))

return 0
end

return 1
end

----- ---- --- -- -

function VH_OnParsedMsgRevConnectToMe (nick, othernick)
if table_othsets ["locked"] == true then return 1 end

if (table_sets ["addledobot"] == 1) and (othernick == table_sets ["ledobotnick"]) then
maintouser (nick, getlang (358))

return 0
end

return 1
end

----- ---- --- -- -

function VH_OnOperatorKicks (op, nick, data)
if table_othsets ["locked"] == true then return 1 end
local ucl = getclass (nick)
opsnotify (table_sets ["classnotikick"], string.format (getlang (147), nick, getip (nick), ucl, op, data))
oprankaccept (op, getclass (op))

if (ucl > 0) and (ucl < table_sets ["scanbelowclass"]) then
if table_sets ["regkickaction"] == 1 then
local rucl = getregclass (nick)

if rucl ~= nil then -- check if physically registered
opsnotify (table_sets ["classnotikick"], string.format (getlang (281), nick, rucl))
end

elseif table_sets ["regkickaction"] == 2 then
rucl = getregclass (nick)

if rucl ~= nil then -- only if registered
delledouser (nick)
VH:SQLQuery ("delete from `reglist` where `nick` = '"..repsqlchars (nick).."' limit 1")
opsnotify (table_sets ["classnotikick"], string.format (getlang (359), nick, rucl))
end
end
end

return 1
end

----- ---- --- -- -

function VH_OnOperatorDrops (op, nick)
if table_othsets ["locked"] == true then return 1 end
oprankaccept (op, getclass (op))

return 1
end

----- ---- --- -- -

function VH_OnParsedMsgPM (from, data, to)
if table_othsets ["locked"] == true then return 1 end
local fcls = getclass (from)

if fcls < table_sets ["pmminclass"] then -- not allowed
pmtouser (from, to, getlang (183))

return 0
end

local retval = 1

if to == table_othsets ["opchatnick"] then

if fcls >= 3 then
addophistoryline (from, data) -- log only when operator writing
else
opsnotify (table_sets ["classnotibotpm"], string.format (getlang (432), from, getip (from), fcls, data))
end

elseif to == table_othsets ["botnick"] then

if string.sub (data, 1, 1) == table_othsets ["ustrig"] then
-- skip
elseif string.sub (data, 1, 1) == table_othsets ["optrig"] then
if fcls < 3 then
opsnotify (table_sets ["classnotibotpm"], string.format (getlang (432), from, getip (from), fcls, data))
end

else
opsnotify (table_sets ["classnotibotpm"], string.format (getlang (432), from, getip (from), fcls, data))
end

elseif to == table_sets ["ledobotnick"] then

if table_sets ["addledobot"] == 1 then
if fcls == 10 then
if string.sub (data, 1, 1) == table_othsets ["optrig"] then -- acceps operator command
VH_OnOperatorCommand (from, data)
else
broadcastchatroom (table_sets ["ledobotnick"], 10, 10, from, data)
end

elseif fcls >= 3 then
if string.sub (data, 1, 1) == table_othsets ["optrig"] then -- acceps operator command
VH_OnOperatorCommand (from, data)
end

else
opsnotify (table_sets ["classnotibotpm"], string.format (getlang (432), from, getip (from), fcls, data))
VH:SendDataToUser ("$To: "..from.." From: "..table_sets ["ledobotnick"].." $<"..table_sets ["ledobotnick"].."> "..getlang (9).."|", from)
end
end

elseif to == table_othsets ["lasttimenick"] then

if table_sets ["timebotint"] ~= 0 then
opsnotify (table_sets ["classnotibotpm"], string.format (getlang (432), from, getip (from), fcls, data))
VH:SendDataToUser ("$To: "..from.." From: "..table_othsets ["lasttimenick"].." $<"..table_sets ["ledobotnick"].."> "..getlang (9).."|", from)
end

else
if checkchatroom (to, from, data, fcls) == 1 then return 0 end
retval = antiscan (from, fcls, data, 2, to, nil)
end

return retval
end

----- ---- --- -- -

function VH_OnParsedMsgChat (nick, data)
if table_othsets ["locked"] == true then return 1 end
local ucl = getclass (nick)
if ucl < getconfig ("mainchat_class") then return 1 end
if antiscan (nick, ucl, data, 1, nil, nil) == 0 then return 0 end
local fakenick = nick
local realnick = nick

if table_sets ["funrandomchat"] == 1 then
fakenick = getrandomnick (nick)
realnick = fakenick

if getclass (fakenick) >= table_sets ["custnickclass"] then
fakenick = getcustnick (fakenick) or fakenick -- use custom nick here too
end

else

if ucl >= table_sets ["custnickclass"] then
fakenick = getcustnick (nick) or nick
end
end

local cvdat = data
local retval = 1

if table_sets ["translitmode"] > 0 then -- convert
cvdat = convtranslit (data, table_sets ["translitmode"])
if data ~= cvdat then retval = 0 end -- only when modified
end

if (retval == 0) or (fakenick ~= nick) then -- only when modified
VH:SendDataToAll ("<"..fakenick.."> "..cvdat.."|", 0, 10)
retval = 0
end

addmchistoryline (fakenick, realnick, data)
replyresponder (fakenick, ucl, data)
chatrankaccept (nick, ucl)
wordrankaccept (nick, ucl, data)

return retval
end

---------------------------------------------------------------------
-- verlihub event functions <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- ledokol functions >>
---------------------------------------------------------------------

function forcewelcome (nick, item, cls)
if string.find (item, "^%S+ %S+ .+$") then
local _, _, stype = string.find (item, "^(%S+) %S+ .+$")

if (stype == "in") or (stype == "out") then
local user = string.gsub (item, "^%S+ (%S+) (.+)$", "%1")
local item = string.gsub (item, "^%S+ (%S+) (.+)$", "%2")

if (getstatus (user) == 1) and ((table_sets ["welcomeclass"] == 11) or (getclass (user) < table_sets ["welcomeclass"])) then
commandanswer (nick, getlang (469))
else
local auser = repsqlchars (user)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl_sql ["wm"].."` where `nick` = '"..auser.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["wm"].."` set `"..stype.."` = '"..repsqlchars (item).."' where `nick` = '"..auser.."' limit 1")
else
VH:SQLQuery ("insert into `"..tbl_sql ["wm"].."` (`nick`, `"..stype.."`) values ('"..auser.."', '"..repsqlchars (item).."')")
end

item = string.gsub (item, "%*", reprexpchars (user))

if stype == "in" then
commandanswer (nick, string.format (getlang (485), user, item))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang (496), nick, cls, user, item))
elseif stype == "out" then
commandanswer (nick, string.format (getlang (495), user, item))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang (497), nick, cls, user, item))
end
end

else -- unknown type
commandanswer (nick, string.format (getlang (100), "in "..getlang (70).." out"))
end

else -- deleting
local stype = string.gsub (item, "^(%S+) %S+$", "%1")

if stype == "in" then
local user = string.gsub (item, "^%S+ (%S+)$", "%1")

if (getstatus (user) == 1) and ((table_sets ["welcomeclass"] == 11) or (getclass (user) < table_sets ["welcomeclass"])) then
commandanswer (nick, getlang (469))
else
local anick = repsqlchars (user)
VH:SQLQuery ("update `"..tbl_sql ["wm"].."` set `in` = '' where `nick` = '"..anick.."' limit 1")
VH:SQLQuery ("delete from `"..tbl_sql ["wm"].."` where `nick` = '"..anick.."' and `out` = '' limit 1")
commandanswer (nick, string.format (getlang (498), user))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang (500), nick, cls, user))
end

elseif stype == "out" then
local user = string.gsub (item, "^%S+ (%S+)$", "%1")

if (getstatus (user) == 1) and ((table_sets ["welcomeclass"] == 11) or (getclass (user) < table_sets ["welcomeclass"])) then
commandanswer (nick, getlang (469))
else
local anick = repsqlchars (user)
VH:SQLQuery ("update `"..tbl_sql ["wm"].."` set `out` = '' where `nick` = '"..anick.."' limit 1")
VH:SQLQuery ("delete from `"..tbl_sql ["wm"].."` where `nick` = '"..anick.."' and `in` = '' limit 1")
commandanswer (nick, string.format (getlang (499), user))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang (501), nick, cls, user))
end

else -- unknown type
commandanswer (nick, string.format (getlang (100), "in "..getlang (70).." out"))
end
end

return 0
end

----- ---- --- -- -

function listwelcome (nick)
local _, rows = VH:SQLQuery ("select `nick`, `in`, `out` from `"..tbl_sql ["wm"].."` order by `nick` asc")

if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local _, user, inm, outm = VH:SQLFetch (x)
inm = string.gsub (inm, "%*", reprexpchars (user))
outm = string.gsub (outm, "%*", reprexpchars (user))
anentry = anentry.."\n "..getlang (254)..": "..user.."\n "..getlang (255)..": "..inm.."\n "..getlang (256)..": "..outm.."\n"
end

commandanswer (nick, getlang (252)..":\n"..anentry)
else
commandanswer (nick, getlang (257))
end

return 0
end

----- ---- --- -- -

function delwelcome (nick, item, cls)
local aitem = repsqlchars (item)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl_sql ["wm"].."` where `nick` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["wm"].."` where `nick` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang (258), item))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang (502), nick, cls, item))
else
commandanswer (nick, string.format (getlang (259), item))
end

return 0
end

----- ---- --- -- -

function setwelcome (nick, item, cls)
if string.find (item, "^%S+ .+$") then
local stype = string.gsub (item, "^(%S+) .+$", "%1")

if (stype == "in") or (stype == "out") then
local item = string.gsub (item, "^%S+ (.+)$", "%1")
local anick = repsqlchars (nick)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl_sql ["wm"].."` where `nick` = '"..anick.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["wm"].."` set `"..stype.."` = '"..repsqlchars (item).."' where `nick` = '"..anick.."' limit 1")
else
VH:SQLQuery ("insert into `"..tbl_sql ["wm"].."` (`nick`, `"..stype.."`) values ('"..anick.."', '"..repsqlchars (item).."')")
end

item = string.gsub (item, "%*", reprexpchars (nick))

if stype == "in" then
commandanswer (nick, string.format (getlang (260), item))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang (261), nick, cls, item))
elseif stype == "out" then
commandanswer (nick, string.format (getlang (262), item))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang (263), nick, cls, item))
end

else -- unknown type
commandanswer (nick, string.format (getlang (100), "in "..getlang (70).." out"))
end

else -- deleting
local stype = string.gsub (item, "^(%S+)$", "%1")

if stype == "in" then
local anick = repsqlchars (nick)
VH:SQLQuery ("update `"..tbl_sql ["wm"].."` set `in` = '' where `nick` = '"..anick.."' limit 1")
VH:SQLQuery ("delete from `"..tbl_sql ["wm"].."` where `nick` = '"..anick.."' and `out` = '' limit 1")
commandanswer (nick, getlang (491))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang (493), nick, cls))

elseif stype == "out" then
local anick = repsqlchars (nick)
VH:SQLQuery ("update `"..tbl_sql ["wm"].."` set `out` = '' where `nick` = '"..anick.."' limit 1")
VH:SQLQuery ("delete from `"..tbl_sql ["wm"].."` where `nick` = '"..anick.."' and `in` = '' limit 1")
commandanswer (nick, getlang (492))
opsnotify (table_sets ["classnotiwelcome"], string.format (getlang (494), nick, cls))

else -- unknown type
commandanswer (nick, string.format (getlang (100), "in "..getlang (70).." out"))
end
end

return 0
end

----- ---- --- -- -

function showwelcome (nick)
local _, rows = VH:SQLQuery ("select `in`, `out` from `"..tbl_sql ["wm"].."` where `nick` = '"..repsqlchars (nick).."' limit 1")

if rows > 0 then
local _, inm, outm = VH:SQLFetch (0)
inm = string.gsub (inm, "%*", reprexpchars (nick))
commandanswer (nick, string.format (getlang (265), inm))
outm = string.gsub (outm, "%*", reprexpchars (nick))
commandanswer (nick, string.format (getlang (483), outm))
else
commandanswer (nick, getlang (264))
end

return 0
end

----- ---- --- -- -

function sendwelcomein (nick, ucl)
if ucl >= table_sets ["welcomeclass"] then
local _, rows = VH:SQLQuery ("select `in` from `"..tbl_sql ["wm"].."` where `nick` = '"..repsqlchars (nick).."' and `in` != '' limit 1")

if rows > 0 then
local _, cmsg = VH:SQLFetch (0)

if ucl >= table_sets ["custnickclass"] then
cmsg = string.gsub (cmsg, "%*", reprexpchars (getcustnick (nick) or nick))
else
cmsg = string.gsub (cmsg, "%*", reprexpchars (nick))
end

maintoall (cmsg, 0, 10)
end
end

return 0
end

----- ---- --- -- -

function sendwelcomeout (nick, ucl)
if ucl >= table_sets ["welcomeclass"] then
local _, rows = VH:SQLQuery ("select `out` from `"..tbl_sql ["wm"].."` where `nick` = '"..repsqlchars (nick).."' and `out` != '' limit 1")

if rows > 0 then
local _, cmsg = VH:SQLFetch (0)

if ucl >= table_sets ["custnickclass"] then
cmsg = string.gsub (cmsg, "%*", reprexpchars (getcustnick (nick) or nick))
else
cmsg = string.gsub (cmsg, "%*", reprexpchars (nick))
end

maintoall (cmsg, 0, 10)
end
end

return 0
end

----- ---- --- -- -

function addchatroom (nick, item)
local minc = string.gsub (item, "^%S+ .* (%d+) (%d+)$", "%1")
local maxc = string.gsub (item, "^%S+ .* (%d+) (%d+)$", "%2")

if ((tonumber (minc) > 5) and (tonumber (minc) < 10)) or (tonumber (minc) > 10) or ((tonumber (maxc) > 5) and (tonumber (maxc) < 10)) or (tonumber (maxc) > 10) then -- only if valid class
commandanswer (nick, string.format (getlang (143), "0, 1, 2, 3, 4, 5 "..getlang (70).." 10"))
else
local room = string.gsub (item, "^(%S+) .* %d+ %d+$", "%1")
local entry = repsqlchars (room)
local _, rows = VH:SQLQuery ("select `minclass` from `"..tbl_sql ["chat"].."` where `room` = '"..entry.."' limit 1")
local desc = string.gsub (item, "^%S+ (.*) %d+ %d+$", "%1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["chat"].."` set `description` = '"..repsqlchars (desc).."', `minclass` = '"..minc.."', `maxclass` = '"..maxc.."' where `room` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang (272), room))
else

if getstatus (room) == 0 then
VH:SQLQuery ("insert into `"..tbl_sql ["chat"].."` (`room`, `description`, `minclass`, `maxclass`) values ('"..entry.."', '"..repsqlchars (desc).."', '"..minc.."', '"..maxc.."')")

if table_sets ["chatrunning"] == 1 then
addhubrobot (room, desc, 0)
end

commandanswer (nick, string.format (getlang (273), room))
else -- nick is already in use
commandanswer (nick, string.format (getlang (304), room))
end
end
end

return 0
end

----- ---- --- -- -

function delchatroom (nick, item)
local aitem = repsqlchars (item)
local _, rows = VH:SQLQuery ("select `minclass` from `"..tbl_sql ["chat"].."` where `room` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["chat"].."` where `room` = '"..aitem.."' limit 1")

if (table_sets ["chatrunning"] == 1) and (getstatus (item) == 1) then
delhubrobot (item)
end

commandanswer (nick, string.format (getlang (274), item))
else
commandanswer (nick, string.format (getlang (275), item))
end

return 0
end

----- ---- --- -- -

function listchatroom (nick)
local _, rows = VH:SQLQuery ("select `room`, `description`, `minclass`, `maxclass` from `"..tbl_sql ["chat"].."` order by `minclass` asc, `maxclass` desc")

if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local _, room, desc, minc, maxc = VH:SQLFetch (x)
anentry = anentry.."\n "..getlang (276)..": "..room.." ["..minc.."-"..maxc.."]\n "..getlang (277)..": "..desc.."\n"
end

commandanswer (nick, getlang (267)..":\n"..anentry)
else
commandanswer (nick, getlang (278))
end

return 0
end

----- ---- --- -- -

function installchatrooms ()
local _, rows = VH:SQLQuery ("select `room`, `description` from `"..tbl_sql ["chat"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, room, desc = VH:SQLFetch (x)

if getstatus (room) == 0 then
addhubrobot (room, desc, 0)
end
end
end

return 0
end

----- ---- --- -- -

function uninstallchatrooms ()
local _, rows = VH:SQLQuery ("select `room` from `"..tbl_sql ["chat"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, room = VH:SQLFetch (x)

if getstatus (room) == 1 then
delhubrobot (room)
end
end
end

return 0
end

----- ---- --- -- -

function checkchatroom (to, from, data, ucl)
local _, rows = VH:SQLQuery ("select `room`, `minclass`, `maxclass` from `"..tbl_sql ["chat"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, room, minc, maxc = VH:SQLFetch (x)

if to == room then
minc = tonumber (minc)
maxc = tonumber (maxc)

if (ucl >= minc) and (ucl <= maxc) then
broadcastchatroom (room, minc, maxc, from, data)
else
opsnotify (table_sets ["classnotibotpm"], string.format (getlang (432), from, getip (from), ucl, data))
VH:SendDataToUser ("$To: "..from.." From: "..to.." $<"..table_othsets ["sendfrom"].."> "..getlang (279).."|", from)
end

return 1
end
end
end

return 0
end

----- ---- --- -- -

function broadcastchatroom (room, minc, maxc, from, text)
local nicklist = getnicklist ()

if nicklist then
for user in string.gmatch (nicklist, "([^$]+)%$%$") do
local ucl = getclass (user)

if (user ~= from) and (ucl >= minc) and (ucl <= maxc) then -- skip user himself
VH:SendDataToUser ("$To: "..from.." From: "..room.." $<"..from.."> "..text.."|", user)
end
end
end

return 0
end

----- ---- --- -- -

function ischatroom (nick)
local _, rows = VH:SQLQuery ("select `room` from `"..tbl_sql ["chat"].."` where `room` = '"..repsqlchars (nick).."' limit 1")

if rows > 0 then

return 1
end

return 0
end

----- ---- --- -- -

function getcustnick (nick)
local _, rows = VH:SQLQuery ("select `custom` from `"..tbl_sql ["cust"].."` where `nick` = '"..repsqlchars (nick).."' limit 1")

if rows > 0 then
local _, val = VH:SQLFetch (0)
return val
else
return nil
end
end

----- ---- --- -- -

function getrealnick (nick, custom)
local rnick = findcustnick (custom)

if rnick == nil then
if getstatus (custom) == 1 then
commandanswer (nick, getlang (424))
else
commandanswer (nick, getlang (368))
end

else
local stsword = ""

if getstatus (rnick) == 1 then
stsword = getlang (371)
else
stsword = getlang (370)
end

commandanswer (nick, string.format (getlang (369), stsword, rnick))
end

return 0
end

----- ---- --- -- -

function findcustnick (nick)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl_sql ["cust"].."` where `custom` = '"..repsqlchars (nick).."' limit 1")

if rows > 0 then
local _, val = VH:SQLFetch (0)
return val
else
return nil
end
end

----- ---- --- -- -

function addcustnick (nick, custom)
local nnick = repsqlchars (nick)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl_sql ["cust"].."` where `nick` = '"..nnick.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["cust"].."` set `custom` = '"..repsqlchars (custom).."' where `nick` = '"..nnick.."' limit 1")
else
VH:SQLQuery ("insert into `"..tbl_sql ["cust"].."` (`nick`, `custom`) values ('"..nnick.."', '"..repsqlchars (custom).."')")
end

return 0
end

----- ---- --- -- -

function cleancustnick (limit, byclass)
local _, rows = VH:SQLQuery ("select `nick`, `custom` from `"..tbl_sql ["cust"].."`")

if rows > 0 then
local table_delete = {}

for x = 0, rows - 1 do
local _, nick, custom = VH:SQLFetch (x)

if byclass == 0 then
if string.len (custom) > limit then
table_delete [nick] = custom
end

else

if getclass (nick) < limit then
table_delete [nick] = custom
end
end
end

for k, v in pairs (table_delete) do
VH:SQLQuery ("delete from `"..tbl_sql ["cust"].."` where `nick` = '"..repsqlchars (k).."' limit 1")

if getstatus (k) == 1 then
maintoall (string.format (getlang (20), v, k), 0, 10)
end
end
end

return 0
end

----- ---- --- -- -

function delcustnick (nick)
VH:SQLQuery ("delete from `"..tbl_sql ["cust"].."` where `nick` = '"..repsqlchars (nick).."' limit 1")

return 0
end

----- ---- --- -- -

function opforcecustnick (nick, line)
local onick = string.gsub (line, "^(%S+) .+$", "%1")

if getstatus (onick) == 0 then
commandanswer (nick, string.format (getlang (468), onick))
elseif (table_sets ["custnickclass"] == 11) or (getclass (onick) < table_sets ["custnickclass"]) then
commandanswer (nick, getlang (469))
else
local ncust = string.gsub (line, "^%S+ (.+)$", "%1")

if string.len (ncust) > table_sets ["custmaxlen"] then
commandanswer (nick, string.format (getlang (328), table_sets ["custmaxlen"]))
else
local oldcust = getcustnick (onick)
ncust = repnickchars (ncust)

if (getstatus (ncust) == 0) and (getregclass (ncust) == nil) and (findcustnick (ncust) == nil) then
addcustnick (onick, ncust)
maintoall (string.format (getlang (20), (oldcust or onick), ncust), 0, 10)
else -- nick already exists in list
commandanswer (nick, string.format (getlang (248), ncust))
end
end
end

return 0
end

----- ---- --- -- -

function opdelcustnick (nick, user)
local auser = repsqlchars (user)
local _, rows = VH:SQLQuery ("select `nick`, `custom` from `"..tbl_sql ["cust"].."` where `nick` = '"..auser.."' or `custom` = '"..auser.."' limit 1")

if rows > 0 then
local _, orig, custom = VH:SQLFetch (0)
VH:SQLQuery ("delete from `"..tbl_sql ["cust"].."` where `nick` = '"..repsqlchars (orig).."' limit 1")

if getstatus (orig) == 1 then
maintoall (string.format (getlang (20), custom, orig), 0, 10)
else
commandanswer (nick, string.format (getlang (330), user))
end

else
commandanswer (nick, string.format (getlang (331), user))
end

return 0
end

----- ---- --- -- -

function resetcustnicks ()
local _, rows = VH:SQLQuery ("select `nick`, `custom` from `"..tbl_sql ["cust"].."`")

if rows > 0 then
local table_delete = {}

for x = 0, rows - 1 do
local _, nick, custom = VH:SQLFetch (x)
table_delete [nick] = custom
end

for k, v in pairs (table_delete) do
VH:SQLQuery ("delete from `"..tbl_sql ["cust"].."` where `nick` = '"..repsqlchars (k).."' limit 1")

if getstatus (k) == 1 then
maintoall (string.format (getlang (20), v, k), 0, 10)
end
end
end

return 0
end

----- ---- --- -- -

function setcustnick (nick, custom)
if string.len (custom) == 0 then -- user is resetting his nick
local oldcust = getcustnick (nick)

if oldcust ~= nil then
delcustnick (nick)
maintoall (string.format (getlang (20), oldcust, nick), 0, 10)
end

elseif string.len (custom) > table_sets ["custmaxlen"] then
commandanswer (nick, string.format (getlang (328), table_sets ["custmaxlen"]))
else
local custom = repnickchars (custom)

if (string.lower (nick) == string.lower (custom)) or ((getstatus (custom) == 0) and (getregclass (custom) == nil) and (findcustnick (custom) == nil)) then
local oldcust = getcustnick (nick)

if nick == custom then -- resetting
delcustnick (nick)
else
addcustnick (nick, custom)
end

maintoall (string.format (getlang (20), (oldcust or nick), custom), 0, 10)
else -- nick already used
commandanswer (nick, string.format (getlang (248), custom))
end
end

return 0
end

----- ---- --- -- -

function listcustnick (nick)
local _, rows = VH:SQLQuery ("select `nick`, `custom` from `"..tbl_sql ["cust"].."` order by `nick` asc")

if rows > 0 then
local aentry = ""
local numlen = 0

for x = 0, rows - 1 do
local _, user, custom = VH:SQLFetch (x)
if x == 0 then numlen = string.len (rows) end
aentry = aentry.." "..inleadingzeroes (numlen, (x + 1))..". [O: "..getstatus (user).."] "..user.." @ "..custom.."\n"
end

commandanswer (nick, getlang (154)..":\n\n"..aentry)
else
commandanswer (nick, getlang (112))
end

return 0
end

----- ---- --- -- -

function logsread (nick, item)
logfile = string.gsub (item, "^(%S+) (%d+)$", "%1")
lnnum = string.gsub (item, "^(%S+) (%d+)$", "%2")
lnnum = tonumber (lnnum)

if lnnum <= 1 then
lnnum = 1
end

if (logfile == "log") or (logfile == "log.old") or (logfile == "err") or (logfile == "err.old") then -- look below (1)
cnt = 0

lfl = io.open (table_othsets ["dif_vhcfg"]..logfile, "r")

if lfl then -- look below (2)
lfl:close ()

for line in io.lines (table_othsets ["dif_vhcfg"]..logfile) do
cnt = cnt + 1
end

if cnt > 0 then -- look below (3)
if cnt > lnnum then
diff = cnt - lnnum + 1
showcnt = lnnum
else
diff = 1
showcnt = cnt
end

numlen = string.len (cnt)
cnt = 0
aline = ""

for line in io.lines (table_othsets ["dif_vhcfg"]..logfile) do
cnt = cnt + 1

if cnt >= diff then
aline = aline.." "..inleadingzeroes (numlen, cnt)..": "..repnmdcoutchars (line).."\n"
end
end

commandanswer (nick, string.format (getlang (157), showcnt, cnt, logfile)..":\n\n"..aline)
else -- zero lines in file (3)
commandanswer (nick, getlang (295))
end

else -- file couldnt be found (2)
commandanswer (nick, getlang (295))
end

else -- invalid log file (1)
commandanswer (nick, string.format (getlang (294), "log, err, log.old "..getlang (70).." err.old"))
end

return 0
end

----- ---- --- -- -

function checkcmd (nick, class, cmd)
local _, rows = VH:SQLQuery ("select `command`, `class` from `"..tbl_sql ["cmd"].."` order by `occurred` desc")

if rows > 0 then
local rcmd = repnmdcinchars (cmd)

for x = 0, rows - 1 do
local _, entry, cls = VH:SQLFetch (x)

if string.find (rcmd, entry) and (class < tonumber (cls)) then
VH:SQLQuery ("update `"..tbl_sql ["cmd"].."` set `occurred` = `occurred` + 1 where `command` = '"..repsqlchars (entry).."' limit 1")
commandanswer (nick, getlang (128))

return 0
end
end
end

return 1
end

----- ---- --- -- -

function addcmdentry (nick, item)
local class = string.gsub (item, "^.+ (%d+)$", "%1")
class = tonumber (class)

if (class == 11) or (class == 10) or (class == 5) or (class == 4) or (class == 3) or (class == 2) or (class == 1) then -- only if valid class
local entry = string.gsub (item, "^(.+) %d+$", "%1")
local str = repsqlchars (repnmdcinchars (entry))
local _, rows = VH:SQLQuery ("select `class` from `"..tbl_sql ["cmd"].."` where `command` = '"..str.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["cmd"].."` set `class` = '"..class.."' where `command` = '"..str.."' limit 1")
commandanswer (nick, string.format (getlang (339), class, entry))
else
VH:SQLQuery ("insert into `"..tbl_sql ["cmd"].."` (`command`, `class`) values ('"..str.."', '"..class.."')")
commandanswer (nick, string.format (getlang (340), class, entry))
end

else
commandanswer (nick, string.format (getlang (143), "1, 2, 3, 4, 5, 10 "..getlang (70).." 11"))
end

return 0
end

----- ---- --- -- -

function delcmdentry (nick, item)
local aitem = repsqlchars (repnmdcinchars (item))
local _, rows = VH:SQLQuery ("select `class` from `"..tbl_sql ["cmd"].."` where `command` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["cmd"].."` where `command` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang (341), item))
else
commandanswer (nick, string.format (getlang (342), item))
end

return 0
end

----- ---- --- -- -

function listcmdentry (nick)
local _, rows = VH:SQLQuery ("select `command`, `class`, `occurred` from `"..tbl_sql ["cmd"].."` order by `occurred` desc")

if rows > 0 then
local anentry = ""
local len = 0
local numlen = 0

for x = 0, rows - 1 do
local _, entry, class, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

anentry = anentry.." "..inleadingzeroes (numlen, (x + 1))..". [O: "..inleadingzeroes (len, occurred).."] "..repnmdcoutchars (entry).." ["..class.."]\n"
end

commandanswer (nick, getlang (338)..":\n\n"..anentry)
else
commandanswer (nick, getlang (343))
end

return 0
end

----- ---- --- -- -

function addcmdexentry (nick, item)
local entry = repsqlchars (repnmdcinchars (item))
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["cmdex"].."` where `exception` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (300), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["cmdex"].."` (`exception`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (299), item))
end

return 0
end

----- ---- --- -- -

function delcmdexentry (nick, item)
local aitem = repsqlchars (repnmdcinchars (item))
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["cmdex"].."` where `exception` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["cmdex"].."` where `exception` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang (301), item))
else
commandanswer (nick, string.format (getlang (302), item))
end

return 0
end

----- ---- --- -- -

function listcmdexentry (nick)
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..tbl_sql ["cmdex"].."` order by `occurred` desc")

if rows > 0 then
local anentry = ""
local len = 0
local numlen = 0

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

anentry = anentry.." "..inleadingzeroes (numlen, (x + 1))..". [O: "..inleadingzeroes (len, occurred).."] "..repnmdcoutchars (entry).."\n"
end

commandanswer (nick, getlang (298)..":\n\n"..anentry)
else
commandanswer (nick, getlang (303))
end

return 0
end

----- ---- --- -- -

function installtimebot ()
table_othsets ["timebotseconds"] = os.time ()
local bottime = os.time () + table_sets ["srvtimediff"] -- current system time
bottime = os.date (table_sets ["timebotnick"], bottime)
uninstalltimebot ()
addhubrobot (bottime, table_othsets ["timebotdesc"], 0)
table_othsets ["lasttimenick"] = bottime

-- there is another much faster way of adding timebot to userlist
-- bad side: new users wont see it until new time is added to list
-- send to all: $Quit table_othsets ["lasttimenick"]
-- send to all: $OpList bottime

return 0
end

----- ---- --- -- -

function uninstalltimebot ()
if (table_othsets ["lasttimenick"] ~= nil) and (getstatus (table_othsets ["lasttimenick"]) == 1) then
delhubrobot (table_othsets ["lasttimenick"])
end

return 0
end

----- ---- --- -- -

function addreminder (nick, item)
local minc = string.gsub (item, "^%S+ .+ (%d+) (%d+) (%d+) (%d+)$", "%1")
local maxc = string.gsub (item, "^%S+ .+ (%d+) (%d+) (%d+) (%d+)$", "%2")
local dest = string.gsub (item, "^%S+ .+ (%d+) (%d+) (%d+) (%d+)$", "%3")
local intv = string.gsub (item, "^%S+ .+ (%d+) (%d+) (%d+) (%d+)$", "%4")

if ((tonumber (minc) > 5) and (tonumber (minc) < 10)) or (tonumber (minc) > 10) or ((tonumber (maxc) > 5) and (tonumber (maxc) < 10)) or (tonumber (maxc) > 10) then -- only if valid class
commandanswer (nick, string.format (getlang (143), "0, 1, 2, 3, 4, 5 "..getlang (70).." 10"))
elseif tonumber (dest) > 2 then -- only if valid destination
commandanswer (nick, string.format (getlang (387), "0, 1 "..getlang (70).." 2"))
elseif (tonumber (intv) < 1) or (tonumber (intv) > 10080) then -- only if valid interval
commandanswer (nick, string.format (getlang (388), "1 "..getlang (199).." 10080"))
else
local ident = string.gsub (item, "^(%S+) .+ %d+ %d+ %d+ %d+$", "%1")
local cntnt = string.gsub (item, "^%S+ (.+) %d+ %d+ %d+ %d+$", "%1")
local entry = repsqlchars (ident)
local _, rows = VH:SQLQuery ("select `pm` from `"..tbl_sql ["rem"].."` where `id` = '"..entry.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["rem"].."` set `content` = '"..repsqlchars (cntnt).."', `minclass` = '"..minc.."', `maxclass` = '"..maxc.."', `pm` = '"..dest.."', `interval` = '"..intv.."' where `id` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang (389), ident))
else
VH:SQLQuery ("insert into `"..tbl_sql ["rem"].."` (`id`, `content`, `minclass`, `maxclass`, `pm`, `interval`) values ('"..entry.."', '"..repsqlchars (cntnt).."', '"..minc.."', '"..maxc.."', '"..dest.."', '"..intv.."')")
commandanswer (nick, string.format (getlang (390), ident))
end
end

return 0
end

----- ---- --- -- -

function delreminder (nick, item)
local aitem = repsqlchars (item)
local _, rows = VH:SQLQuery ("select `pm` from `"..tbl_sql ["rem"].."` where `id` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["rem"].."` where `id` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang (391), item))
else
commandanswer (nick, string.format (getlang (392), item))
end

return 0
end

----- ---- --- -- -

function showreminder (nick, id)
local _, rows = VH:SQLQuery ("select `content` from `"..tbl_sql ["rem"].."` where `id` = '"..repsqlchars (id).."' limit 1")

if rows > 0 then
local _, contn = VH:SQLFetch (0)
commandanswer (nick, string.format (getlang (510), id)..": "..reptextvars (contn, nil, nil))
else
commandanswer (nick, string.format (getlang (392), id))
end
end

----- ---- --- -- -

function listreminder (nick)
local _, rows = VH:SQLQuery ("select `id`, `content`, `minclass`, `maxclass`, `pm`, `interval`, `timer` from `"..tbl_sql ["rem"].."` order by `minclass` asc, `maxclass` desc")

if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local _, ident, cntnt, minc, maxc, dest, intv, timr = VH:SQLFetch (x)

if tonumber (dest) == 0 then
dest = getlang (399)
elseif tonumber (dest) == 1 then
dest = getlang (398)
else
dest = getlang (219)
end

anentry = anentry.."\n "..getlang (393)..": "..ident.."\n "..getlang (396)..": "..dest.." ["..minc.."-"..maxc.."]\n "..getlang (395)..": "..timr.." "..getlang (397).." "..intv.."\n "..getlang (394)..": "..cntnt.."\n"
end

commandanswer (nick, getlang (385)..":\n"..anentry)
else
commandanswer (nick, getlang (386))
end

return 0
end

----- ---- --- -- -

function sendreminder ()
local _, rows = VH:SQLQuery ("select `id`, `interval`, `timer` from `"..tbl_sql ["rem"].."`")

if rows > 0 then
local table_updates = {}

for x = 0, rows - 1 do
local _, idnt, intrv, tmer = VH:SQLFetch (x)
tmer = tonumber (tmer) + 1

if tmer >= tonumber (intrv) then
table_updates [idnt] = 0
else
table_updates [idnt] = tmer
end
end

for k, v in pairs (table_updates) do
local repk = repsqlchars (k)

if v == 0 then -- send the reminder
local _, rows = VH:SQLQuery ("select `content`, `minclass`, `maxclass`, `pm` from `"..tbl_sql ["rem"].."` where `id` = '"..repk.."' limit 1")

if rows > 0 then
local _, contn, mincl, maxcl, pmf = VH:SQLFetch (0)
local repdvars = reptextvars (contn, nil, nil)

if tonumber (pmf) == 0 then
maintoall (repdvars, mincl, maxcl)
elseif tonumber (pmf) == 1 then
VH:SendPMToAll (repdvars, table_othsets ["sendfrom"], mincl, maxcl)
else
maintoall (repdvars, mincl, maxcl)
VH:SendPMToAll (repdvars, table_othsets ["sendfrom"], mincl, maxcl)
end
end
end

VH:SQLQuery ("update `"..tbl_sql ["rem"].."` set `timer` = '"..v.."' where `id` = '"..repk.."' limit 1")
end
end

return 0
end

----- ---- --- -- -

function addnews (nick, item)
local ndate = os.time () + table_sets ["srvtimediff"] -- current system time
VH:SQLQuery ("insert into `"..tbl_sql ["news"].."` (`date`, `by`, `item`) values ('"..ndate.."', '"..repsqlchars (nick).."', '"..repsqlchars (item).."')")
commandanswer (nick, string.format (getlang (456), os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], ndate)))

return 0
end

----- ---- --- -- -

function delnews (nick, adate)
local _, rows = VH:SQLQuery ("select `date` from `"..tbl_sql ["news"].."`")
local table_delete = {}

if rows > 0 then
for x = 0, rows - 1 do
local _, zdate = VH:SQLFetch (x)

if string.find (os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], zdate), repdatechars (adate)) then
table_delete [zdate] = x -- entries with same date will be overwritten
end
end

else
commandanswer (nick, getlang (457))

return 0
end

for k, _ in pairs (table_delete) do
VH:SQLQuery ("delete from `"..tbl_sql ["news"].."` where `date` = '"..repsqlchars (k).."'") -- dont set limit because there might be few rows
end

local num = table.getn (table_delete)

if num > 0 then
commandanswer (nick, string.format (getlang (458), num))
else
commandanswer (nick, string.format (getlang (459), adate))
end

return 0
end

----- ---- --- -- -

function sendnews (nick, lnnum, autosend)
local lns = tonumber (lnnum)
if lns < 1 then lns = 1 end
local _, rows = VH:SQLQuery ("select `date`, `by`, `item` from `"..tbl_sql ["news"].."` order by `date` desc, `id` desc limit "..lns)

if rows > 0 then
local aentry = ""

for x = 0, rows - 1 do
local _, adate, user, msg = VH:SQLFetch (x)
aentry = aentry.." "..string.format (getlang (461), user, os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate), msg).."\n"
end

if autosend == 0 then
commandanswer (nick, string.format (getlang (460), rows)..":\n\n"..aentry)
else
maintouser (nick, string.format (getlang (460), rows)..":\n\n"..aentry)
end

else

if autosend == 0 then -- only if sending manually
commandanswer (nick, getlang (457))
end
end

return 0
end

----- ---- --- -- -

function addresponder (nick, item)
local _, _, maxc = string.find (item, "^\".+\" \".+\" (%d+)$")
maxc = tonumber (maxc)

if (maxc >= 0) and (maxc <= 5) or (maxc == 10) then
local _, _, msg, rpl = string.find (item, "^\"(.+)\" \"(.+)\" %d+$")
VH:SQLQuery ("insert into `"..tbl_sql ["mcresp"].."` (`message`, `reply`, `maxclass`) values ('"..repsqlchars (repnmdcinchars (msg)).."', '"..repsqlchars (rpl).."', '"..repsqlchars (maxc).."')")
commandanswer (nick, string.format (getlang (407), msg))
else
commandanswer (nick, string.format (getlang (143), "0, 1, 2, 3, 4, 5 "..getlang (70).." 10"))
end

return 0
end

----- ---- --- -- -

function delresponder (nick, item)
local aitem = repsqlchars (item)
local _, rows = VH:SQLQuery ("select `maxclass` from `"..tbl_sql ["mcresp"].."` where `id` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["mcresp"].."` where `id` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang (408), item))
else
commandanswer (nick, string.format (getlang (409), item))
end

return 0
end

----- ---- --- -- -

function listresponder (nick)
local _, rows = VH:SQLQuery ("select `id`, `message`, `reply`, `maxclass`, `occurred` from `"..tbl_sql ["mcresp"].."` order by `occurred` desc, `id` desc")

if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local _, id, msg, repl, maxc, occur = VH:SQLFetch (x)
anentry = anentry.."\n "..getlang (410)..": "..repnmdcoutchars (msg).."\n "..getlang (411)..": "..repl.."\n ID: "..id.." [C: "..maxc.."] [O: "..occur.."]\n"
end

commandanswer (nick, getlang (403)..":\n"..anentry)
else
commandanswer (nick, getlang (404))
end

return 0
end

----- ---- --- -- -

function addrespex (nick, item)
local entry = repsqlchars (item)
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["respex"].."` where `exception` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (416), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["respex"].."` (`exception`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (417), item))
end

return 0
end

----- ---- --- -- -

function delrespex (nick, item)
local aitem = repsqlchars (item)
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["respex"].."` where `exception` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["respex"].."` where `exception` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang (418), item))
else
commandanswer (nick, string.format (getlang (419), item))
end

return 0
end

----- ---- --- -- -

function listrespex (nick)
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..tbl_sql ["respex"].."` order by `occurred` desc")

if rows > 0 then
local anentry = ""
local len = 0
local numlen = 0

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

anentry = anentry.." "..inleadingzeroes (numlen, (x + 1))..". [O: "..inleadingzeroes (len, occurred).."] "..entry.."\n"
end

commandanswer (nick, getlang (414)..":\n\n"..anentry)
else
commandanswer (nick, getlang (415))
end

return 0
end

----- ---- --- -- -

function replyresponder (nick, cls, msg)
if table_sets ["resprunning"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["respex"].."` where `exception` = '"..repsqlchars (nick).."' or `exception` = '"..repsqlchars (getip (nick)).."' limit 1")

if rows > 0 then
local _, ex = VH:SQLFetch (0)
VH:SQLQuery ("update `"..tbl_sql ["respex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (ex).."' limit 1")

return 0
end

local _, rows = VH:SQLQuery ("select `id`, `message`, `reply`, `maxclass` from `"..tbl_sql ["mcresp"].."`")

if rows > 0 then
local txt = string.lower (repnmdcinchars (msg))
local respsel = {}

for x = 0, rows - 1 do
local _, id, ent, repl, maxc = VH:SQLFetch (x)

if (cls <= tonumber (maxc)) and string.find (txt, ent) then
table.insert (respsel, {[id] = repl})
end
end

local cnt = table.getn (respsel)

if cnt > 0 then
for k, v in pairs (respsel [math.random (cnt)]) do
table.insert (table_resp, {[os.time ()] = reptextvars (v, nick, msg)})
VH:SQLQuery ("update `"..tbl_sql ["mcresp"].."` set `occurred` = `occurred` + 1 where `id` = '"..repsqlchars (k).."' limit 1")
end
end
end

return 0
end

----- ---- --- -- -

function addrelease (nick, line)
local rel, cat, tth = "", "", ""

if string.find (line, "^\".+\" \".+\" %S+$") then
rel = string.gsub (line, "^\"(.+)\" \"(.+)\" (%S+)$", "%1")
cat = string.gsub (line, "^\"(.+)\" \"(.+)\" (%S+)$", "%2")
tth = string.gsub (line, "^\"(.+)\" \"(.+)\" (%S+)$", "%3")
else
rel = string.gsub (line, "^\"(.+)\" \"(.+)\"$", "%1")
cat = string.gsub (line, "^\"(.+)\" \"(.+)\"$", "%2")
end

local arel = repsqlchars (rel)
local _, rows = VH:SQLQuery ("select `date` from `"..tbl_sql ["rel"].."` where `release` = '"..arel.."' limit 1")
local ndate = os.time () + table_sets ["srvtimediff"] -- current system time

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["rel"].."` set `category` = '"..repsqlchars (cat).."', `tth` = '"..repsqlchars (tth).."', `date` = '"..ndate.."' where `release` = '"..arel.."' limit 1")
commandanswer (nick, string.format (getlang (505), rel))
else
VH:SQLQuery ("insert into `"..tbl_sql ["rel"].."` (`release`, `category`, `tth`, `by`, `date`) values ('"..arel.."', '"..repsqlchars (cat).."', '"..repsqlchars (tth).."', '"..repsqlchars (nick).."', '"..ndate.."')")
commandanswer (nick, string.format (getlang (506), rel))
end

return 0
end

----- ---- --- -- -

function delrelease (nick, line)
local stype = string.gsub (line, "^(%S+) .+$", "%1")

if stype == "rel" then
local rel = string.gsub (line, "^%S+ (.+)$", "%1")
local arel = repsqlchars (rel)
local _, rows = VH:SQLQuery ("select `date` from `"..tbl_sql ["rel"].."` where `release` = '"..arel.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["rel"].."` where `release` = '"..arel.."' limit 1")
commandanswer (nick, string.format (getlang (507), rel))
else
commandanswer (nick, string.format (getlang (508), rel))
end

elseif stype == "cat" then
local cat = string.gsub (line, "^%S+ (.+)$", "%1")
local acat = repsqlchars (cat)
local _, rows = VH:SQLQuery ("select `date` from `"..tbl_sql ["rel"].."` where `category` = '"..acat.."'")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["rel"].."` where `category` = '"..acat.."'") -- no limit
commandanswer (nick, string.format (getlang (54), rows ,cat))
else
commandanswer (nick, string.format (getlang (355), cat))
end

else -- unknown type
commandanswer (nick, string.format (getlang (100), "rel "..getlang (70).." cat"))
end

return 0
end

----- ---- --- -- -

function listrelease (nick, line)
local stype, lnnum, catst = "", 0, ""

if string.find (line, "^%S+ %d+ .+$") then
stype = string.gsub (line, "^(%S+) (%d+) (.+)$", "%1")
lnnum = string.gsub (line, "^(%S+) (%d+) (.+)$", "%2")
catst = string.gsub (line, "^(%S+) (%d+) (.+)$", "%3")
else
stype = string.gsub (line, "^(%S+) (%d+)$", "%1")
lnnum = string.gsub (line, "^(%S+) (%d+)$", "%2")
catst = nil
end

lnnum = tonumber (lnnum)
if lnnum < 1 then lnnum = 1 end

if stype == "cat" then
if catst == nil then
commandanswer (nick, getlang (332))
else
local _, rows = VH:SQLQuery ("select `release`, `tth`, `by`, `date` from `"..tbl_sql ["rel"].."` where `category` = '"..repsqlchars (catst).."' order by `date` desc limit "..lnnum)

if rows > 0 then
local anentry = ""
local numlen = 0

for x = 0, rows - 1 do
local _, rel, tth, auth, adate = VH:SQLFetch (x)

if string.len (tth) > 0 then
tth = "\n "..string.format (getlang (224), "magnet:?xt=urn:tree:tiger:"..tth)
end

if x == 0 then
numlen = string.len (rows)
end

anentry = anentry.."\n "..inleadingzeroes (numlen, (x + 1))..". "..rel.."\n "..string.format (getlang (309), auth).."\n "..string.format (getlang (283), os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate))..tth.."\n"
end

commandanswer (nick, string.format (getlang (316), rows, catst)..":\n"..anentry)
else
commandanswer (nick, string.format (getlang (315), catst))
end
end

elseif stype == "pub" then
if catst == nil then
commandanswer (nick, getlang (332))
else
local _, rows = VH:SQLQuery ("select `release`, `category`, `tth`, `date` from `"..tbl_sql ["rel"].."` where `by` = '"..repsqlchars (catst).."' order by `date` desc limit "..lnnum)

if rows > 0 then
local anentry = ""
local numlen = 0

for x = 0, rows - 1 do
local _, rel, cat, tth, adate = VH:SQLFetch (x)

if string.len (tth) > 0 then
tth = "\n "..string.format (getlang (224), "magnet:?xt=urn:tree:tiger:"..tth)
end

if x == 0 then
numlen = string.len (rows)
end

anentry = anentry.."\n "..inleadingzeroes (numlen, (x + 1))..". "..rel.."\n "..string.format (getlang (246), cat).."\n "..string.format (getlang (283), os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate))..tth.."\n"
end

commandanswer (nick, string.format (getlang (314), rows, catst)..":\n"..anentry)
else
commandanswer (nick, string.format (getlang (313), catst))
end
end

elseif stype == "all" then
local _, rows = VH:SQLQuery ("select `release`, `category`, `tth`, `by`, `date` from `"..tbl_sql ["rel"].."` order by `date` desc limit "..lnnum)

if rows > 0 then
local anentry = ""
local numlen = 0

for x = 0, rows - 1 do
local _, rel, cat, tth, auth, adate = VH:SQLFetch (x)

if string.len (tth) > 0 then
tth = "\n "..string.format (getlang (224), "magnet:?xt=urn:tree:tiger:"..tth)
end

if x == 0 then
numlen = string.len (rows)
end

anentry = anentry.."\n "..inleadingzeroes (numlen, (x + 1))..". "..rel.."\n "..string.format (getlang (246), cat).."\n "..string.format (getlang (309), auth).."\n "..string.format (getlang (283), os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate))..tth.."\n"
end

commandanswer (nick, string.format (getlang (312), rows)..":\n"..anentry)
else
commandanswer (nick, getlang (311))
end

else -- unknown type
commandanswer (nick, string.format (getlang (100), "cat, pub "..getlang (70).." all"))
end

return 0
end

----- ---- --- -- -

function findrelease (nick, line)
local spat = string.gsub (line, "%%", "\\%%")
spat = repsqlchars (string.gsub (spat, string.char (32), "%%")) -- space to match any characters as word delimiter
local _, rows = VH:SQLQuery ("select `release`, `category`, `tth`, `by`, `date` from `"..tbl_sql ["rel"].."` where `release` like '%"..spat.."%' or `category` like '%"..spat.."%' order by `date` desc")

if rows > 0 then
local anentry = ""
local numlen = 0

for x = 0, rows - 1 do
local _, rel, cat, tth, auth, adate = VH:SQLFetch (x)

if string.len (tth) > 0 then
tth = "\n "..string.format (getlang (224), "magnet:?xt=urn:tree:tiger:"..tth)
end

if x == 0 then
numlen = string.len (rows)
end

anentry = anentry.."\n "..inleadingzeroes (numlen, (x + 1))..". "..rel.."\n "..string.format (getlang (246), cat).."\n "..string.format (getlang (309), auth).."\n "..string.format (getlang (283), os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate))..tth.."\n"
end

commandanswer (nick, string.format (getlang (504), rows, line)..":\n"..anentry)
else
commandanswer (nick, string.format (getlang (317), line))
end

return 0
end

----- ---- --- -- -

function showuserlog (nick, line)
local _, _, tp, str, lim = string.find (line, "^(%S+) (.+) (%d+)$")

if (tp == "nick") or (tp == "ip") or (tp == "desc") or (tp == "tag") or (tp == "conn") or (tp == "email") or (tp == "share") or (tp == "all") then
lim = tonumber (lim)
if lim < 1 then lim = 1 end
str = repsqlchars (str)

if tp == "all" then
local _, rows = VH:SQLQuery ("select `time`, `nick`, `ip`, `desc`, `tag`, `conn`, `email`, `share` from `"..tbl_sql ["ulog"].."` where `nick` like '%"..str.."%' or `ip` like '%"..str.."%' or `desc` like '%"..str.."%' or `tag` like '%"..str.."%' or `conn` like '%"..str.."%' or `email` like '%"..str.."%' or `share` like '%"..str.."%' order by `time` desc limit "..lim)

if rows > 0 then
local res = ""

for x = 0, rows - 1 do
local _, rtime, rnick, rip, rdesc, rtag, rconn, remail, rshare = VH:SQLFetch (x)
res = res.." [ O: "..fromunixtime (rtime).." ] [ N: "..repnmdcoutchars (rnick).." ]"
if rip ~= "[unknown]" then res = res.." [ I: "..repnmdcoutchars (rip).." ]" end
if rdesc ~= "" then res = res.." [ D: "..repnmdcoutchars (rdesc).." ]" end
if rtag ~= "" then res = res.." [ T: "..repnmdcoutchars (rtag).." ]" end
if rconn ~= "" then res = res.." [ C: "..repnmdcoutchars (rconn).." ]" end
if remail ~= "" then res = res.." [ E: "..repnmdcoutchars (remail).." ]" end
if rshare ~= "0" then res = res.." [ S: "..repnmdcoutchars (rshare).." ]" end
res = res.."\n"
end

commandanswer (nick, string.format (getlang (122), rows)..":\n\n"..res)
else
commandanswer (nick, getlang (121))
end

else -- specific
local _, rows = VH:SQLQuery ("select `time`, `nick`, `ip`, `desc`, `tag`, `conn`, `email`, `share` from `"..tbl_sql ["ulog"].."` where `"..tp.."` like '%"..str.."%' order by `time` desc limit "..lim)

if rows > 0 then
local res = ""

for x = 0, rows - 1 do
local _, rtime, rnick, rip, rdesc, rtag, rconn, remail, rshare = VH:SQLFetch (x)
res = res.." [ O: "..fromunixtime (rtime).." ] [ N: "..repnmdcoutchars (rnick).." ]"
if rip ~= "[unknown]" then res = res.." [ I: "..repnmdcoutchars (rip).." ]" end
if rdesc ~= "" then res = res.." [ D: "..repnmdcoutchars (rdesc).." ]" end
if rtag ~= "" then res = res.." [ T: "..repnmdcoutchars (rtag).." ]" end
if rconn ~= "" then res = res.." [ C: "..repnmdcoutchars (rconn).." ]" end
if remail ~= "" then res = res.." [ E: "..repnmdcoutchars (remail).." ]" end
if rshare ~= "0" then res = res.." [ S: "..repnmdcoutchars (rshare).." ]" end
res = res.."\n"
end

commandanswer (nick, string.format (getlang (122), rows)..":\n\n"..res)
else
commandanswer (nick, getlang (121))
end
end

else -- unknown type
commandanswer (nick, string.format (getlang (100), "nick, ip, desc, tag, conn, email, share "..getlang (70).." all"))
end

return 0
end

----- ---- --- -- -

function calculate (nick, line)
anum = string.gsub (line, "^(%S+) %S (%S+)$", "%1")
bnum = string.gsub (line, "^(%S+) %S (%S+)$", "%2")
anum = string.gsub (anum, ",", "%.")
bnum = string.gsub (bnum, ",", "%.")

if ((tonumber (anum)) or (string.lower (anum) == "pi")) and ((tonumber (bnum)) or (string.lower (bnum) == "pi")) then
oper = string.gsub (line, "^%S+ (%S) %S+$", "%1")

if (oper == "+") or (oper == "-") or (oper == "*") or (oper == "/") or (oper == "^") then
if string.lower (anum) == "pi" then
anum = math.pi
else
anum = tonumber (anum)
end

if string.lower (bnum) == "pi" then
bnum = math.pi
else
bnum = tonumber (bnum)
end

if oper == "+" then
reslt = anum + bnum
elseif oper == "-" then
reslt = anum - bnum
elseif oper == "*" then
reslt = anum * bnum
elseif oper == "/" then

if bnum == 0 then -- division by zero
commandanswer (nick, getlang (250))

return 0
end

reslt = anum / bnum
elseif oper == "^" then
reslt = anum ^ bnum
end

commandanswer (nick, anum.." "..oper.." "..bnum.." = "..reslt)
else
commandanswer (nick, string.format (getlang (482), "+, -, *, / "..getlang (70).." ^"))
end

else
commandanswer (nick, getlang (481))
end

return 0
end

----- ---- --- -- -

function addauthentry (nick, item)
local user = string.gsub (item, "^(%S+) %d+%.%d+%.%d+%.%d+$", "%1")
local auser = repsqlchars (user)
local _, rows = VH:SQLQuery ("select `badip` from `"..tbl_sql ["auth"].."` where `nick` = '"..auser.."' limit 1")
local ip = string.gsub (item, "^%S+ (%d+%.%d+%.%d+%.%d+)$", "%1")
local aip = repsqlchars (ip)

if rows > 0 then
local _, bip = VH:SQLFetch (0)

if bip == ip then -- reset bad ip when it matches new ip
VH:SQLQuery ("update `"..tbl_sql ["auth"].."` set `ip` = '"..aip.."', `badip` = 'none' where `nick` = '"..auser.."' limit 1")
else
VH:SQLQuery ("update `"..tbl_sql ["auth"].."` set `ip` = '"..aip.."' where `nick` = '"..auser.."' limit 1")
end

commandanswer (nick, string.format (getlang (235), user, ip))
else
VH:SQLQuery ("insert into `"..tbl_sql ["auth"].."` (`nick`, `ip`) values ('"..auser.."', '"..aip.."')")
commandanswer (nick, string.format (getlang (236), user, ip))
end

return 0
end

----- ---- --- -- -

function delauthentry (nick, item)
local aitem = repsqlchars (item)
local _, rows = VH:SQLQuery ("select `bad` from `"..tbl_sql ["auth"].."` where `nick` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["auth"].."` where `nick` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang (237), item))
else
commandanswer (nick, string.format (getlang (238), item))
end

return 0
end

----- ---- --- -- -

function listauthentry (nick)
local _, rows = VH:SQLQuery ("select `nick`, `ip`, `badip`, `good`, `bad` from `"..tbl_sql ["auth"].."` order by `bad` desc, `good` desc")

if rows > 0 then
local anentry = ""
local len = 0
local seclen = 0
local numlen = 0

for x = 0, rows - 1 do
local _, entry, ip, bip, good, bad = VH:SQLFetch (x)

if x == 0 then
len = string.len (good)
seclen = string.len (bad)
numlen = string.len (rows)
end

anentry = anentry.." "..inleadingzeroes (numlen, (x + 1))..". [B: "..inleadingzeroes (seclen, bad).."] [G: "..inleadingzeroes (len, good).."] "..entry.." @ "..ip.." ["..bip.."]\n"
end

commandanswer (nick, getlang (239)..":\n\n"..anentry)
else
commandanswer (nick, getlang (240))
end

return 0
end

----- ---- --- -- -

function authcheck (nick, ucls, uip)
if (table_sets ["authrunning"] == 1) and (uip ~= "[unknown]") then
local anick = repsqlchars (nick)
local _, rows = VH:SQLQuery ("select `ip` from `"..tbl_sql ["auth"].."` where `nick` = '"..anick.."' limit 1")

if rows > 0 then
local _, ip = VH:SQLFetch (0)

if ip == uip then -- match
VH:SQLQuery ("update `"..tbl_sql ["auth"].."` set `good` = `good` + 1 where `nick` = '"..anick.."' limit 1")
opsnotify (table_sets ["classnotiauth"], string.format (getlang (244), nick, uip, ucls))
else
maintouser (nick, table_sets ["authmessage"])
VH:SQLQuery ("update `"..tbl_sql ["auth"].."` set `badip` = '"..repsqlchars (uip).."', `bad` = `bad` + 1 where `nick` = '"..anick.."' limit 1")
VH:CloseConnection (nick) -- drop user
opsnotify (table_sets ["classnotiauth"], string.format (getlang (245), nick, uip, ucls))

return 1
end
end
end

return 0
end

----- ---- --- -- -

function updatescript (nick)
if not table_othsets ["ver_sock"] then -- crappy way of downloading: curl
commandanswer (nick, getlang (229))
--os.execute ("curl \"http://"..table_othsets ["dns_downl"].."/?menu=ledokol&page=ledokol.ver\" --retry 3 --connect-timeout 5 -m 15 -A \"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3\" -o \""..table_othsets ["ledotmpdir"].."ledokol.ver\"")
os.execute ("curl \"http://ledokol.googlecode.com/files/ledokol.ver\" --retry 3 --connect-timeout 5 -m 15 -A \"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3\" -o \""..table_othsets ["ledotmpdir"].."ledokol.ver\"")
local ttmpfile = io.open (table_othsets ["ledotmpdir"].."ledokol.ver", "r")

if ttmpfile then
local line = ttmpfile:read ("*line") -- why cant i use this function after f:seek ("end")?
local fsize = ttmpfile:seek ("end")

if tonumber (fsize) > 0 then
ttmpfile:close ()
os.remove (table_othsets ["ledotmpdir"].."ledokol.ver")
local bver = string.gsub (line, "%.", "")

if tonumber (bver) then
bver = tonumber (bver)
local aver = string.gsub (table_othsets ["ver_ledo"], "%.", "")
aver = tonumber (aver)

if bver > aver then
commandanswer (nick, string.format (getlang (24), line))
--os.execute ("curl \"http://"..table_othsets ["dns_downl"].."/?menu=ledokol&page=ledokol.lua\" --retry 3 --connect-timeout 5 -m 15 -A \"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3\" -o \""..table_othsets ["ledotmpdir"].."ledokol.lua\"")
os.execute ("curl \"http://ledokol.googlecode.com/files/ledokol.lua\" --retry 3 --connect-timeout 5 -m 15 -A \"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3\" -o \""..table_othsets ["ledotmpdir"].."ledokol.lua\"")
ttmpfile = io.open (table_othsets ["ledotmpdir"].."ledokol.lua", "r")

if ttmpfile then
fsize = ttmpfile:seek ("end")

if tonumber (fsize) > 0 then
ttmpfile:close ()
commandanswer (nick, getlang (346))
os.execute ("cp -f "..table_othsets ["ledotmpdir"].."ledokol.lua \""..table_othsets ["dif_vhcfg"].."scripts/\"")
commandanswer (nick, getlang (344))
os.remove (table_othsets ["ledotmpdir"].."ledokol.lua")
commandanswer (nick, getlang (345).."\n\n !luaunload "..table_othsets ["dif_vhcfg"].."scripts/ledokol.lua\n !luaload "..table_othsets ["dif_vhcfg"].."scripts/ledokol.lua\n")
else
commandanswer (nick, getlang (19))
ttmpfile:close ()
os.remove (table_othsets ["ledotmpdir"].."ledokol.lua")
end

else
commandanswer (nick, getlang (16))
end

else
commandanswer (nick, getlang (25))
end

else
commandanswer (nick, getlang (19))
end

else
commandanswer (nick, getlang (19))
ttmpfile:close ()
os.remove (table_othsets ["ledotmpdir"].."ledokol.ver")
end

else
commandanswer (nick, getlang (16))
end

else -- new way of downloading: lua socket
commandanswer (nick, getlang (229))
--tfile, _, _ = lsockhttp.request ("http://"..table_othsets ["dns_downl"].."/?menu=ledokol&page=ledokol.ver") -- download version file
local tfile, _, _ = lsockhttp.request ("http://ledokol.googlecode.com/files/ledokol.ver") -- download version file

if tfile == nil then -- server is down
commandanswer (nick, getlang (16))
elseif string.len (tfile) == 0 then -- version file is not found
commandanswer (nick, getlang (19))
else
local bver = string.gsub (tfile, "%.", "")

if tonumber (bver) then
bver = tonumber (bver)
local aver = string.gsub (table_othsets ["ver_ledo"], "%.", "")
aver = tonumber (aver)

if bver > aver then
commandanswer (nick, string.format (getlang (24), tfile))
tfile = nil -- destroy version file
--tfile, _, _ = lsockhttp.request ("http://"..table_othsets ["dns_downl"].."/?menu=ledokol&page=ledokol.lua") -- try to download script file
local tfile, _, _ = lsockhttp.request ("http://ledokol.googlecode.com/files/ledokol.lua") -- try to download script file

if tfile == nil then -- server is down
commandanswer (nick, getlang (16))
elseif string.len (tfile) == 0 then -- script file is not found
commandanswer (nick, getlang (19))
else
commandanswer (nick, getlang (346))
os.remove (table_othsets ["dif_vhcfg"].."scripts/ledokol.lua") -- remove old script file

_, _, _ = lsockhttp.request { -- download new script file

--url = "http://"..table_othsets ["dns_downl"].."/ledokol/ledokol.lua", 
url = "http://ledokol.googlecode.com/files/ledokol.lua", 
sink = lsockltn12.sink.file (assert (io.open (table_othsets ["dif_vhcfg"].."scripts/ledokol.lua", "a"))) -- into new file

}

commandanswer (nick, getlang (344))
commandanswer (nick, getlang (345).."\n\n !luaunload "..table_othsets ["dif_vhcfg"].."scripts/ledokol.lua\n !luaload "..table_othsets ["dif_vhcfg"].."scripts/ledokol.lua\n")
--commandanswer (nick, string.format (getlang (347), "http://"..table_othsets ["dns_downl"].."/?menu=ledokol&page=download"))
end

else -- no update is required
commandanswer (nick, getlang (25))
end

else -- content of version file is not expected version number
commandanswer (nick, getlang (19))
end
end
end

return 0
end

----- ---- --- -- -

function cleanhistory (nick, limt, autom, cls)
local rows = counttable (tbl_sql ["mchist"])

if rows > 0 then
if limt == 0 then
VH:SQLQuery ("truncate table `"..tbl_sql ["mchist"].."`")
elseif rows > limt then
rows = rows - limt
VH:SQLQuery ("delete from `"..tbl_sql ["mchist"].."` order by `date` asc limit "..rows)
end

if (limt == 0) or (rows > limt) then
commandanswer (nick, string.format (getlang (11), rows))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (15), nick, cls, rows))
end

else

if autom == 0 then
commandanswer (nick, getlang (12))
end
end

rows = counttable (tbl_sql ["ophist"])

if rows > 0 then
if limt == 0 then
VH:SQLQuery ("truncate table `"..tbl_sql ["ophist"].."`")
elseif rows > limt then
rows = rows - limt
VH:SQLQuery ("delete from `"..tbl_sql ["ophist"].."` order by `date` asc limit "..rows)
end

if (limt == 0) or (rows > limt) then
commandanswer (nick, string.format (getlang (13), rows))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (405), nick, cls, rows))
end

else

if autom == 0 then
commandanswer (nick, getlang (14))
end
end

return 0
end

----- ---- --- -- -

function sendmchistory (nick, lnnum, autosend)
local lnn = tonumber (lnnum)

if lnn >= table_sets ["histlimit"] then
lnn = table_sets ["histlimit"]
elseif lnn <= 1 then
lnn = 1
end

local _, rows = VH:SQLQuery ("select `nick`, `date`, `message` from `"..tbl_sql ["mchist"].."` order by `date` desc, `id` desc limit "..lnn)

if rows > 0 then
local aentry = ""

for x = 0, rows - 1 do
local _, user, adate, msg = VH:SQLFetch (x)

if autosend == 1 then -- truncate the message
if string.len (msg) > table_sets ["histautolinemax"] then
msg = string.sub (msg, 1, table_sets ["histautolinemax"]).." [...]"
end
end

aentry = " "..os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate)..": <"..user.."> "..msg.."\n"..aentry
end

if autosend == 0 then
commandanswer (nick, string.format (getlang (17), rows)..":\n\n"..aentry)
else
maintouser (nick, string.format (getlang (17), rows)..":\n\n"..aentry)
end

else

if autosend == 0 then -- only if sending manually
commandanswer (nick, getlang (18))
end
end

return 0
end

----- ---- --- -- -

function sendownhistory (nick, lnnum)
local lnnm = tonumber (lnnum)

if lnnm >= table_sets ["histlimit"] then
lnnm = table_sets ["histlimit"]
elseif lnnm < 1 then
lnnm = 1
end

local _, rows = VH:SQLQuery ("select `nick`, `date`, `message` from `"..tbl_sql ["mchist"].."` where `realnick` = '"..repsqlchars (nick).."' order by `date` desc, `id` desc limit "..lnnm)

if rows > 0 then
local aentry = ""

for x = 0, rows - 1 do
local _, user, adate, msg = VH:SQLFetch (x)
aentry = " "..os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate)..": <"..user.."> "..msg.."\n"..aentry
end

commandanswer (nick, string.format (getlang (463), rows)..":\n\n"..aentry)
else
commandanswer (nick, getlang (462))
end

return 0
end

----- ---- --- -- -

function sendophistory (nick, lnnum)
local lnnm = tonumber (lnnum)

if lnnm >= table_sets ["histlimit"] then
lnnm = table_sets ["histlimit"]
elseif lnnm < 1 then
lnnm = 1
end

local _, rows = VH:SQLQuery ("select `nick`, `date`, `message` from `"..tbl_sql ["ophist"].."` order by `date` desc, `id` desc limit "..lnnm)

if rows > 0 then
local aentry = ""

for x = 0, rows - 1 do
local _, user, adate, msg = VH:SQLFetch (x)
aentry = " "..os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate)..": <"..user.."> "..msg.."\n"..aentry
end

commandanswer (nick, string.format (getlang (21), rows)..":\n\n"..aentry)
else
commandanswer (nick, getlang (22))
end

return 0
end

----- ---- --- -- -

function addmchistoryline (nick, realnick, line)
if table_sets ["histlimit"] == 0 then return 0 end
if (nick == table_othsets ["sendfrom"]) and (table_sets ["histbotmsg"] == 0) then return 0 end
local _, rows = VH:SQLQuery ("select `date` from `"..tbl_sql ["mchist"].."` order by `date` asc")
local ndate = os.time () + table_sets ["srvtimediff"] -- current system time
local rnick = repsqlchars (nick)
local repnick = repsqlchars (realnick)
local str = string.gsub (line, "is kicking", "is"..string.char (160).."kicking")
str = repsqlchars (str)

if rows > 0 then
if rows >= table_sets ["histlimit"] then
local _, adate = VH:SQLFetch (0)
VH:SQLQuery ("update `"..tbl_sql ["mchist"].."` set `realnick` = '"..repnick.."', `nick` = '"..rnick.."', `date` = '"..ndate.."', `message` = '"..str.."' where `date` = '"..adate.."' limit 1")
else
VH:SQLQuery ("insert into `"..tbl_sql ["mchist"].."` (`realnick`, `nick`, `date`, `message`) values ('"..repnick.."', '"..rnick.."', '"..ndate.."', '"..str.."')")
end

else
VH:SQLQuery ("insert into `"..tbl_sql ["mchist"].."` (`realnick`, `nick`, `date`, `message`) values ('"..repnick.."', '"..rnick.."', '"..ndate.."', '"..str.."')")
end

return 0
end

----- ---- --- -- -

function addophistoryline (nick, line)
if table_sets ["histlimit"] == 0 then return 0 end
if string.sub (line, 1, 1) == "+" then return 0 end -- skip a chatroom command
local _, rows = VH:SQLQuery ("select `date` from `"..tbl_sql ["ophist"].."` order by `date` asc")
local ndate = os.time () + table_sets ["srvtimediff"] -- current system time
local rnick = repsqlchars (nick)
local str = repsqlchars (line)

if rows > 0 then
if rows >= table_sets ["histlimit"] then
local _, adate = VH:SQLFetch (0)
VH:SQLQuery ("update `"..tbl_sql ["ophist"].."` set `nick` = '"..rnick.."', `date` = '"..ndate.."', `message` = '"..str.."' where `date` = '"..adate.."' limit 1")
else
VH:SQLQuery ("insert into `"..tbl_sql ["ophist"].."` (`nick`, `date`, `message`) values ('"..rnick.."', '"..ndate.."', '"..str.."')")
end

else
VH:SQLQuery ("insert into `"..tbl_sql ["ophist"].."` (`nick`, `date`, `message`) values ('"..rnick.."', '"..ndate.."', '"..str.."')")
end

return 0
end

----- ---- --- -- -

function sendoffmsg (from, line, ucls)
local to = string.gsub (line, "^(%S+) .+$", "%1")

if string.lower (to) == string.lower (from) then
commandanswer (from, getlang (26))
elseif isbot (to) == 1 then
commandanswer (from, getlang (139))
else
local msg = string.gsub (line, "^%S+ (.+)$", "%1")
local uip = getip (from)
local tsts = getstatus (to)

if antiscan (from, ucls, msg, 3, to, tsts) == 1 then
if tsts == 1 then
offlinepm (from, to, msg)
commandanswer (from, string.format (getlang (27), to))
else
local ndate = os.time () + table_sets ["srvtimediff"] -- current system time
VH:SQLQuery ("insert into `"..tbl_sql ["off"].."` (`from`, `ip`, `to`, `date`, `message`) values ('"..repsqlchars (from).."', '"..uip.."', '"..repsqlchars (to).."', '"..ndate.."', '"..repsqlchars (msg).."')")
commandanswer (from, string.format (getlang (28), to))
opsnotify (table_sets ["classnotioff"], string.format (getlang (29), from, uip, ucls))
end
end
end

return 0
end

----- ---- --- -- -

function autosendoffmsg (to, ucls, tip)
if table_sets ["offmsgclass"] ~= 11 then
local user = repsqlchars (to)
local _, rows = VH:SQLQuery ("select `from`, `date`, `message` from `"..tbl_sql ["off"].."` where `to` = '"..user.."' order by `date` asc, `from` asc")

if rows > 0 then
for x = 0, rows - 1 do
local _, from, adate, msg = VH:SQLFetch (x)
offlinepm (from, to, string.format (getlang (33), os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate))..":\n\n"..msg.."\n")
local sts = ""

if getstatus (from) == 0 then
sts = getlang (31)
else
sts = getlang (32)
end

offlinepm (from, to, getlang (34)..": "..sts)
end

opsnotify (table_sets ["classnotioff"], string.format (getlang (35), to, tip, ucls))
VH:SQLQuery ("delete from `"..tbl_sql ["off"].."` where `to` = '"..user.."'") -- remove all stored message to that user
end
end

return 0
end

----- ---- --- -- -

function listoffline (nick)
local _, rows = VH:SQLQuery ("select `from`, `ip`, `date` from `"..tbl_sql ["off"].."` order by `date` asc, `from` asc")

if rows > 0 then
local anentry = ""
local len = 0

for x = 0, rows - 1 do
local _, from, ip, adate = VH:SQLFetch (x)

if x == 0 then
len = string.len (rows)
end

anentry = anentry.." "..inleadingzeroes (len, (x + 1))..". [D: "..os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], adate).."] "..from.." @ "..ip.."\n"
end

commandanswer (nick, getlang (36)..":\n\n"..anentry)
else
commandanswer (nick, getlang (37))
end

return 0
end

----- ---- --- -- -

function deloffline (nick, adate)
local _, rows = VH:SQLQuery ("select `date` from `"..tbl_sql ["off"].."`")
local table_delete = {}

if rows > 0 then
for x = 0, rows - 1 do
local _, zdate = VH:SQLFetch (x)

if string.find (os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], zdate), repdatechars (adate)) then
table_delete [zdate] = x -- entries with same date will be overwritten
end
end

else
commandanswer (nick, getlang (37))

return 0
end

for k, _ in pairs (table_delete) do
VH:SQLQuery ("delete from `"..tbl_sql ["off"].."` where `date` = '"..repsqlchars (k).."'") -- dont set limit because there might be few rows
end

local num = table.getn (table_delete)

if num > 0 then
commandanswer (nick, string.format (getlang (38), num))
else
commandanswer (nick, string.format (getlang (39), adate))
end

return 0
end

----- ---- --- -- -

function cleanoffline (nick, cls)
rows = counttable (tbl_sql ["off"])

if rows > 0 then
VH:SQLQuery ("truncate table `"..tbl_sql ["off"].."`")
commandanswer (nick, string.format (getlang (38), rows))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (40), nick, cls))
else
commandanswer (nick, getlang (41))
end

return 0
end

----- ---- --- -- -

function checknick (nick, ucls, aip)
if table_sets ["michnick"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl_sql ["minick"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = string.lower (repnmdcinchars (nick))

for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["minick"].."` set `occurred` = `occurred` + 1 where `nick` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["miex"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["miex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang (43), nick, aip, ucls, nick))

return 0
end
end
end

local rsn = string.gsub (table_sets ["minickmessage"], "%*", reprexpchars (nick))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checkdesc (nick, desc, ucls, aip)
if table_sets ["michdesc"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `description` from `"..tbl_sql ["midesc"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = string.lower (repnmdcinchars (desc))

for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["midesc"].."` set `occurred` = `occurred` + 1 where `description` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["miex"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["miex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang (45), nick, aip, ucls, desc))

return 0
end
end
end

local rsn = string.gsub (table_sets ["midescmessage"], "%*", reprexpchars (desc))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checktag (nick, tag, ucls, aip)
if table_sets ["michtag"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `tag` from `"..tbl_sql ["mitag"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = string.lower (repnmdcinchars (tag))

for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["mitag"].."` set `occurred` = `occurred` + 1 where `tag` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["miex"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["miex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..(entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang (47), nick, aip, ucls, tag))

return 0
end
end
end

local rsn = string.gsub (table_sets ["mitagmessage"], "%*", reprexpchars (tag))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checkconn (nick, conn, ucls, aip)
if table_sets ["michconn"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `connection` from `"..tbl_sql ["miconn"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = string.lower (repnmdcinchars (conn))

for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["miconn"].."` set `occurred` = `occurred` + 1 where `connection` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["miex"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["miex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang (49), nick, aip, ucls, conn))

return 0
end
end
end

local rsn = string.gsub (table_sets ["miconnmessage"], "%*", reprexpchars (conn))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checkemail (nick, email, ucls, aip)
if table_sets ["michemail"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `email` from `"..tbl_sql ["miemail"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = string.lower (repnmdcinchars (email))

for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["miemail"].."` set `occurred` = `occurred` + 1 where `email` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["miex"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["miex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang (51), nick, aip, ucls, email))

return 0
end
end
end

local rsn = string.gsub (table_sets ["miemailmessage"], "%*", reprexpchars (email))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checkshare (nick, share, ucls, aip)
if table_sets ["michshare"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `share` from `"..tbl_sql ["mishare"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = repnmdcinchars (share)

for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["mishare"].."` set `occurred` = `occurred` + 1 where `share` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["miex"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["miex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang (53), nick, aip, ucls, share))

return 0
end
end
end

local rsn = string.gsub (table_sets ["misharemessage"], "%*", reprexpchars (share))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checkip (nick, aip, ucls)
if table_sets ["michip"] == 0 then return 0 end
local _, rows = VH:SQLQuery ("select `share` from `"..tbl_sql ["miip"].."` order by `occurred` desc")

if rows > 0 then
local lowtxt = repnmdcinchars (aip)

for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["miip"].."` set `occurred` = `occurred` + 1 where `share` = '"..repsqlchars (entry).."' limit 1")
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["miex"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
VH:SQLQuery ("update `"..tbl_sql ["miex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang (354), nick, aip, ucls, aip))

return 0
end
end
end

local rsn = string.gsub (table_sets ["miipmessage"], "%*", reprexpchars (aip))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end

return 0
end

----- ---- --- -- -

function checkfake (nick, share, ucls, aip)
if (table_sets ["michfake"] == 1) and (share >= 1048576) then -- skip users with share smaller than one mb
if (string.find (share, "00000000")) or (string.find (share, "11111111")) or (string.find (share, "22222222")) or (string.find (share, "33333333")) or (string.find (share, "44444444")) or (string.find (share, "55555555")) or (string.find (share, "66666666")) or (string.find (share, "77777777")) or (string.find (share, "88888888")) or (string.find (share, "99999999")) or (not string.find (tostring (share / 1048576), "%.")) or (not string.find (tostring (share / 1073741824), "%.")) or (not string.find (tostring (share / 1099511627776), "%.")) then
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["miex"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (repnmdcinchars (share), entry) then
VH:SQLQuery ("update `"..tbl_sql ["miex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang (449), nick, aip, ucls, share.." "..getlang (365)))

return 0
end
end
end

local rsn = string.gsub (table_sets ["mifakemessage"], "%*", reprexpchars (share.." "..getlang (365)))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end

return 0
end

----- ---- --- -- -

function checkclone (nick, share, aip, ucls)
if (table_sets ["michclone"] == 1) and (share > 0) and (aip ~= "[unknown]") then -- skip zero byte users
local nl = getnicklist ()

for user in string.gmatch (nl, "([^$]+)%$%$") do
if (user ~= nick) and (getclass (user) < table_sets ["scanbelowclass"]) then -- skip user himself and if second user is protected
if (parsemyinfoshare (getmyinfo (user)) == share) and (getip (user) == aip) then -- exact share and ip match
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["miex"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (repnmdcinchars (share), entry) or string.find (repnmdcinchars (aip), entry) then
VH:SQLQuery ("update `"..tbl_sql ["miex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang (450), nick, aip, ucls, user))

return 0
end
end
end

local rsn = string.gsub (table_sets ["miclonemessage"], "%*", reprexpchars (user))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end
end

return 0
end

----- ---- --- -- -

function checksameip (nick, ip, ucls)
if (table_sets ["michsameip"] == 1) and (ip ~= "[unknown]") then -- skip users with unknown ip
local nl = getnicklist ()

for user in string.gmatch (nl, "([^$]+)%$%$") do
if (user ~= nick) and (getclass (user) < table_sets ["scanbelowclass"]) then -- skip user himself and if second user is protected
if getip (user) == ip then -- exact ip match
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["miex"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (repnmdcinchars (ip), entry) then
VH:SQLQuery ("update `"..tbl_sql ["miex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (entry).."' limit 1")
opsnotify (table_sets ["classnotiex"], string.format (getlang (451), nick, ip, ucls, user))

return 0
end
end
end

local rsn = string.gsub (table_sets ["misameipmessage"], "%*", reprexpchars (user))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["mitbantime"])

return 1
end
end
end
end

return 0
end

----- ---- --- -- -

function parsemyinfoshare (myinfo) -- 3.0
local _, _, share = string.find (myinfo, "^%$MyINFO %$ALL %S+ .*%$.*%$.*%$.*%$(.*)%$$")
if tonumber (share) then share = tonumber (share) else share = 0 end

return share
end

----- ---- --- -- -

function parsemyinfo (myinfo) -- 3.0
local _, _, desc, conn, email, share = string.find (myinfo, "^%$MyINFO %$ALL %S+ (.*)%$.*%$(.*)%$(.*)%$(.*)%$$")
local tag = ""
conn = string.sub (conn, 1, string.len (conn) - 1)
local len = string.len (desc)

for x = len, 1, -1 do
if (string.sub (desc, x, x) == "<") and (string.sub (desc, len, -1) == ">") then
tag = string.sub (desc, x, -1)
desc = string.sub (desc, 1, x - 1)
break
end
end

desc = desc or ""
tag = tag or ""
conn = conn or ""
email = email or ""
if tonumber (share) then share = tonumber (share) else share = 0 end

return desc, tag, conn, email, share
end

----- ---- --- -- -

function addmyinfoentry (nick, line)
local part = string.gsub (line, "^(%S+) (.+)$", "%1")
local item = string.gsub (line, "^(%S+) (.+)$", "%2")
local entry = repsqlchars (repnmdcinchars (item))

if part == "nick" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["minick"].."` where `nick` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (56), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["minick"].."` (`nick`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (57), item))
end

elseif part == "desc" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["midesc"].."` where `description` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (58), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["midesc"].."` (`description`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (59), item))
end

elseif part == "tag" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["mitag"].."` where `tag` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (60), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["mitag"].."` (`tag`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (61), item))
end

elseif part == "conn" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["miconn"].."` where `connection` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (62), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["miconn"].."` (`connection`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (63), item))
end

elseif part == "email" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["miemail"].."` where `email` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (64), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["miemail"].."` (`email`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (65), item))
end

elseif part == "share" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["mishare"].."` where `share` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (66), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["mishare"].."` (`share`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (67), item))
end

elseif part == "ip" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["miip"].."` where `ip` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (348), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["miip"].."` (`ip`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (349), item))
end

elseif part == "ex" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["miex"].."` where `exception` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (68), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["miex"].."` (`exception`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (69), item))
end

else
commandanswer (nick, string.format (getlang (100), "nick, desc, tag, conn, email, share, ip "..getlang (70).." ex"))
end

return 0
end

----- ---- --- -- -

function delmyinfoentry (nick, line)
local part = string.gsub (line, "^(%S+) (.+)$", "%1")
local item = string.gsub (line, "^(%S+) (.+)$", "%2")
local entry = repsqlchars (repnmdcinchars (item))

if part == "nick" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["minick"].."` where `nick` = '"..entry.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["minick"].."` where `nick` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang (71), item))
else
commandanswer (nick, string.format (getlang (72), item))
end

elseif part == "desc" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["midesc"].."` where `description` = '"..entry.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["midesc"].."` where `description` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang (73), item))
else
commandanswer (nick, string.format (getlang (74), item))
end

elseif part == "tag" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["mitag"].."` where `tag` = '"..entry.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["mitag"].."` where `tag` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang (75), item))
else
commandanswer (nick, string.format (getlang (76), item))
end

elseif part == "conn" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["miconn"].."` where `connection` = '"..entry.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["miconn"].."` where `connection` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang (77), item))
else
commandanswer (nick, string.format (getlang (78), item))
end

elseif part == "email" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["miemail"].."` where `email` = '"..entry.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["miemail"].."` where `email` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang (79), item))
else
commandanswer (nick, string.format (getlang (80), item))
end

elseif part == "share" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["mishare"].."` where `share` = '"..entry.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["mishare"].."` where `share` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang (81), item))
else
commandanswer (nick, string.format (getlang (82), item))
end

elseif part == "ip" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["miip"].."` where `ip` = '"..entry.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["miip"].."` where `ip` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang (350), item))
else
commandanswer (nick, string.format (getlang (351), item))
end

elseif part == "ex" then
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["miex"].."` where `exception` = '"..entry.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["miex"].."` where `exception` = '"..entry.."' limit 1")
commandanswer (nick, string.format (getlang (83), item))
else
commandanswer (nick, string.format (getlang (84), item))
end

else -- unknown type
commandanswer (nick, string.format (getlang (100), "nick, desc, tag, conn, email, share, ip "..getlang (70).." ex"))
end

return 0
end

----- ---- --- -- -

function listmyinfoentry (nick, part)
local rows, lsttxt, nolsttxt = 0, "", ""

if part == "nick" then
_, rows = VH:SQLQuery ("select `nick`, `occurred` from `"..tbl_sql ["minick"].."` order by `occurred` desc")
lsttxt = getlang (85)
nolsttxt = getlang (86)

elseif part == "desc" then
_, rows = VH:SQLQuery ("select `description`, `occurred` from `"..tbl_sql ["midesc"].."` order by `occurred` desc")
lsttxt = getlang (87)
nolsttxt = getlang (88)

elseif part == "tag" then
_, rows = VH:SQLQuery ("select `tag`, `occurred` from `"..tbl_sql ["mitag"].."` order by `occurred` desc")
lsttxt = getlang (89)
nolsttxt = getlang (90)

elseif part == "conn" then
_, rows = VH:SQLQuery ("select `connection`, `occurred` from `"..tbl_sql ["miconn"].."` order by `occurred` desc")
lsttxt = getlang (91)
nolsttxt = getlang (92)

elseif part == "email" then
_, rows = VH:SQLQuery ("select `email`, `occurred` from `"..tbl_sql ["miemail"].."` order by `occurred` desc")
lsttxt = getlang (93)
nolsttxt = getlang (94)

elseif part == "share" then
_, rows = VH:SQLQuery ("select `share`, `occurred` from `"..tbl_sql ["mishare"].."` order by `occurred` desc")
lsttxt = getlang (95)
nolsttxt = getlang (96)

elseif part == "ip" then
_, rows = VH:SQLQuery ("select `ip`, `occurred` from `"..tbl_sql ["miip"].."` order by `occurred` desc")
lsttxt = getlang (352)
nolsttxt = getlang (353)

elseif part == "ex" then
_, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..tbl_sql ["miex"].."` order by `occurred` desc")
lsttxt = getlang (97)
nolsttxt = getlang (98)

else -- unknown type
lsttxt = nil
commandanswer (nick, string.format (getlang (100), "nick, desc, tag, conn, email, share, ip "..getlang (70).." ex"))
end

if lsttxt then
if rows > 0 then
local anentry = ""
local len = 0
local numlen = 0

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

anentry = anentry.." "..inleadingzeroes (numlen, (x + 1))..". [O: "..inleadingzeroes (len, occurred).."] "..repnmdcoutchars (entry).."\n"
end

commandanswer (nick, lsttxt..":\n\n"..anentry)
else
commandanswer (nick, nolsttxt)
end
end

return 0
end

----- ---- --- -- -

function cleanuptable (nick, line, cls)
local ctype = string.gsub (line, "^(%S+) (%d+).*$", "%1")
local cdays = string.gsub (line, "^(%S+) (%d+).*$", "%2")
local seconds = os.difftime (os.time (), tonumber (cdays) * 24 * 3600)

if ctype == "kick" then
commandanswer (nick, getlang (3))
local _, rows = VH:SQLQuery ("select `is_drop` from `kicklist` where `time` < '"..seconds.."'")

if rows > 0 then
VH:SQLQuery ("delete from `kicklist` where `time` < '"..seconds.."'")
commandanswer (nick, string.format (getlang (99), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (8), nick, cls, rows, cdays))
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleankicks' limit 1") -- update
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..cdays.."' where `variable` = 'dayscleankicks' limit 1")
else
commandanswer (nick, string.format (getlang (101), ctype))
end

elseif ctype == "ban" then
commandanswer (nick, getlang (3))
local _, rows = VH:SQLQuery ("select `ban_type` from `banlist` where `date_start` < '"..seconds.."'")

if rows > 0 then
VH:SQLQuery ("delete from `banlist` where `date_start` < '"..seconds.."'")
commandanswer (nick, string.format (getlang (99), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (7), nick, cls, rows, cdays))
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanbans' limit 1") -- update
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..cdays.."' where `variable` = 'dayscleanbans' limit 1")
else
commandanswer (nick, string.format (getlang (101), ctype))
end

elseif ctype == "unban" then
commandanswer (nick, getlang (3))
local _, rows = VH:SQLQuery ("select `ban_type` from `unbanlist` where `date_start` < '"..seconds.."'")

if rows > 0 then
VH:SQLQuery ("delete from `unbanlist` where `date_start` < '"..seconds.."'")
commandanswer (nick, string.format (getlang (99), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (6), nick, cls, rows, cdays))
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanunbans' limit 1") -- update
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..cdays.."' where `variable` = 'dayscleanunbans' limit 1")
else
commandanswer (nick, string.format (getlang (101), ctype))
end

elseif ctype == "reg" then
commandanswer (nick, getlang (332))

elseif ctype == "iplog" then
commandanswer (nick, getlang (3))
local _, rows = VH:SQLQuery ("select `id` from `pi_iplog` where `date` < '"..seconds.."'")

if rows > 0 then
VH:SQLQuery ("delete from `pi_iplog` where `date` < '"..seconds.."'")
commandanswer (nick, string.format (getlang (99), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (5), nick, cls, rows, cdays))
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleaniplog' limit 1") -- update
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..cdays.."' where `variable` = 'dayscleaniplog' limit 1")
else
commandanswer (nick, string.format (getlang (101), ctype))
end

elseif ctype == "stats" then
commandanswer (nick, getlang (3))
local _, rows = VH:SQLQuery ("select `realtime` from `pi_stats` where `realtime` < '"..seconds.."'")

if rows > 0 then
VH:SQLQuery ("delete from `pi_stats` where `realtime` < '"..seconds.."'")
commandanswer (nick, string.format (getlang (99), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (148), nick, cls, rows, cdays))
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanstats' limit 1") -- update
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..cdays.."' where `variable` = 'dayscleanstats' limit 1")
else
commandanswer (nick, string.format (getlang (101), ctype))
end

elseif ctype == "ulog" then
commandanswer (nick, getlang (3))
local _, rows = VH:SQLQuery ("select `id` from `"..tbl_sql ["ulog"].."` where `time` < '"..seconds.."'")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["ulog"].."` where `time` < '"..seconds.."'")
commandanswer (nick, string.format (getlang (99), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (167), nick, cls, rows, cdays))
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanusrlog' limit 1") -- update
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..cdays.."' where `variable` = 'limcleanusrlog' limit 1")
else
commandanswer (nick, string.format (getlang (101), ctype))
end

else -- unknown type
commandanswer (nick, string.format (getlang (100), "kick, ban, unban, reg, iplog, stats "..getlang (70).." ulog"))
end

return 0
end

----- ---- --- -- -

function altcleanuptable (nick, line, cls)
if string.find (line, "^%S+ %d+ %-%d$") then -- fucking lua regular expression doesnt take -1 as a number
ctype = string.gsub (line, "^(%S+) (%d+) (%-%d)$", "%1")
cdays = string.gsub (line, "^(%S+) (%d+) (%-%d)$", "%2")
altvar = string.gsub (line, "^(%S+) (%d+) (%-%d)$", "%3")
else
ctype = string.gsub (line, "^(%S+) (%d+) (%d+)$", "%1")
cdays = string.gsub (line, "^(%S+) (%d+) (%d+)$", "%2")
altvar = string.gsub (line, "^(%S+) (%d+) (%d+)$", "%3")
end

cdays = tonumber (cdays)
altvar = tonumber (altvar)
seconds = cdays * 24 * 3600
seconds = os.time () - seconds

if ctype == "reg" then
if (altvar == 10) or (altvar == 5) or (altvar == 4) or (altvar == 3) or (altvar == 2) or (altvar == 1) or (altvar == 0) or (altvar == -1) then
commandanswer (nick, getlang (3))
local rows = 0

if cdays == 0 then
_, rows = VH:SQLQuery ("select `nick` from `reglist` where `login_last` is null and `class` = '"..altvar.."'")
else
_, rows = VH:SQLQuery ("select `nick` from `reglist` where `login_last` is not null and `login_last` < '"..seconds.."' and `class` = '"..altvar.."'")
end

if rows > 0 then
anick = ""

for x = 0, rows - 1 do
local _, user = VH:SQLFetch (x)

if x == 0 then
numlen = string.len (rows)
end

anick = anick.." "..inleadingzeroes (numlen, (x + 1))..". "..user.."\n"
end

if cdays == 0 then
VH:SQLQuery ("delete from `reglist` where `login_last` is null and `class` = '"..altvar.."'")
else
VH:SQLQuery ("delete from `reglist` where `login_last` is not null and `login_last` < '"..seconds.."' and `class` = '"..altvar.."'")
end

commandanswer (nick, string.format (getlang (334), rows, altvar)..":\n\n"..anick)
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (335), nick, cls, rows, altvar, cdays))
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanregs' limit 1") -- update
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..cdays.."' where `variable` = 'dayscleanregs' limit 1")
else
commandanswer (nick, string.format (getlang (101), ctype))
end

else
commandanswer (nick, string.format (getlang (143), "-1, 0, 1, 2, 3, 4, 5 "..getlang (70).." 10"))
end

else -- redirect to another type
cleanuptable (nick, line)
end

return 0
end

----- ---- --- -- -

function chatrankaccept (nick, ucls)
if ucls < table_sets ["chatrankclass"] then return 0 end
local usr = repsqlchars (nick)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl_sql ["ranex"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["ranex"].."` set `occurred` = `occurred` + 1 where `nick` = '"..usr.."' limit 1")
else
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["chran"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["chran"].."` set `rank` = `rank` + 1 where `nick` = '"..usr.."' limit 1")
else
VH:SQLQuery ("insert into `"..tbl_sql ["chran"].."` (`nick`) values ('"..usr.."')")
end
end

return 0
end

----- ---- --- -- -

function sharerankaccept (nick, share, ucls)
if ucls < table_sets ["sharerankclass"] then return 0 end
if share < (table_sets ["shareranmin"] * 1073741824) then return 0 end -- dont count users without share
local usr = repsqlchars (nick)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl_sql ["ranex"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["ranex"].."` set `occurred` = `occurred` + 1 where `nick` = '"..usr.."' limit 1")
else
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["shran"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
local _, rank = VH:SQLFetch (0)

if share > tonumber (rank) then -- only if new share is bigger
VH:SQLQuery ("update `"..tbl_sql ["shran"].."` set `rank` = '"..share.."' where `nick` = '"..usr.."' limit 1")
end

else
VH:SQLQuery ("insert into `"..tbl_sql ["shran"].."` (`nick`, `rank`) values ('"..usr.."', '"..share.."')")
end
end

return 0
end

----- ---- --- -- -

function oprankaccept (nick, ucls)
if ucls < table_sets ["oprankclass"] then return 0 end
local usr = repsqlchars (nick)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl_sql ["ranex"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["ranex"].."` set `occurred` = `occurred` + 1 where `nick` = '"..usr.."' limit 1")
else
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["opran"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["opran"].."` set `rank` = `rank` + 1 where `nick` = '"..usr.."' limit 1")
else
VH:SQLQuery ("insert into `"..tbl_sql ["opran"].."` (`nick`) values ('"..usr.."')")
end
end

return 0
end

----- ---- --- -- -

function wordrankaccept (nick, ucls, line)
if ucls < table_sets ["wordrankclass"] then return 0 end
local usr = repsqlchars (nick)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl_sql ["ranex"].."` where `nick` = '"..usr.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["ranex"].."` set `occurred` = `occurred` + 1 where `nick` = '"..usr.."' limit 1")
else
local str = repwordranchars (repnmdcinchars (line), 0).."$"

for aword in string.gmatch (str, "([^$]+)%$") do
aword = repwordranchars (aword, 1)
local stlen = string.len (aword)

if (stlen >= table_sets ["wordranmin"]) and (stlen <= table_sets ["wordranmax"]) then
aword = repsqlchars (aword)
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["wdran"].."` where `word` = '"..aword.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["wdran"].."` set `rank` = `rank` + 1 where `word` = '"..aword.."' limit 1")
else
VH:SQLQuery ("insert into `"..tbl_sql ["wdran"].."` (`word`) values ('"..aword.."')")
end
end
end
end

return 0
end

----- ---- --- -- -

function cleanwordrank (limit, maxi)
local _, rows = VH:SQLQuery ("select `word` from `"..tbl_sql ["wdran"].."`")

if rows > 0 then
local table_delete = {}

for x = 0, rows - 1 do
local _, aword = VH:SQLFetch (x)

if maxi == 0 then
if string.len (aword) < limit then
table_delete [aword] = x
end

else

if string.len (aword) > limit then
table_delete [aword] = x
end
end
end

for k, _ in pairs (table_delete) do
VH:SQLQuery ("delete from `"..tbl_sql ["wdran"].."` where `word` = '"..repsqlchars (k).."' limit 1")
end
end

return 0
end

----- ---- --- -- -

function delrank (nick, line)
local ctype = string.gsub (line, "^(%S+) (%S+)$", "%1")
local cuser = string.gsub (line, "^(%S+) (%S+)$", "%2")
local auser = repsqlchars (cuser)

if ctype == "chat" then
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["chran"].."` where `nick` = '"..auser.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["chran"].."` where `nick` = '"..auser.."' limit 1")
commandanswer (nick, string.format (getlang (105), cuser))
else
commandanswer (nick, string.format (getlang (106), cuser))
end

elseif ctype == "share" then
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["shran"].."` where `nick` = '"..auser.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["shran"].."` where `nick` = '"..auser.."' limit 1")
commandanswer (nick, string.format (getlang (321), cuser))
else
commandanswer (nick, string.format (getlang (322), cuser))
end

elseif ctype == "op" then
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["opran"].."` where `nick` = '"..auser.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["opran"].."` where `nick` = '"..auser.."' limit 1")
commandanswer (nick, string.format (getlang (107), cuser))
else
commandanswer (nick, string.format (getlang (108), cuser))
end

elseif ctype == "word" then
auser = repnmdcinchars (auser)
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["wdran"].."` where `word` = '"..auser.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["wdran"].."` where `word` = '"..auser.."' limit 1")
commandanswer (nick, string.format (getlang (440), cuser))
else
commandanswer (nick, string.format (getlang (441), cuser))
end

elseif ctype == "all" then
delrank (nick, "chat "..cuser)
delrank (nick, "share "..cuser)
delrank (nick, "op "..cuser)

else -- unknown type
commandanswer (nick, string.format (getlang (100), "chat, share, op, word "..getlang (70).." all"))
end

return 0
end

----- ---- --- -- -

function cleanupranks (nick, line, cls)
local ctype = string.gsub (line, "^(%S+) (%d+)$", "%1")
local climt = string.gsub (line, "^(%S+) (%d+)$", "%2")
local climt = tonumber (climt)

if ctype == "chat" then
commandanswer (nick, getlang (3))
local rows = 0

if climt == 0 then
rows = counttable (tbl_sql ["chran"])
else
_, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["chran"].."` where `rank` < '"..climt.."'")
end

if rows > 0 then
if climt == 0 then
VH:SQLQuery ("truncate table `"..tbl_sql ["chran"].."`")
else
VH:SQLQuery ("delete from `"..tbl_sql ["chran"].."` where `rank` < '"..climt.."'")
end

commandanswer (nick, string.format (getlang (99), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (374), nick, cls, rows, climt))
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanchrank' limit 1") -- update
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..climt.."' where `variable` = 'limcleanchrank' limit 1")
else
commandanswer (nick, string.format (getlang (101), ctype))
end

elseif ctype == "share" then
commandanswer (nick, getlang (3))
local rows = 0

if climt == 0 then
rows = counttable (tbl_sql ["shran"])
else
cbytes = climt * 1073741824
cbytes = roundint (cbytes, 0)
_, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["shran"].."` where `rank` < '"..cbytes.."'")
end

if rows > 0 then
if climt == 0 then
VH:SQLQuery ("truncate table `"..tbl_sql ["shran"].."`")
else
VH:SQLQuery ("delete from `"..tbl_sql ["shran"].."` where `rank` < '"..cbytes.."'")
end

commandanswer (nick, string.format (getlang (99), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (375), nick, cls, rows, climt))
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanshrank' limit 1") -- update
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..climt.."' where `variable` = 'limcleanshrank' limit 1")
else
commandanswer (nick, string.format (getlang (101), ctype))
end

elseif ctype == "op" then
commandanswer (nick, getlang (3))
local rows = 0

if climt == 0 then
rows = counttable (tbl_sql ["opran"])
else
_, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["opran"].."` where `rank` < '"..climt.."'")
end

if rows > 0 then
if climt == 0 then
VH:SQLQuery ("truncate table `"..tbl_sql ["opran"].."`")
else
VH:SQLQuery ("delete from `"..tbl_sql ["opran"].."` where `rank` < '"..climt.."'")
end

commandanswer (nick, string.format (getlang (99), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (376), nick, cls, rows, climt))
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanoprank' limit 1") -- update
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..climt.."' where `variable` = 'limcleanoprank' limit 1")
else
commandanswer (nick, string.format (getlang (101), ctype))
end

elseif ctype == "word" then
commandanswer (nick, getlang (3))
local rows = 0

if climt == 0 then
rows = counttable (tbl_sql ["wdran"])
else
_, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["wdran"].."` where `rank` < '"..climt.."'")
end

if rows > 0 then
if climt == 0 then
VH:SQLQuery ("truncate table `"..tbl_sql ["wdran"].."`")
else
VH:SQLQuery ("delete from `"..tbl_sql ["wdran"].."` where `rank` < '"..climt.."'")
end

commandanswer (nick, string.format (getlang (99), rows, ctype))
opsnotify (table_sets ["classnotiledoact"], string.format (getlang (442), nick, cls, rows, climt))
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..os.date (table_sets ["dateformat"]).."' where `variable` = 'lastcleanwordrank' limit 1") -- update
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..climt.."' where `variable` = 'limcleanwordrank' limit 1")
else
commandanswer (nick, string.format (getlang (101), ctype))
end

else -- unknown type
commandanswer (nick, string.format (getlang (100), "chat, share, op "..getlang (70).." word"))
end

return 0
end

----- ---- --- -- -

function chatranksendown (nick)
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["chran"].."` where `nick` = '"..repsqlchars (nick).."' limit 1")

if rows > 0 then
local _, rank = VH:SQLFetch (0)
commandanswer (nick, string.format (getlang (110), rank))
else
commandanswer (nick, getlang (111))
end

return 0
end

----- ---- --- -- -

function shareranksendown (nick)
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["shran"].."` where `nick` = '"..repsqlchars (nick).."' limit 1")

if rows > 0 then
local _, rank = VH:SQLFetch (0)
commandanswer (nick, string.format (getlang (327), makesize (rank)))
else
commandanswer (nick, string.format (getlang (325), table_sets ["shareranmin"].." "..getlang (362)))
end

return 0
end

----- ---- --- -- -

function opranksendown (nick)
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["opran"].."` where `nick` = '"..repsqlchars (nick).."' limit 1")

if rows > 0 then
local _, rank = VH:SQLFetch (0)
commandanswer (nick, string.format (getlang (114), rank))
else
commandanswer (nick, getlang (115))
end

return 0
end

----- ---- --- -- -

function chatranksendall (nick)
local _, rows = VH:SQLQuery ("select `nick`, `rank` from `"..tbl_sql ["chran"].."` order by `rank` desc limit "..table_sets ["ranklimit"])

if rows > 0 then
local arank = ""

for x = 0, rows - 1 do
local _, user, rank = VH:SQLFetch (x)

if x == 0 then
len = string.len (rank)
numlen = string.len (rows)
end

arank = arank.." "..inleadingzeroes (numlen, (x + 1))..". [R: "..inleadingzeroes (len, rank).."] "..user.."\n"
end

commandanswer (nick, string.format (getlang (116), rows)..":\n\n"..arank)
else
commandanswer (nick, getlang (117))
end

return 0
end

----- ---- --- -- -

function shareranksendall (nick)
local _, rows = VH:SQLQuery ("select `nick`, `rank` from `"..tbl_sql ["shran"].."` order by `rank` desc limit "..table_sets ["ranklimit"])

if rows > 0 then
local arank = ""

for x = 0, rows - 1 do
local _, user, rank = VH:SQLFetch (x)

if x == 0 then
numlen = string.len (rows)
end

arank = arank.." "..inleadingzeroes (numlen, (x + 1))..". "..user.." @ "..makesize (rank).."\n"
end

commandanswer (nick, string.format (getlang (324), rows)..":\n\n"..arank)
else
commandanswer (nick, getlang (326))
end

return 0
end

----- ---- --- -- -

function opranksendall (nick)
local _, rows = VH:SQLQuery ("select `nick`, `rank` from `"..tbl_sql ["opran"].."` order by `rank` desc limit "..table_sets ["ranklimit"])

if rows > 0 then
local arank = ""

for x = 0, rows - 1 do
local _, user, rank = VH:SQLFetch (x)

if x == 0 then
len = string.len (rank)
numlen = string.len (rows)
end

arank = arank.." "..inleadingzeroes (numlen, (x + 1))..". [R: "..inleadingzeroes (len, rank).."] "..user.."\n"
end

commandanswer (nick, string.format (getlang (118), rows)..":\n\n"..arank)
else
commandanswer (nick, getlang (119))
end

return 0
end

----- ---- --- -- -

function wordranksendall (nick)
local _, rows = VH:SQLQuery ("select `word`, `rank` from `"..tbl_sql ["wdran"].."` order by `rank` desc limit "..table_sets ["ranklimit"])

if rows > 0 then
local arank = ""

for x = 0, rows - 1 do
local _, user, rank = VH:SQLFetch (x)

if x == 0 then
len = string.len (rank)
numlen = string.len (rows)
end

arank = arank.." "..inleadingzeroes (numlen, (x + 1))..". [R: "..inleadingzeroes (len, rank).."] "..repnmdcoutchars (user).."\n"
end

commandanswer (nick, string.format (getlang (439), rows)..":\n\n"..arank)
else
commandanswer (nick, getlang (445))
end

return 0
end

----- ---- --- -- -

function addrankex (nick, item)
local entry = repsqlchars (item)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl_sql ["ranex"].."` where `nick` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (210), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["ranex"].."` (`nick`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (211), item))
delrank (nick, "all "..item)
end

return 0
end

----- ---- --- -- -

function delrankex (nick, item)
local aitem = repsqlchars (item)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl_sql ["ranex"].."` where `nick` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["ranex"].."` where `nick` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang (212), item))
else
commandanswer (nick, string.format (getlang (213), item))
end

return 0
end

----- ---- --- -- -

function listrankex (nick)
local _, rows = VH:SQLQuery ("select `nick`, `occurred` from `"..tbl_sql ["ranex"].."` order by `occurred` desc")

if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

anentry = anentry.." "..inleadingzeroes (numlen, (x + 1))..". [O: "..inleadingzeroes (len, occurred).."] "..entry.."\n"
end

commandanswer (nick, getlang (214)..":\n\n"..anentry)
else
commandanswer (nick, getlang (215))
end

return 0
end

----- ---- --- -- -

function countchatranks ()
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["chran"].."`")
local crcount = 0

if rows > 0 then
for x = 0, rows - 1 do
local _, anum = VH:SQLFetch (x)
crcount = crcount + tonumber (anum)
end
end

return crcount
end

----- ---- --- -- -

function countshareranks ()
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["shran"].."`")
local srcount = 0

if rows > 0 then
for x = 0, rows - 1 do
local _, anum = VH:SQLFetch (x)
srcount = srcount + tonumber (anum)
end
end

return srcount
end

----- ---- --- -- -

function countopranks ()
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["opran"].."`")
local orcount = 0

if rows > 0 then
for x = 0, rows - 1 do
local _, anum = VH:SQLFetch (x)
orcount = orcount + tonumber (anum)
end
end

return orcount
end

----- ---- --- -- -

function countwordranks ()
local _, rows = VH:SQLQuery ("select `rank` from `"..tbl_sql ["wdran"].."`")
local orcount = 0

if rows > 0 then
for x = 0, rows - 1 do
local _, anum = VH:SQLFetch (x)
orcount = orcount + tonumber (anum)
end
end

return orcount
end

----- ---- --- -- -

function addsefientry (nick, item)
local prio = string.gsub (item, "^.+ (%d) (%d) (%d)$", "%1")
local aaction = string.gsub (item, "^.+ (%d) (%d) (%d)$", "%2")
local stype = string.gsub (item, "^.+ (%d) (%d) (%d)$", "%3")
prio = tonumber (prio)
aaction = tonumber (aaction)
stype = tonumber (stype)

if (aaction < 0) or (aaction > 7) then -- only if valid action
commandanswer (nick, string.format (getlang (227), "0, 1, 2, 3, 4, 5, 6 "..getlang (70).." 7"))
elseif (prio < 0) or (prio > 9) then -- only if valid priority
commandanswer (nick, string.format (getlang (23), 0, 9))
elseif (stype < 1) or (stype > 9) then -- only if valid search type
commandanswer (nick, string.format (getlang (319), "1, 2, 3, 4, 5, 6, 7, 8 "..getlang (70).." 9"))
else

local aitem = string.gsub (item, "^(.+) %d %d %d$", "%1")
local entry = repsqlchars (repnmdcinchars (aitem))
local _, rows = VH:SQLQuery ("select `action` from `"..tbl_sql ["sefi"].."` where `filter` = '"..entry.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["sefi"].."` set `priority` = '"..prio.."', `action` = '"..aaction.."', `type` = '"..stype.."' where `filter` = '"..entry.."' limit 1")
local note = 585

if stype == 2 then note = 586
elseif stype == 3 then note = 587
elseif stype == 4 then note = 588
elseif stype == 5 then note = 589
elseif stype == 6 then note = 590
elseif stype == 7 then note = 591
elseif stype == 8 then note = 592
elseif stype == 9 then note = 593
end

commandanswer (nick, string.format (getlang (note), aaction, prio, aitem))
else
VH:SQLQuery ("insert into `"..tbl_sql ["sefi"].."` (`filter`, `priority`, `action`, `type`) values ('"..entry.."', '"..prio.."', '"..aaction.."', '"..stype.."')")
local note = 594

if stype == 2 then note = 595
elseif stype == 3 then note = 596
elseif stype == 4 then note = 597
elseif stype == 5 then note = 598
elseif stype == 6 then note = 599
elseif stype == 7 then note = 600
elseif stype == 8 then note = 601
elseif stype == 9 then note = 602
end

commandanswer (nick, string.format (getlang (note), aaction, prio, aitem))
end
end

return 0
end

----- ---- --- -- -

function delsefientry (nick, item)
local aitem = repsqlchars (repnmdcinchars (item))
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["sefi"].."` where `filter` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["sefi"].."` where `filter` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang (220), item))
else
commandanswer (nick, string.format (getlang (221), item))
end

return 0
end

----- ---- --- -- -

function listsefientry (nick)
local _, rows = VH:SQLQuery ("select `filter`, `occurred`, `priority`, `action`, `type` from `"..tbl_sql ["sefi"].."` order by `occurred` desc, `priority` desc")

if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local _, entry, occurred, prio, aaction, stype = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

anentry = anentry.." "..inleadingzeroes (numlen, (x + 1))..". [P: "..prio.."] [A: "..aaction.."] [T: "..stype.."] [O: "..inleadingzeroes (len, occurred).."] "..repnmdcoutchars (entry).."\n"
end

commandanswer (nick, getlang (222)..":\n\n"..anentry)
else
commandanswer (nick, getlang (223))
end

return 0
end

----- ---- --- -- -

function addsefiexentry (nick, item)
local entry = repsqlchars (repnmdcinchars (item))
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["sefiex"].."` where `exception` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (287), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["sefiex"].."` (`exception`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (288), item))
end

return 0
end

----- ---- --- -- -

function delsefiexentry (nick, item)
local aitem = repsqlchars (repnmdcinchars (item))
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["sefiex"].."` where `exception` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["sefiex"].."` where `exception` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang (289), item))
else
commandanswer (nick, string.format (getlang (290), item))
end

return 0
end

----- ---- --- -- -

function listsefiexentry (nick)
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..tbl_sql ["sefiex"].."` order by `occurred` desc")

if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

anentry = anentry.." "..inleadingzeroes (numlen, (x + 1))..". [O: "..inleadingzeroes (len, occurred).."] "..repnmdcoutchars (entry).."\n"
end

commandanswer (nick, getlang (286)..":\n\n"..anentry)
else
commandanswer (nick, getlang (291))
end

return 0
end

----- ---- --- -- -

function addantientry (nick, item)
local prio = string.gsub (item, "^.+ (%d) (%d) (%d)$", "%1")
local aaction = string.gsub (item, "^.+ (%d) (%d) (%d)$", "%2")
local flags = string.gsub (item, "^.+ (%d) (%d) (%d)$", "%3")
prio = tonumber (prio)
aaction = tonumber (aaction)
flags = tonumber (flags)

if (aaction < 0) or (aaction > 7) then -- only if valid action
commandanswer (nick, string.format (getlang (227), "0, 1, 2, 3, 4, 5, 6 "..getlang (70).." 7"))
elseif (flags < 1) or (flags > 3) then -- only if valid flags
commandanswer (nick, string.format (getlang (228), "1, 2 "..getlang (70).." 3"))
elseif (prio < 0) or (prio > 9) then -- only if valid priority
commandanswer (nick, string.format (getlang (23), 0, 9))
else
local aitem = string.gsub (item, "^(.+) %d %d %d$", "%1")
local entry = repsqlchars (repnmdcinchars (aitem))
local _, rows = VH:SQLQuery ("select `action` from `"..tbl_sql ["anti"].."` where `antispam` = '"..entry.."' limit 1")

if rows > 0 then
VH:SQLQuery ("update `"..tbl_sql ["anti"].."` set `priority` = '"..prio.."', `action` = '"..aaction.."', `flags` = '"..flags.."' where `antispam` = '"..entry.."' limit 1")
local note = 554

if flags == 1 then note = 552
elseif flags == 2 then note = 553
end

commandanswer (nick, string.format (getlang (note), aaction, prio, aitem))
else
VH:SQLQuery ("insert into `"..tbl_sql ["anti"].."` (`antispam`, `priority`, `action`, `flags`) values ('"..entry.."', '"..prio.."', '"..aaction.."', '"..flags.."')")
local note = 557

if flags == 1 then note = 555
elseif flags == 2 then note = 556
end

commandanswer (nick, string.format (getlang (note), aaction, prio, aitem))
end
end

return 0
end

----- ---- --- -- -

function delantientry (nick, item)
local aitem = repsqlchars (repnmdcinchars (item))
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["anti"].."` where `antispam` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["anti"].."` where `antispam` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang (129), item))
else
commandanswer (nick, string.format (getlang (130), item))
end

return 0
end

----- ---- --- -- -

function listantientry (nick)
local _, rows = VH:SQLQuery ("select `antispam`, `occurred`, `priority`, `action`, `flags` from `"..tbl_sql ["anti"].."` order by `occurred` desc, `priority` desc, `flags` desc")

if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local _, entry, occurred, prio, aaction, flags = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

anentry = anentry.." "..inleadingzeroes (numlen, (x + 1))..". [P: "..prio.."] [A: "..aaction.."] [F: "..flags.."] [O: "..inleadingzeroes (len, occurred).."] "..repnmdcoutchars (entry).."\n"
end

commandanswer (nick, getlang (131)..":\n\n"..anentry)
else
commandanswer (nick, getlang (132))
end

return 0
end

----- ---- --- -- -

function addexentry (nick, item)
local entry = repsqlchars (repnmdcinchars (item))
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["antiex"].."` where `exception` = '"..entry.."' limit 1")

if rows > 0 then
commandanswer (nick, string.format (getlang (133), item))
else
VH:SQLQuery ("insert into `"..tbl_sql ["antiex"].."` (`exception`) values ('"..entry.."')")
commandanswer (nick, string.format (getlang (134), item))
end

return 0
end

----- ---- --- -- -

function delexentry (nick, item)
local aitem = repsqlchars (repnmdcinchars (item))
local _, rows = VH:SQLQuery ("select `occurred` from `"..tbl_sql ["antiex"].."` where `exception` = '"..aitem.."' limit 1")

if rows > 0 then
VH:SQLQuery ("delete from `"..tbl_sql ["antiex"].."` where `exception` = '"..aitem.."' limit 1")
commandanswer (nick, string.format (getlang (135), item))
else
commandanswer (nick, string.format (getlang (136), item))
end

return 0
end

----- ---- --- -- -

function listexentry (nick)
local _, rows = VH:SQLQuery ("select `exception`, `occurred` from `"..tbl_sql ["antiex"].."` order by `occurred` desc")

if rows > 0 then
local anentry = ""

for x = 0, rows - 1 do
local _, entry, occurred = VH:SQLFetch (x)

if x == 0 then
len = string.len (occurred)
numlen = string.len (rows)
end

anentry = anentry.." "..inleadingzeroes (numlen, (x + 1))..". [O: "..inleadingzeroes (len, occurred).."] "..repnmdcoutchars (entry).."\n"
end

commandanswer (nick, getlang (137)..":\n\n"..anentry)
else
commandanswer (nick, getlang (138))
end

return 0
end

----- ---- --- -- -

function savetopic (owner, topic, ucls)
if ucls >= getconfig ("topic_mod_class") then
if (topic == nil) or (string.len (topic) < 1) then
table_othsets ["topicowner"] = nil -- dont change
table_othsets ["topicvalue"] = nil -- dont change
else
table_othsets ["topicowner"] = owner
table_othsets ["topicvalue"] = topic

if table_sets ["rolltopicint"] > 0 then -- add extra spaces if rolling is enabled
table_othsets ["rolltopicsecs"] = os.time ()
table_othsets ["rolltopiclen"] = 1 -- dont change
VH:SendDataToAll ("$HubName "..getconfig ("hub_name").." - "..makespace (table_sets ["rolltopicspace"])..topic.."|", 0, 10)
end
end
end

return 0
end

----- ---- --- -- -

function sendtopic (nick)
if table_othsets ["topicvalue"] == nil then
commandanswer (nick, getlang (42))
else

if table_sets ["showtopicowner"] == 0 then
commandanswer (nick, string.format (getlang (1), table_othsets ["topicvalue"]))
else
commandanswer (nick, string.format (getlang (2), table_othsets ["topicowner"], table_othsets ["topicvalue"]))
end
end

return 0
end

----- ---- --- -- -

function rolltopic ()
table_othsets ["rolltopicsecs"] = os.time ()
local newtopc = makespace (table_sets ["rolltopicspace"])..table_othsets ["topicvalue"]

if table_othsets ["rolltopiclen"] >= (string.len (newtopc) + 1) then
table_othsets ["rolltopiclen"] = 1 -- dont change
end

newtopc = string.sub (newtopc, table_othsets ["rolltopiclen"] + 1, -1)..string.sub (newtopc, 1, table_othsets ["rolltopiclen"])
table_othsets ["rolltopiclen"] = table_othsets ["rolltopiclen"] + 1 -- steps to move
VH:SendDataToAll ("$HubName "..getconfig ("hub_name").." - "..newtopc.."|", 0, 10)

return 0
end

----- ---- --- -- -

function namereg (nick, line, cls)
oldn = string.gsub (line, "^(%S+) %S+$", "%1")

if getregclass (oldn) == nil then -- check if physically registered
commandanswer (nick, string.format (getlang (487), oldn))
else
newn = string.gsub (line, "^%S+ (%S+)$", "%1")
newn = repnickchars (newn)

if getstatus (oldn) == 1 then -- notify and disconnect user if hes online
pmtouser (oldn, table_othsets ["botnick"], string.format (getlang (488), newn))
VH:CloseConnection (oldn)
end

rnewn = repsqlchars (newn)
roldn = repsqlchars (oldn)
VH:SQLQuery ("update `reglist` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..tbl_sql ["wm"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..tbl_sql ["cust"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..tbl_sql ["auth"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..tbl_sql ["chran"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..tbl_sql ["opran"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..tbl_sql ["shran"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."' limit 1")
VH:SQLQuery ("update `"..tbl_sql ["off"].."` set `from` = '"..rnewn.."' where `from` = '"..roldn.."'") -- no limit
VH:SQLQuery ("update `"..tbl_sql ["news"].."` set `by` = '"..rnewn.."' where `by` = '"..roldn.."'") -- no limit
VH:SQLQuery ("update `"..tbl_sql ["rel"].."` set `by` = '"..rnewn.."' where `by` = '"..roldn.."'") -- no limit
VH:SQLQuery ("update `"..tbl_sql ["mchist"].."` set `realnick` = '"..rnewn.."' where `realnick` = '"..roldn.."'") -- no limit
VH:SQLQuery ("update `"..tbl_sql ["ophist"].."` set `nick` = '"..rnewn.."' where `nick` = '"..roldn.."'") -- no limit
commandanswer (nick, string.format (getlang (489), oldn, newn))
opsnotify (table_sets ["classnotireg"], string.format (getlang (490), nick, cls, oldn, newn))
end

return 0
end

----- ---- --- -- -

function sendreglist (nick, line)
if string.find (line, "^%-%d %d+x%d+$") then -- f*cking lua regular expression doesnt take -1 as a number
class = string.gsub (line, "^(%-%d) (%d+)x(%d+)$", "%1")
sfrom = string.gsub (line, "^(%-%d) (%d+)x(%d+)$", "%2")
hmany = string.gsub (line, "^(%-%d) (%d+)x(%d+)$", "%3")
else
class = string.gsub (line, "^(%d+) (%d+)x(%d+)$", "%1")
sfrom = string.gsub (line, "^(%d+) (%d+)x(%d+)$", "%2")
hmany = string.gsub (line, "^(%d+) (%d+)x(%d+)$", "%3")
end

class = tonumber (class)
sfrom = tonumber (sfrom)
hmany = tonumber (hmany)

if hmany <= 1 then
hmany = 1
end

if (class == 10) or (class == 5) or (class == 4) or (class == 3) or (class == 2) or (class == 1) or (class == 0) or (class == -1) then
local _, trows = VH:SQLQuery ("select `class` from `reglist` where `class` = '"..class.."'")

if trows > 0 then
if (sfrom <= 0) or (sfrom > trows) then
commandanswer (nick, string.format (getlang (140), sfrom, trows, class))
else
mysfrom = sfrom - 1
local _, rows = VH:SQLQuery ("select `nick`, `reg_date`, `pwd_change`, `login_last`, `enabled` from `reglist` where `class` = '"..class.."' order by `login_last` desc limit "..mysfrom..", "..hmany)

if rows > 0 then
local areg = ""

for x = 0, rows - 1 do
local _, user, rgdate, pwdc, lastlog, enacc = VH:SQLFetch (x)

if x == 0 then
numlen = string.len (rows)
end

areg = areg.." "..inleadingzeroes (numlen, (x + 1))..". [R: "..fromunixtime (rgdate).."] [L: "..fromunixtime (lastlog).."] [P: "..pwdc.."] [E: "..enacc.."] [O: "..getstatus (user).."] "..user.."\n"
end

commandanswer (nick, string.format (getlang (141), rows, trows, class, sfrom)..":\n\n"..areg)
end
end

else
commandanswer (nick, string.format (getlang (142), class))
end

else
commandanswer (nick, string.format (getlang (143), "-1, 0, 1, 2, 3, 4, 5 "..getlang (70).." 10"))
end

return 0
end

----- ---- --- -- -

function delledouser (nick)
local usr = repsqlchars (nick)
VH:SQLQuery ("delete from `"..tbl_sql ["wm"].."` where `nick` = '"..usr.."' limit 1")
VH:SQLQuery ("delete from `"..tbl_sql ["cust"].."` where `nick` = '"..usr.."' limit 1")
VH:SQLQuery ("delete from `"..tbl_sql ["auth"].."` where `nick` = '"..usr.."' limit 1")
VH:SQLQuery ("delete from `"..tbl_sql ["off"].."` where `from` = '"..usr.."'")
VH:SQLQuery ("delete from `"..tbl_sql ["chran"].."` where `nick` = '"..usr.."' limit 1")
VH:SQLQuery ("delete from `"..tbl_sql ["opran"].."` where `nick` = '"..usr.."' limit 1")
VH:SQLQuery ("delete from `"..tbl_sql ["shran"].."` where `nick` = '"..usr.."' limit 1")

return 0
end

----- ---- --- -- -

function sendsay (nick, message, ucl)
user = string.gsub (message, "^(%S*) (.*)$", "%1")
message = string.gsub (message, "^(%S*) (.*)$", "%2")

if ((user == table_sets ["ledobotnick"]) or (user == table_othsets ["botnick"]) or (user == table_othsets ["opchatnick"]) or (user == nick)) or (getclass (user) < ucl) then
opsnotify (table_sets ["classnotisay"], string.format (getlang (144), nick, ucl, user, message))
VH:SendDataToAll ("<"..user.."> "..message.."|", 0, 10)
addmchistoryline (user, nick, message)
else
opsnotify (table_sets ["classnotisay"], string.format (getlang (145), nick, ucl, user, message))
commandanswer (nick, getlang (146))
end

return 0
end

----- ---- --- -- -

function donotifyregnew (nick, ucls, line)
if ucls < getconfig ("min_class_register") then return 0 end -- check verlihub configuration
local user = ""
local class = 0

if string.find (line, "^%s*%S+%s+%S+%s*.*$") then
user = string.gsub (line, "^%s*(%S+)%s+(%S+)%s*.*$", "%1")
class = string.gsub (line, "^%s*(%S+)%s+(%S+)%s*.*$", "%2")
class = tonumber (class) or 1 -- default class when invalid number

if (class == 0) or ((class >= 6) and (class <= 9)) then
class = 1 -- default class when 0 is used
end

else
user = string.gsub (line, "^%s*(%S+)%s*.*$", "%1")
class = 1 -- default class when not specified
end

if (ucls < 10) and (class > ucls - getconfig ("classdif_reg")) then return 0 end -- check verlihub configuration

if not getregclass (user) then -- only if not registered
opsnotify (table_sets ["classnotireg"], string.format (getlang (446), nick, ucls, class, user))
oprankaccept (nick, ucls)
end

return 0
end

----- ---- --- -- -

function donotifyregdel (nick, ucls, line)
if ucls < getconfig ("min_class_register") then return 0 end -- check verlihub configuration
local user = string.gsub (line, "^%s*(%S+)%s*.*$", "%1")
local class = getregclass (user)
if (not class) or ((ucls < 10) and (class > ucls - getconfig ("classdif_reg"))) then return 0 end -- only if registered
opsnotify (table_sets ["classnotireg"], string.format (getlang (447), nick, ucls, class, user))
oprankaccept (nick, ucls)
delledouser (user) -- remove user from ledokol tables aswell

return 0
end

----- ---- --- -- -

function donotifyregclass (nick, ucls, line)
if ucls < getconfig ("min_class_register") then return 0 end -- check verlihub configuration
local user = string.gsub (line, "^%s*(%S+)%s+(%S+)%s*.*$", "%1")
local class = string.gsub (line, "^%s*(%S+)%s+(%S+)%s*.*$", "%2")
class = tonumber (class) or 0
local uclass = getregclass (user)
if (not uclass) or ((ucls < 10) and (class > ucls - getconfig ("classdif_reg"))) then return 0 end -- only if registered
if uclass == class then return 0 end -- only if different

if class < 3 then -- remove user from op ranks list if new class is lower than op class
VH:SQLQuery ("delete from `"..tbl_sql ["opran"].."` where `nick` = '"..repsqlchars (user).."' limit 1")
end

opsnotify (table_sets ["classnotireg"], string.format (getlang (448), nick, ucls, uclass, class, user))
oprankaccept (nick, ucls)

return 0
end

----- ---- --- -- -

function donotifyban (nick, ucls, line)
local reason = ""

if string.find (line, "^%S*%s+%S+ .*$") then
cmd = string.gsub (line, "^(%S*)%s+(%S+) (.*)$", "%1")
user = string.gsub (line, "^(%S*)%s+(%S+) (.*)$", "%2")
reason = string.gsub (line, "^(%S*)%s+(%S+) (.*)$", "%3")
else -- ip can be banned without specifying a reason when its found in kick list
cmd = string.gsub (line, "^(%S*)%s+(%S+)$", "%1")
user = string.gsub (line, "^(%S*)%s+(%S+)$", "%2")
repusr = repsqlchars (user)
local _, rows = VH:SQLQuery ("select `reason` from `kicklist` where `ip` = '"..repusr.."' order by `time` desc limit 1")

if rows > 0 then
_, reason = VH:SQLFetch (0)
else

return 0
end
end

oprankaccept (nick, ucls)
local _, bantime = string.find (cmd, "_")

if not bantime then
opsnotify (table_sets ["classnotiban"], string.format (getlang (104), user, nick, reason))
else
bantime = string.sub (cmd, bantime + 1, -1) -- i dont understand this: !ban_ user test => "_" gets banned with reason "user test"
opsnotify (table_sets ["classnotiban"], string.format (getlang (208), user, bantime, nick, reason))
end

return 0
end

----- ---- --- -- -

function donotifyunban (nick, ucls, line)
local user = string.gsub (line, "^%S*%s+(%S+) .*$", "%1")
local repusr = repsqlchars (user)
local _, rows = VH:SQLQuery ("select `ban_type` from `banlist` where `ip` = '"..repusr.."' or `nick` = '"..repusr.."' or `host` = '"..repusr.."' or `range_fr` = '"..repusr.."' or `range_to` = '"..repusr.."' limit 1")

if rows > 0 then
local reason = string.gsub (line, "^%S*%s+%S+ (.*)$", "%1")
opsnotify (table_sets ["classnotiban"], string.format (getlang (150), user, nick, reason))
oprankaccept (nick, ucls)
end

return 0
end

----- ---- --- -- -

function donotifyconfig (nick, line, cls)
local cname = string.gsub (line, "^%s*(%S+) .*$", "%1")
local _, rows = VH:SQLQuery ("select `var` from `SetupList` where `var` = '"..repsqlchars (cname).."' limit 1")

if rows > 0 then
local cvalu = string.gsub (line, "^%s*%S+ (.*)$", "%1")
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, cls, cname, getconfig (cname), cvalu))
oprankaccept (nick, cls)
end

return 0
end

----- ---- --- -- -

function donotifyredir (nick, ucls, line)
who = string.gsub (line, "^%$Who:(.+)%$Where:.+%$Msg:.+$", "%1")

if getstatus (who) == 1 then
where = string.gsub (line, "^%$Who:.+%$Where:(.+)%$Msg:(.+)$", "%1")
msg = string.gsub (line, "^%$Who:.+%$Where:(.+)%$Msg:(.+)$", "%2")
opsnotify (table_sets ["classnotiredir"], string.format (getlang (152), who, getip (who), getclass (who), where, nick, msg))
oprankaccept (nick, ucls)
else
opsnotify (table_sets ["classnotiredir"], string.format (getlang (46), nick, ucls, who))
end

return 0
end

----- ---- --- -- -

function donotifycmd (nick, cmd, limited, cls)
if table_sets ["classnoticom"] == 11 then return 0 end
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["cmdex"].."`")

if rows > 0 then
for x = 0, rows - 1 do
local _, entry = VH:SQLFetch (x)

if string.find (repnmdcinchars (cmd), entry) then
VH:SQLQuery ("update `"..tbl_sql ["cmdex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (entry).."' limit 1")

return 0
end
end
end

local cmsg = string.format (getlang (103), nick, cls, cmd)

if limited == 0 then
VH:SendPMToAll ("["..inleadingzeroes (2, table_sets ["classnoticom"]).."] "..cmsg, table_othsets ["feednick"], table_sets ["classnoticom"], 10)
else
VH:SendPMToAll ("["..inleadingzeroes (2, limited).."] "..cmsg, table_othsets ["feednick"], limited, 10)
end

if (table_sets ["histbotmsg"] == 1) and (table_sets ["addledobot"] == 0) and (table_sets ["useextrafeed"] == 0) then
addophistoryline (table_othsets ["opchatnick"], cmsg)
end

return 0
end

----- ---- --- -- -

function sethubconf (line)
local _, _, cname, cvalu = string.find (line, "^%s*(%S+) (.*)$")
local _, _, nospval = string.find (cvalu, "^%s*(%S+)%s*$") -- truncate spaces

if cname == "hub_security" then
table_othsets ["botnick"] = nospval
if table_sets ["addledobot"] == 0 then table_othsets ["sendfrom"] = nospval end

elseif cname == "opchat_name" then
table_othsets ["opchatnick"] = nospval
if (table_sets ["addledobot"] == 0) and (table_sets ["useextrafeed"] == 0) then table_othsets ["feednick"] = nospval end

elseif cname == "cmd_start_op" then
table_othsets ["optrig"] = string.sub (nospval, 1, 1)

elseif cname == "cmd_start_user" then
table_othsets ["ustrig"] = string.sub (nospval, 1, 1)

elseif cname == "timer_serv_period" then
table_othsets ["srvtimer"] = tonumber (nospval) or table_othsets ["srvtimer"]
end

return 0
end

----- ---- --- -- -

function getledoconf (var)
local _, rows = VH:SQLQuery ("select `value` from `"..tbl_sql ["conf"].."` where `variable` = '"..var.."' limit 1")

if rows > 0 then
local _, cfg = VH:SQLFetch (0)
return cfg
else
return nil
end
end

----- ---- --- -- -

function setledocmd (nick, ucls, line)
local orig = string.gsub (line, "^(%S+) %S+$", "%1")

if not table_cmnds [orig] then
commandanswer (nick, string.format (getlang (423), orig))
else
local cnew = string.gsub (line, "^%S+ (%S+)$", "%1")
table_cmnds [orig] = cnew
VH:SQLQuery ("update `"..tbl_sql ["ledocmd"].."` set `new` = '"..repsqlchars (cnew).."' where `original` = '"..repsqlchars (orig).."' limit 1")
commandanswer (nick, string.format (getlang (422), orig, cnew))
opsnotify (table_sets ["classnoticom"], string.format (getlang (425), nick, ucls, orig, cnew))
end

return 0
end

----- ---- --- -- -

function resetledocmd (nick)
local cnum = 0

for k, v in pairs (table_cmnds) do
if v ~= k then
cnum = cnum + 1
table_cmnds [k] = k
k = repsqlchars (k)
VH:SQLQuery ("update `"..tbl_sql ["ledocmd"].."` set `new` = '"..k.."' where `original` = '"..k.."' limit 1")
end
end

commandanswer (nick, string.format (getlang (427), cnum))

return 0
end

----- ---- --- -- -

function setledoconf (nick, ucls, line)
local tvar = string.gsub (line, "^(%S+) (.*)$", "%1")
local setto = string.gsub (line, "^(%S+) (.*)$", "%2")

if tvar == "enableantispam" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["enableantispam"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["enableantispam"], setto))
table_sets ["enableantispam"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "allowspamtoops" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["allowspamtoops"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["allowspamtoops"], setto))
table_sets ["allowspamtoops"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "kickunkusers" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["kickunkusers"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["kickunkusers"], setto))
table_sets ["kickunkusers"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "chatrunning" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["chatrunning"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["chatrunning"], setto))
oldval = table_sets ["chatrunning"]
table_sets ["chatrunning"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if oldval ~= table_sets ["chatrunning"] then -- only if set to different
if table_sets ["chatrunning"] == 0 then
uninstallchatrooms ()
else
installchatrooms ()
end
end

else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "thirdacttime" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["thirdacttime"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["thirdacttime"], setto))
table_sets ["thirdacttime"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "sixthactaddr" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["sixthactaddr"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["sixthactaddr"], setto))
table_sets ["sixthactaddr"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "seventhacttime" then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["seventhacttime"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["seventhacttime"], setto))
table_sets ["seventhacttime"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

----- ---- --- -- -

elseif tvar == "unktbantime" then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["unktbantime"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["unktbantime"], setto))
table_sets ["unktbantime"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

----- ---- --- -- -

elseif tvar == "unkkickreason" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["unkkickreason"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["unkkickreason"], setto))
table_sets ["unkkickreason"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "enablesearfilt" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["enablesearfilt"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["enablesearfilt"], setto))
table_sets ["enablesearfilt"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "scanbelowclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["scanbelowclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["scanbelowclass"], setto))
table_sets ["scanbelowclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "1, 2, 3, 4, 5 "..getlang (197).." 10"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "regkickaction" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["regkickaction"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["regkickaction"], setto))
table_sets ["regkickaction"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1 "..getlang (197).." 2"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "showtopicowner" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["showtopicowner"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["showtopicowner"], setto))
table_sets ["showtopicowner"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "ipconantiflint" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 3600) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["ipconantiflint"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["ipconantiflint"], setto))
table_sets ["ipconantiflint"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (199).." 3600"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "pmminclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["pmminclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["pmminclass"], setto))
table_sets ["pmminclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5 "..getlang (197).." 10"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "enableuserlog" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["enableuserlog"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["enableuserlog"], setto))
table_sets ["enableuserlog"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "logallmyinfos" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["logallmyinfos"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["logallmyinfos"], setto))
table_sets ["logallmyinfos"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "funrandomchat" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["funrandomchat"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["funrandomchat"], setto))
table_sets ["funrandomchat"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "chatrankclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["chatrankclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["chatrankclass"], setto))
oldval = table_sets ["chatrankclass"]
table_sets ["chatrankclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["chatrankclass"] > oldval then
cleantablebyclass (table_sets ["chatrankclass"], tbl_sql ["chran"])
end

else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "oprankclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["oprankclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["oprankclass"], setto))
oldval = table_sets ["oprankclass"]
table_sets ["oprankclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["oprankclass"] > oldval then
cleantablebyclass (table_sets ["oprankclass"], tbl_sql ["opran"])
end

else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "sharerankclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["sharerankclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["sharerankclass"], setto))
oldval = table_sets ["sharerankclass"]
table_sets ["sharerankclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["sharerankclass"] > oldval then
cleantablebyclass (table_sets ["sharerankclass"], tbl_sql ["shran"])
end

else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "wordrankclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["wordrankclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["wordrankclass"], setto))
table_sets ["wordrankclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "ranklimit" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 1) and (setto <= 1000) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["ranklimit"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["ranklimit"], setto))
table_sets ["ranklimit"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "1 "..getlang (199).." 1000"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "shareranmin" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 1) and (setto <= 1024) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["shareranmin"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["shareranmin"], setto))
oldval = table_sets ["shareranmin"]
table_sets ["shareranmin"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["shareranmin"] > oldval then
VH:SQLQuery ("delete from `"..tbl_sql ["shran"].."` where `rank` < '"..(table_sets ["shareranmin"] * 1073741824).."'")
end

else
commandanswer (nick, string.format (getlang (196), tvar, "1 "..getlang (199).." 1024"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "wordranmin" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 1) and (setto <= 25) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["wordranmin"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["wordranmin"], setto))
oldval = table_sets ["wordranmin"]
table_sets ["wordranmin"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["wordranmin"] > oldval then
cleanwordrank (table_sets ["wordranmin"], 0)
end

else
commandanswer (nick, string.format (getlang (196), tvar, "1 "..getlang (199).." 25"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "wordranmax" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 1) and (setto <= 100) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["wordranmax"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["wordranmax"], setto))
oldval = table_sets ["wordranmax"]
table_sets ["wordranmax"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["wordranmax"] < oldval then
cleanwordrank (table_sets ["wordranmax"], 1)
end

else
commandanswer (nick, string.format (getlang (196), tvar, "1 "..getlang (199).." 100"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotianti" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotianti"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotianti"], setto))
table_sets ["classnotianti"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiex" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotiex"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotiex"], setto))
table_sets ["classnotiex"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotisefi" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotisefi"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotisefi"], setto))
table_sets ["classnotisefi"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnoticom" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnoticom"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnoticom"], setto))
table_sets ["classnoticom"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotisay" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotisay"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotisay"], setto))
table_sets ["classnotisay"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotikick" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotikick"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotikick"], setto))
table_sets ["classnotikick"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiban" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotiban"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotiban"], setto))
table_sets ["classnotiban"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotireg" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotireg"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotireg"], setto))
table_sets ["classnotireg"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnoticonfig" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnoticonfig"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnoticonfig"], setto))
table_sets ["classnoticonfig"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiredir" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotiredir"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotiredir"], setto))
table_sets ["classnotiredir"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiunk" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotiunk"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotiunk"], setto))
table_sets ["classnotiunk"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotioff" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotioff"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotioff"], setto))
table_sets ["classnotioff"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiledoact" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotiledoact"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotiledoact"], setto))
table_sets ["classnotiledoact"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiauth" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotiauth"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotiauth"], setto))
table_sets ["classnotiauth"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotiwelcome" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotiwelcome"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotiwelcome"], setto))
table_sets ["classnotiwelcome"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "classnotibotpm" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["classnotibotpm"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["classnotibotpm"], setto))
table_sets ["classnotibotpm"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "mincommandclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["mincommandclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["mincommandclass"], setto))
table_sets ["mincommandclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "3, 4, 5 "..getlang (197).." 10"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "minusrcommandclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["minusrcommandclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["minusrcommandclass"], setto))
table_sets ["minusrcommandclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5 "..getlang (197).." 10"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "custnickclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["custnickclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["custnickclass"], setto))
oldval = table_sets ["custnickclass"]
table_sets ["custnickclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["custnickclass"] > oldval then
cleancustnick (table_sets ["custnickclass"], 1)
end

else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "welcomeclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["welcomeclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["welcomeclass"], setto))
oldval = table_sets ["welcomeclass"]
table_sets ["welcomeclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["welcomeclass"] > oldval then
cleantablebyclass (table_sets ["welcomeclass"], tbl_sql ["wm"])
end

else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "releaseclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["releaseclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["releaseclass"], setto))
table_sets ["releaseclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "antimessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["antimessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["antimessage"], setto))
table_sets ["antimessage"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "authmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["authmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["authmessage"], setto))
table_sets ["authmessage"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "searfiltmsg" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["searfiltmsg"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["searfiltmsg"], setto))
table_sets ["searfiltmsg"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "antikreason" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["antikreason"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["antikreason"], setto))
table_sets ["antikreason"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "sefireason" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["sefireason"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["sefireason"], setto))
table_sets ["sefireason"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "authrunning" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["authrunning"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["authrunning"], setto))
table_sets ["authrunning"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "savecustnicks" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["savecustnicks"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["savecustnicks"], setto))
table_sets ["savecustnicks"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "remrunning" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["remrunning"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["remrunning"], setto))
table_sets ["remrunning"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "resprunning" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["resprunning"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["resprunning"], setto))
table_sets ["resprunning"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "respdelay" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 1) and (setto <= 60) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["respdelay"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["respdelay"], setto))
table_sets ["respdelay"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "1 "..getlang (199).." 60"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "custmaxlen" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 3) and (setto <= 64) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["custmaxlen"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["custmaxlen"], setto))
oldval = table_sets ["custmaxlen"]
table_sets ["custmaxlen"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["custmaxlen"] < oldval then
cleancustnick (table_sets ["custmaxlen"], 0)
end

else
commandanswer (nick, string.format (getlang (196), tvar, "3 "..getlang (199).." 64"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "micheck" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["micheck"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["micheck"], setto))
table_sets ["micheck"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "micallall" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["micallall"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["micallall"], setto))
table_sets ["micallall"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "michnick" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["michnick"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["michnick"], setto))
table_sets ["michnick"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "michdesc" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["michdesc"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["michdesc"], setto))
table_sets ["michdesc"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "michtag" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["michtag"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["michtag"], setto))
table_sets ["michtag"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "michconn" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["michconn"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["michconn"], setto))
table_sets ["michconn"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "michemail" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["michemail"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["michemail"], setto))
table_sets ["michemail"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "michshare" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["michshare"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["michshare"], setto))
table_sets ["michshare"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "michip" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["michip"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["michip"], setto))
table_sets ["michip"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "michfake" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["michfake"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["michfake"], setto))
table_sets ["michfake"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "michclone" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["michclone"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["michclone"], setto))
table_sets ["michclone"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "michsameip" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["michsameip"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["michsameip"], setto))
table_sets ["michsameip"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "mitbantime" then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["mitbantime"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["mitbantime"], setto))
table_sets ["mitbantime"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

----- ---- --- -- -

elseif tvar == "minickmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["minickmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["minickmessage"], setto))
table_sets ["minickmessage"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "midescmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["midescmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["midescmessage"], setto))
table_sets ["midescmessage"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "mitagmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["mitagmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["mitagmessage"], setto))
table_sets ["mitagmessage"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "miconnmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["miconnmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["miconnmessage"], setto))
table_sets ["miconnmessage"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "miemailmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["miemailmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["miemailmessage"], setto))
table_sets ["miemailmessage"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "misharemessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["misharemessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["misharemessage"], setto))
table_sets ["misharemessage"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "miipmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["miipmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["miipmessage"], setto))
table_sets ["miipmessage"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "mifakemessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["mifakemessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["mifakemessage"], setto))
table_sets ["mifakemessage"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "miclonemessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["miclonemessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["miclonemessage"], setto))
table_sets ["miclonemessage"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "misameipmessage" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["misameipmessage"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["misameipmessage"], setto))
table_sets ["misameipmessage"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "offmsgclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["offmsgclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["offmsgclass"], setto))
table_sets ["offmsgclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "sayclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["sayclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["sayclass"], setto))
table_sets ["sayclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "newsclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) or (setto == 11) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["newsclass"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["newsclass"], setto))
table_sets ["newsclass"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0, 1, 2, 3, 4, 5, 10 "..getlang (197).." 11"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "histbotmsg" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["histbotmsg"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["histbotmsg"], setto))
table_sets ["histbotmsg"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "histautolines" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 100) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["histautolines"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["histautolines"], setto))
table_sets ["histautolines"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (199).." 100"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "histautolinemax" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 10) and (setto <= 1000) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["histautolinemax"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["histautolinemax"], setto))
table_sets ["histautolinemax"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "10 "..getlang (199).." 1000"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "newsautolines" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 100) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["newsautolines"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["newsautolines"], setto))
table_sets ["newsautolines"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (199).." 100"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "histlimit" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 1000) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["histlimit"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["histlimit"], setto))
table_sets ["histlimit"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
cleanhistory (nick, table_sets ["histlimit"], 1, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (199).." 1000"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "translitmode" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 2) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["translitmode"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["translitmode"], setto))
table_sets ["translitmode"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (199).." 2"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "langfileprefix" then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["langfileprefix"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["langfileprefix"], setto))
oldval = table_sets ["langfileprefix"]
table_sets ["langfileprefix"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if oldval ~= table_sets ["langfileprefix"] then -- only if set to different
loadlangfile (nick)
end

----- ---- --- -- -

elseif tvar == "srvtimediff" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= -43200) and (setto <= 43200) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["srvtimediff"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["srvtimediff"], setto))
table_sets ["srvtimediff"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "-43200 "..getlang (199).." 43200"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "dateformat" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["dateformat"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["dateformat"], setto))
table_sets ["dateformat"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "timeformat" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["timeformat"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["timeformat"], setto))
table_sets ["timeformat"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "timebotint" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 86400) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["timebotint"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["timebotint"], setto))
oldval = table_sets ["timebotint"]
table_sets ["timebotint"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if (oldval ~= table_sets ["timebotint"]) and (table_sets ["timebotint"] == 0) then -- only if set to different
uninstalltimebot ()
end

else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (199).." 86400"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "rolltopicint" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 3600) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["rolltopicint"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["rolltopicint"], setto))
table_sets ["rolltopicint"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (199).." 3600"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "rolltopicspace" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 0) and (setto <= 10) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["rolltopicspace"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["rolltopicspace"], setto))
table_sets ["rolltopicspace"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (199).." 10"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "timebotnick" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["timebotnick"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["timebotnick"], setto))
setto = repnickchars (setto)
table_sets ["timebotnick"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "addledobot" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["addledobot"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["addledobot"], setto))
oldval = table_sets ["addledobot"]
table_sets ["addledobot"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if oldval ~= table_sets ["addledobot"] then -- only if set to different
if table_sets ["addledobot"] == 0 then
if table_sets ["useextrafeed"] == 0 then
table_othsets ["feednick"] = table_othsets ["opchatnick"]
end

table_othsets ["sendfrom"] = table_othsets ["botnick"]

if getstatus (table_sets ["ledobotnick"]) == 1 then
delhubrobot (table_sets ["ledobotnick"])
end

else

if getstatus (table_sets ["ledobotnick"]) == 0 then
addhubrobot (table_sets ["ledobotnick"], table_othsets ["ledobotdesc"]..table_othsets ["ledobottag"], getownsize ())
end

if table_sets ["useextrafeed"] == 0 then
table_othsets ["feednick"] = table_sets ["ledobotnick"]
end

table_othsets ["sendfrom"] = table_sets ["ledobotnick"]
end
end

else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "ledobotnick" then
if string.len (setto) > 0 then
setto = repnickchars (setto)

if isbot (setto) == 1 then
commandanswer (nick, getlang (511))
return nil
end

commandanswer (nick, string.format (getlang (195), tvar, table_sets ["ledobotnick"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["ledobotnick"], setto))
local oldval = table_sets ["ledobotnick"]

if (table_sets ["addledobot"] == 1) and (setto ~= oldval) and (getstatus (table_sets ["ledobotnick"]) == 1) then -- only if set to different
delhubrobot (table_sets ["ledobotnick"])
end

table_sets ["ledobotnick"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if (table_sets ["addledobot"] == 1) and (table_sets ["ledobotnick"] ~= oldval) then -- only if set to different
if getstatus (table_sets ["ledobotnick"]) == 0 then
addhubrobot (table_sets ["ledobotnick"], table_othsets ["ledobotdesc"]..table_othsets ["ledobottag"], getownsize ())
end

if table_sets ["useextrafeed"] == 0 then
table_othsets ["feednick"] = table_sets ["ledobotnick"]
end

table_othsets ["sendfrom"] = table_sets ["ledobotnick"]
end

else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "useextrafeed" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["useextrafeed"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["useextrafeed"], setto))
table_sets ["useextrafeed"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["useextrafeed"] == 1 then
table_othsets ["feednick"] = table_sets ["extrafeednick"]
else

if table_sets ["addledobot"] == 0 then
table_othsets ["feednick"] = table_othsets ["opchatnick"]
else
table_othsets ["feednick"] = table_sets ["ledobotnick"]
end
end

else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

elseif tvar == "extrafeednick" then
if string.len (setto) > 0 then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["extrafeednick"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["extrafeednick"], setto))
setto = repnickchars (setto)
table_sets ["extrafeednick"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..repsqlchars (setto).."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)

if table_sets ["useextrafeed"] == 1 then
table_othsets ["feednick"] = table_sets ["extrafeednick"]
end

else
commandanswer (nick, string.format (getlang (320), tvar))
end

----- ---- --- -- -

elseif tvar == "commandstopm" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandanswer (nick, string.format (getlang (195), tvar, table_sets ["commandstopm"], setto))
opsnotify (table_sets ["classnoticonfig"], string.format (getlang (50), nick, ucls, tvar, table_sets ["commandstopm"], setto))
table_sets ["commandstopm"] = setto
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..setto.."' where `variable` = '"..tvar.."' limit 1")
oprankaccept (nick, ucls)
else
commandanswer (nick, string.format (getlang (196), tvar, "0 "..getlang (197).." 1"))
end

else
commandanswer (nick, string.format (getlang (198), tvar))
end

----- ---- --- -- -

else -- unknown variable
commandanswer (nick, string.format (getlang (200), tvar))
end

return 0
end

----- ---- --- -- -

function sendhelp (nick)
local optrig = table_othsets ["optrig"]
local ustrig = table_othsets ["ustrig"]

local atextlines = "\n\n .:: "..getlang (155)..":\n\n "..

-- antispam
optrig..table_cmnds ["antiadd"].." <"..getlang (193).."> <"..getlang (30).."> <"..getlang (194).."> <"..getlang (126).."> - "..getlang (156).."\n "..
optrig..table_cmnds ["antilist"].." - "..getlang (131).."\n "..
optrig..table_cmnds ["antidel"].." <"..getlang (193).."> - "..getlang (158).."\n "..
optrig..table_cmnds ["antiexadd"].." <"..getlang (193).."> - "..getlang (159).."\n "..
optrig..table_cmnds ["antiexlist"].." - "..getlang (137).."\n "..
optrig..table_cmnds ["antiexdel"].." <"..getlang (193).."> - "..getlang (160).."\n\n "..

-- search filter
optrig..table_cmnds ["sefiadd"].." <"..getlang (193).."> <"..getlang (30).."> <"..getlang (194).."> <"..getlang (48).."> - "..getlang (225).."\n "..
optrig..table_cmnds ["sefilist"].." - "..getlang (222).."\n "..
optrig..table_cmnds ["sefidel"].." <"..getlang (193).."> - "..getlang (226).."\n "..
optrig..table_cmnds ["sefiexadd"].." <"..getlang (193).."> - "..getlang (284).."\n "..
optrig..table_cmnds ["sefiexlist"].." - "..getlang (286).."\n "..
optrig..table_cmnds ["sefiexdel"].." <"..getlang (193).."> - "..getlang (285).."\n\n "..

-- myinfo check
optrig..table_cmnds ["myinfadd"].." <"..getlang (48).."> <"..getlang (193).."> - "..getlang (161).."\n "..
optrig..table_cmnds ["myinflist"].." <"..getlang (48).."> - "..getlang (163).."\n "..
optrig..table_cmnds ["myinfdel"].." <"..getlang (48).."> <"..getlang (193).."> - "..getlang (162).."\n\n "..

-- authorization
optrig..table_cmnds ["authadd"].." <"..getlang (178).."> <"..getlang (243).."> - "..getlang (241).."\n "..
optrig..table_cmnds ["authlist"].." - "..getlang (239).."\n "..
optrig..table_cmnds ["authdel"].." <"..getlang (178).."> - "..getlang (242).."\n\n "

-- ranks
local btextlines = optrig..table_cmnds ["myoprank"].." - "..getlang (175).."\n "..

optrig..table_cmnds ["ranexadd"].." <"..getlang (178).."> - "..getlang (216).."\n "..
optrig..table_cmnds ["ranexlist"].." - "..getlang (214).."\n "..
optrig..table_cmnds ["ranexdel"].." <"..getlang (178).."> - "..getlang (217).."\n "..
optrig..table_cmnds ["randel"].." <"..getlang (48).."> <"..getlang (205).."> - "..getlang (166).."\n "..
optrig..table_cmnds ["ranclean"].." <"..getlang (48).."> <"..getlang (373).."> - "..getlang (372).."\n\n "..

-- welcome messages
optrig..table_cmnds ["wmforce"].." <"..getlang (48).."> <"..getlang (178).."> ["..getlang (44).."] - "..getlang (484).."\n "..
optrig..table_cmnds ["wmlist"].." - "..getlang (252).."\n "..
optrig..table_cmnds ["wmdel"].." <"..getlang (178).."> - "..getlang (253).."\n\n "..

-- chatrooms
optrig..table_cmnds ["chatadd"].." <"..getlang (178).."> <"..getlang (269).."> <"..getlang (270).."> <"..getlang (271).."> - "..getlang (266).."\n "..
optrig..table_cmnds ["chatlist"].." - "..getlang (267).."\n "..
optrig..table_cmnds ["chatdel"].." <"..getlang (178).."> - "..getlang (268).."\n\n "..

-- reminders
optrig..table_cmnds ["remadd"].." <"..getlang (185).."> <"..getlang (380).."> <"..getlang (270).."> <"..getlang (271).."> <"..getlang (381).."> <"..getlang (382).."> - "..getlang (383).."\n "..
optrig..table_cmnds ["remlist"].." - "..getlang (385).."\n "..
optrig..table_cmnds ["remshow"].." <"..getlang (185).."> - "..getlang (509).."\n "..
optrig..table_cmnds ["remdel"].." <"..getlang (185).."> - "..getlang (384).."\n\n "..

-- news
optrig..table_cmnds ["newsadd"].." <"..getlang (452).."> - "..getlang (453).."\n "..
optrig..table_cmnds ["newsdel"].." <"..getlang (102).."> - "..getlang (454).."\n\n "..

-- chat responder
optrig..table_cmnds ["respadd"].." <\""..getlang (193).."\"> <\""..getlang (400).."\"> <"..getlang (271).."> - "..getlang (401).."\n "..
optrig..table_cmnds ["resplist"].." - "..getlang (403).."\n "..
optrig..table_cmnds ["respdel"].." <"..getlang (185).."> - "..getlang (402).."\n "..
optrig..table_cmnds ["respexadd"].." <"..getlang (178).." "..getlang (197).." "..getlang (243).."> - "..getlang (412).."\n "..
optrig..table_cmnds ["respexlist"].." - "..getlang (414).."\n "..
optrig..table_cmnds ["respexdel"].." <"..getlang (178).." "..getlang (197).." "..getlang (243).."> - "..getlang (413).."\n\n "

-- releases
local ctextlines = optrig..table_cmnds ["reladd"].." <\""..getlang (470).."\"> <\""..getlang (471).."\"> ["..getlang (472).."] - "..getlang (473).."\n "..

optrig..table_cmnds ["reldel"].." <"..getlang (48).."> <"..getlang (470).."> - "..getlang (474).."\n\n "..

-- offline messenger
optrig..table_cmnds ["offlist"].." - "..getlang (168).."\n "..
optrig..table_cmnds ["offdel"].." <"..getlang (102).."> - "..getlang (169).."\n "..
optrig..table_cmnds ["offclean"].." - "..getlang (170).."\n\n "..

-- history
optrig..table_cmnds ["ophistory"].." <"..getlang (209).."> - "..getlang (173).."\n "..
optrig..table_cmnds ["histclean"].." - "..getlang (174).."\n\n "..

-- commands
optrig..table_cmnds ["cmndset"].." <"..getlang (420).."> <"..getlang (420).."> - "..getlang (421).."\n "..
optrig..table_cmnds ["cmndreset"].." - "..getlang (426).."\n "..
optrig..table_cmnds ["cmndadd"].." <"..getlang (193).."> <"..getlang (171).."> - "..getlang (336).."\n "..
optrig..table_cmnds ["cmndlist"].." - "..getlang (338).."\n "..
optrig..table_cmnds ["cmnddel"].." <"..getlang (193).."> - "..getlang (337).."\n "..
optrig..table_cmnds ["cmndexadd"].." <"..getlang (193).."> - "..getlang (296).."\n "..
optrig..table_cmnds ["cmndexlist"].." - "..getlang (298).."\n "..
optrig..table_cmnds ["cmndexdel"].." <"..getlang (193).."> - "..getlang (297).."\n\n "..

-- custom nicks
optrig..table_cmnds ["custforce"].." <"..getlang (178).."> <"..getlang (178).."> - "..getlang (467).."\n "..
optrig..table_cmnds ["custdel"].." <"..getlang (178).."> - "..getlang (329).."\n\n "..

-- registered users
optrig..table_cmnds ["regname"].." <"..getlang (178).."> <"..getlang (178).."> - "..getlang (486).."\n "..
optrig..table_cmnds ["reglist"].." <"..getlang (171).."> <"..getlang (149).."> - "..getlang (164).."\n\n "..

-- other
optrig..table_cmnds ["cleanup"].." <"..getlang (48).."> <"..getlang (4).."> ["..getlang (171).."] - "..getlang (172).."\n "..
optrig..table_cmnds ["ulog"].." <"..getlang (48).."> <"..getlang (120).."> - "..getlang (406).."\n "..
optrig..table_cmnds ["readlog"].." <"..getlang (292).."> <"..getlang (209).."> - "..getlang (293).."\n "..
optrig..table_cmnds ["say"].." <"..getlang (178).."> <"..getlang (44).."> - "..getlang (165).."\n\n "

-- ledokol commands
local dtextlines = optrig..table_cmnds ["ledoconf"].." - "..getlang (176).."\n "..

optrig..table_cmnds ["ledoset"].." <"..getlang (204).."> <"..getlang (205).."> - "..getlang (177).."\n "..
optrig..table_cmnds ["ledover"].." - "..getlang (10).."\n "..
optrig..table_cmnds ["ledohelp"].." - "..getlang (179).."\n "..
optrig..table_cmnds ["ledostats"].." - "..getlang (188)..

"\n\n .:: "..getlang (180)..":\n\n "..

-- ranks
ustrig..table_cmnds ["mychatrank"].." - "..getlang (182).."\n "..
ustrig..table_cmnds ["mysharerank"].." - "..getlang (323).."\n "..
ustrig..table_cmnds ["chatranks"].." - "..string.format (getlang (116), table_sets ["ranklimit"]).."\n "..
ustrig..table_cmnds ["shareranks"].." - "..string.format (getlang (324), table_sets ["ranklimit"]).."\n "..
ustrig..table_cmnds ["opranks"].." - "..string.format (getlang (118), table_sets ["ranklimit"]).."\n "..
ustrig..table_cmnds ["wordranks"].." - "..string.format (getlang (439), table_sets ["ranklimit"]).."\n\n "..

-- releases
ustrig..table_cmnds ["rellist"].." <"..getlang (48).."> <"..getlang (209).."> ["..getlang (471).." "..getlang (197).." "..getlang (310).."] - "..getlang (475).."\n "..
ustrig..table_cmnds ["relfind"].." <"..getlang (470).."> - "..getlang (476).."\n\n "..

-- welcome messages
ustrig..table_cmnds ["wmset"].." <"..getlang (48).."> ["..getlang (44).."] - "..getlang (249).."\n "..
ustrig..table_cmnds ["wmshow"].." - "..getlang (251).."\n\n "..

-- custom nicks
ustrig..table_cmnds ["custnick"].." ["..getlang (178).."] - "..getlang (247).."\n "..
ustrig..table_cmnds ["realnick"].." <"..getlang (178).."> - "..getlang (367).."\n "..
ustrig..table_cmnds ["custlist"].." - "..getlang (154).."\n\n "..

-- other
ustrig..table_cmnds ["offmsg"].." <"..getlang (178).."> <"..getlang (44).."> - "..getlang (186).."\n "..
ustrig..table_cmnds ["showtopic"].." - "..getlang (181).."\n "..
ustrig..table_cmnds ["calculate"].." <"..getlang (479).."> - "..getlang (480).."\n "..
ustrig..table_cmnds ["hubnews"].." <"..getlang (209).."> - "..getlang (455).."\n "..
ustrig..table_cmnds ["history"].." <"..getlang (209).."> - "..getlang (187).."\n "..
ustrig..table_cmnds ["myhistory"].." <"..getlang (209).."> - "..getlang (464).."\n"

commandanswer (nick, atextlines..btextlines..ctextlines..dtextlines)

return 0
end

----- ---- --- -- -

function sendstats (nick)
local entchatran = counttable (tbl_sql ["chran"])
local cntchatran = countchatranks ()
local mesperuser = 0

if entchatran > 0 then
mesperuser = cntchatran / entchatran
end

local textlines = "\n\n .:: "..getlang (188)..":"..

"\n\n "..string.format (getlang (189), table_othsets ["ver_ledo"])..
"\n "..string.format (getlang (207), (table_othsets ["ver_lua"] or getlang (184)))..
"\n "..string.format (getlang (206), (table_othsets ["ver_sock"] or getlang (202)))..
"\n "..string.format (getlang (201), (table_othsets ["ver_sql"] or getlang (184)))..

"\n\n "..string.format (getlang (465), makesize (getmemusg ()))..
"\n "..string.format (getlang (433), formatuptime (false))..

"\n\n "..string.format (getlang (190), cntchatran)..
"\n "..string.format (getlang (113), makesize (countshareranks ()))..
"\n "..string.format (getlang (191), countopranks ())..
"\n "..string.format (getlang (444), countwordranks ())..
"\n "..string.format (getlang (192), roundint (mesperuser, 2))..

"\n\n "..string.format (getlang (230), counttable ("kicklist"), "C", getledoconf ("dayscleankicks"), getledoconf ("lastcleankicks"))..
"\n "..string.format (getlang (231), counttable ("banlist"), "C", getledoconf ("dayscleanbans"), getledoconf ("lastcleanbans"))..
"\n "..string.format (getlang (232), counttable ("unbanlist"), "C", getledoconf ("dayscleanunbans"), getledoconf ("lastcleanunbans"))..
"\n "..string.format (getlang (333), counttable ("reglist"), "C", getledoconf ("dayscleanregs"), getledoconf ("lastcleanregs"))..
"\n "..string.format (getlang (233), counttable ("pi_iplog"), "C", getledoconf ("dayscleaniplog"), getledoconf ("lastcleaniplog"))..
"\n "..string.format (getlang (234), counttable ("pi_stats"), "C", getledoconf ("dayscleanstats"), getledoconf ("lastcleanstats"))..
"\n "..string.format (getlang (123), counttable (tbl_sql ["ulog"]), "C", getledoconf ("limcleanusrlog"), getledoconf ("lastcleanusrlog"))..
"\n "..string.format (getlang (377), counttable (tbl_sql ["chran"]), "C", getledoconf ("limcleanchrank"), getledoconf ("lastcleanchrank"))..
"\n "..string.format (getlang (378), counttable (tbl_sql ["shran"]), "C", getledoconf ("limcleanshrank"), getledoconf ("lastcleanshrank"))..
"\n "..string.format (getlang (379), counttable (tbl_sql ["opran"]), "C", getledoconf ("limcleanoprank"), getledoconf ("lastcleanoprank"))..
"\n "..string.format (getlang (443), counttable (tbl_sql ["wdran"]), "C", getledoconf ("limcleanwordrank"), getledoconf ("lastcleanwordrank")).."\n"

commandanswer (nick, textlines)

return 0
end

----- ---- --- -- -

function showledoconf (nick)
local atextlines = getlang (176)..":\n"..

"\n mincommandclass = "..table_sets ["mincommandclass"]..
"\n minusrcommandclass = "..table_sets ["minusrcommandclass"]..
"\n commandstopm = "..table_sets ["commandstopm"]..
"\n"..
"\n scanbelowclass = "..table_sets ["scanbelowclass"]..
"\n regkickaction = "..table_sets ["regkickaction"]..
"\n thirdacttime = "..table_sets ["thirdacttime"]..
"\n sixthactaddr = "..table_sets ["sixthactaddr"]..
"\n seventhacttime = "..table_sets ["seventhacttime"]..
"\n"..
"\n enableantispam = "..table_sets ["enableantispam"]..
"\n allowspamtoops = "..table_sets ["allowspamtoops"]..
"\n antikreason = "..table_sets ["antikreason"]..
"\n antimessage = "..table_sets ["antimessage"]..
"\n"..
"\n enablesearfilt = "..table_sets ["enablesearfilt"]..
"\n sefireason = "..table_sets ["sefireason"]..
"\n searfiltmsg = "..table_sets ["searfiltmsg"]..
"\n"..
"\n classnotianti = "..table_sets ["classnotianti"]..
"\n classnotiex = "..table_sets ["classnotiex"]..
"\n classnotisefi = "..table_sets ["classnotisefi"]..
"\n classnoticom = "..table_sets ["classnoticom"]..
"\n classnotisay = "..table_sets ["classnotisay"]..
"\n classnotikick = "..table_sets ["classnotikick"]..
"\n classnotiban = "..table_sets ["classnotiban"]..
"\n classnotireg = "..table_sets ["classnotireg"]..
"\n classnoticonfig = "..table_sets ["classnoticonfig"]..
"\n classnotiredir = "..table_sets ["classnotiredir"]..
"\n classnotiunk = "..table_sets ["classnotiunk"]..
"\n classnotioff = "..table_sets ["classnotioff"]..
"\n classnotiledoact = "..table_sets ["classnotiledoact"]..
"\n classnotiauth = "..table_sets ["classnotiauth"]..
"\n classnotiwelcome = "..table_sets ["classnotiwelcome"]..
"\n classnotibotpm = "..table_sets ["classnotibotpm"]..
"\n"..
"\n micheck = "..table_sets ["micheck"]..
"\n micallall = "..table_sets ["micallall"]..
"\n michnick = "..table_sets ["michnick"]..
"\n michdesc = "..table_sets ["michdesc"]..
"\n michtag = "..table_sets ["michtag"]..
"\n michconn = "..table_sets ["michconn"]..
"\n michemail = "..table_sets ["michemail"]..
"\n michshare = "..table_sets ["michshare"]..
"\n michip = "..table_sets ["michip"]..
"\n michfake = "..table_sets ["michfake"]..
"\n michclone = "..table_sets ["michclone"]..
"\n michsameip = "..table_sets ["michsameip"]..
"\n minickmessage = "..table_sets ["minickmessage"]..
"\n midescmessage = "..table_sets ["midescmessage"]..
"\n mitagmessage = "..table_sets ["mitagmessage"]..
"\n miconnmessage = "..table_sets ["miconnmessage"]..
"\n miemailmessage = "..table_sets ["miemailmessage"]..
"\n misharemessage = "..table_sets ["misharemessage"]..
"\n miipmessage = "..table_sets ["miipmessage"]..
"\n mifakemessage = "..table_sets ["mifakemessage"]..
"\n miclonemessage = "..table_sets ["miclonemessage"]..
"\n misameipmessage = "..table_sets ["misameipmessage"]..
"\n mitbantime = "..table_sets ["mitbantime"]..
"\n"..
"\n kickunkusers = "..table_sets ["kickunkusers"]..
"\n unktbantime = "..table_sets ["unktbantime"]..
"\n unkkickreason = "..table_sets ["unkkickreason"].."\n"

local btextlines = "\n authrunning = "..table_sets ["authrunning"]..

"\n authmessage = "..table_sets ["authmessage"]..
"\n"..
"\n custnickclass = "..table_sets ["custnickclass"]..
"\n custmaxlen = "..table_sets ["custmaxlen"]..
"\n savecustnicks = "..table_sets ["savecustnicks"]..
"\n"..
"\n releaseclass = "..table_sets ["releaseclass"]..
"\n welcomeclass = "..table_sets ["welcomeclass"]..
"\n offmsgclass = "..table_sets ["offmsgclass"]..
"\n sayclass = "..table_sets ["sayclass"]..
"\n"..
"\n chatrunning = "..table_sets ["chatrunning"]..
"\n remrunning = "..table_sets ["remrunning"]..
"\n"..
"\n resprunning = "..table_sets ["resprunning"]..
"\n respdelay = "..table_sets ["respdelay"]..
"\n"..
"\n newsclass = "..table_sets ["newsclass"]..
"\n newsautolines = "..table_sets ["newsautolines"]..
"\n"..
"\n chatrankclass = "..table_sets ["chatrankclass"]..
"\n sharerankclass = "..table_sets ["sharerankclass"]..
"\n shareranmin = "..table_sets ["shareranmin"]..
"\n oprankclass = "..table_sets ["oprankclass"]..
"\n wordrankclass = "..table_sets ["wordrankclass"]..
"\n wordranmin = "..table_sets ["wordranmin"]..
"\n wordranmax = "..table_sets ["wordranmax"]..
"\n ranklimit = "..table_sets ["ranklimit"]..
"\n"..
"\n histlimit = "..table_sets ["histlimit"]..
"\n histbotmsg = "..table_sets ["histbotmsg"]..
"\n histautolines = "..table_sets ["histautolines"]..
"\n histautolinemax = "..table_sets ["histautolinemax"]..
"\n"..
"\n addledobot = "..table_sets ["addledobot"]..
"\n ledobotnick = "..table_sets ["ledobotnick"]..
"\n"..
"\n useextrafeed = "..table_sets ["useextrafeed"]..
"\n extrafeednick = "..table_sets ["extrafeednick"]..
"\n"..
"\n timebotint = "..table_sets ["timebotint"]..
"\n timebotnick = "..table_sets ["timebotnick"]..
"\n"..
"\n srvtimediff = "..table_sets ["srvtimediff"]..
"\n dateformat = "..table_sets ["dateformat"]..
"\n timeformat = "..table_sets ["timeformat"]..
"\n"..
"\n rolltopicint = "..table_sets ["rolltopicint"]..
"\n rolltopicspace = "..table_sets ["rolltopicspace"]..
"\n showtopicowner = "..table_sets ["showtopicowner"]..
"\n"..
"\n ipconantiflint = "..table_sets ["ipconantiflint"]..
"\n pmminclass = "..table_sets ["pmminclass"]..
"\n enableuserlog = "..table_sets ["enableuserlog"]..
"\n logallmyinfos = "..table_sets ["logallmyinfos"]..
"\n"..
"\n funrandomchat = "..table_sets ["funrandomchat"]..
"\n"..
"\n langfileprefix = "..table_sets ["langfileprefix"]..
"\n translitmode = "..table_sets ["translitmode"].."\n"

commandanswer (nick, atextlines..btextlines)

return 0
end

----- ---- --- -- -

function createtables ()
-- settings
VH:SQLQuery ("create table if not exists `"..tbl_sql ["conf"].."` (`variable` varchar(255) not null, `value` text not null, primary key (`variable`)) engine = myisam")

-- antispam
VH:SQLQuery ("create table if not exists `"..tbl_sql ["anti"].."` (`antispam` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', `priority` tinyint(1) unsigned not null default '0', `action` tinyint(1) unsigned not null default '0', `flags` tinyint(1) unsigned not null default '3', primary key (`antispam`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["antiex"].."` (`exception` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`exception`)) engine = myisam")

-- search filter
VH:SQLQuery ("create table if not exists `"..tbl_sql ["sefi"].."` (`filter` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', `priority` tinyint(1) unsigned not null default '0', `action` tinyint(1) unsigned not null default '0', `type` tinyint(1) unsigned not null default '1', primary key (`filter`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["sefiex"].."` (`exception` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`exception`)) engine = myisam")

-- myinfo
VH:SQLQuery ("create table if not exists `"..tbl_sql ["minick"].."` (`nick` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`nick`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["midesc"].."` (`description` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`description`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["mitag"].."` (`tag` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`tag`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["miconn"].."` (`connection` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`connection`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["miemail"].."` (`email` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`email`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["mishare"].."` (`share` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`share`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["miip"].."` (`ip` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`ip`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["miex"].."` (`exception` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`exception`)) engine = myisam")

-- welcome messages
VH:SQLQuery ("create table if not exists `"..tbl_sql ["wm"].."` (`nick` varchar(255) not null, `in` text not null, `out` text not null, primary key (`nick`)) engine = myisam")

-- custom nicks
VH:SQLQuery ("create table if not exists `"..tbl_sql ["cust"].."` (`nick` varchar(255) not null, `custom` varchar(255) not null, primary key (`nick`)) engine = myisam")

-- chatrooms
VH:SQLQuery ("create table if not exists `"..tbl_sql ["chat"].."` (`room` varchar(255) not null, `description` varchar(255) not null, `minclass` tinyint(2) unsigned not null default '0', `maxclass` tinyint(2) unsigned not null default '10', primary key (`room`)) engine = myisam")

-- reminders
VH:SQLQuery ("create table if not exists `"..tbl_sql ["rem"].."` (`id` varchar(255) not null, `content` text not null, `minclass` tinyint(2) unsigned not null default '0', `maxclass` tinyint(2) unsigned not null default '10', `pm` tinyint(1) unsigned not null default '0', `interval` smallint(5) unsigned not null default '10080', `timer` smallint(5) unsigned not null default '0', primary key (`id`)) engine = myisam")

-- news
VH:SQLQuery ("create table if not exists `"..tbl_sql ["news"].."` (`id` bigint(20) unsigned not null auto_increment, `date` int(10) unsigned not null, `by` varchar(255) not null, `item` text not null, primary key (`id`)) engine = myisam")

-- chat responder
VH:SQLQuery ("create table if not exists `"..tbl_sql ["mcresp"].."` (`id` bigint(20) unsigned not null auto_increment, `message` varchar(255) not null, `reply` text not null, `maxclass` tinyint(2) unsigned not null default '10', `occurred` bigint(20) unsigned not null default '0', primary key (`id`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["respex"].."` (`exception` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`exception`)) engine = myisam")

-- ip authorization
VH:SQLQuery ("create table if not exists `"..tbl_sql ["auth"].."` (`nick` varchar(255) not null, `ip` varchar(15) not null, `badip` varchar(15) not null default 'none', `good` bigint(20) unsigned not null default '0', `bad` bigint(20) unsigned not null default '0', primary key (`nick`)) engine = myisam")

-- releases
VH:SQLQuery ("create table if not exists `"..tbl_sql ["rel"].."` (`release` varchar(255) not null, `category` varchar(255) not null, `tth` varchar(255) not null, `by` varchar(255) not null, `date` int(10) unsigned not null, primary key (`release`)) engine = myisam")

-- ranks
VH:SQLQuery ("create table if not exists `"..tbl_sql ["chran"].."` (`nick` varchar(255) not null, `rank` bigint(20) unsigned not null default '1', primary key (`nick`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["opran"].."` (`nick` varchar(255) not null, `rank` bigint(20) unsigned not null default '1', primary key (`nick`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["shran"].."` (`nick` varchar(255) not null, `rank` bigint(20) unsigned not null default '1', primary key (`nick`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["wdran"].."` (`word` varchar(255) not null, `rank` bigint(20) unsigned not null default '1', primary key (`word`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["ranex"].."` (`nick` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`nick`)) engine = myisam")

-- offline messenger
VH:SQLQuery ("create table if not exists `"..tbl_sql ["off"].."` (`id` bigint(20) unsigned not null auto_increment, `from` varchar(255) not null, `ip` varchar(15) not null, `to` varchar(255) not null, `date` int(10) unsigned not null, `message` text not null, primary key (`id`)) engine = myisam")

-- chat history
VH:SQLQuery ("create table if not exists `"..tbl_sql ["mchist"].."` (`id` bigint(20) unsigned not null auto_increment, `realnick` varchar(255) not null, `nick` varchar(255) not null, `date` int(10) unsigned not null, `message` text not null, primary key (`id`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["ophist"].."` (`id` bigint(20) unsigned not null auto_increment, `nick` varchar(255) not null, `date` int(10) unsigned not null, `message` text not null, primary key (`id`)) engine = myisam")

-- commands
VH:SQLQuery ("create table if not exists `"..tbl_sql ["ledocmd"].."` (`original` varchar(255) not null, `new` varchar(255) not null, primary key (`original`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["cmd"].."` (`command` varchar(255) not null, `class` tinyint(2) unsigned not null default '11', `occurred` bigint(20) unsigned not null default '0', primary key (`command`)) engine = myisam")
VH:SQLQuery ("create table if not exists `"..tbl_sql ["cmdex"].."` (`exception` varchar(255) not null, `occurred` bigint(20) unsigned not null default '0', primary key (`exception`)) engine = myisam")

-- user logger
VH:SQLQuery ("create table if not exists `"..tbl_sql ["ulog"].."` (`id` bigint(20) unsigned not null auto_increment, `time` int(10) unsigned not null, `nick` varchar(255) not null, `ip` varchar(15) not null, `desc` varchar(255) not null, `tag` varchar(255) not null, `conn` varchar(255) not null, `email` varchar(255) not null, `share` bigint(20) unsigned not null, primary key (`id`)) engine = myisam")

return 0
end

----- ---- --- -- -

function droptables ()
for _, v in pairs (tbl_sql) do
VH:SQLQuery ("drop table `"..v.."`")
end
end

----- ---- --- -- -

function renametables ()
VH:SQLQuery ("alter ignore table `script_ledokol_settings` rename to `"..tbl_sql ["conf"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_antispam` rename to `"..tbl_sql ["anti"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_exceptions` rename to `"..tbl_sql ["antiex"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_searchfilter` rename to `"..tbl_sql ["sefi"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_sefiexceptions` rename to `"..tbl_sql ["sefiex"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_nicks` rename to `"..tbl_sql ["minick"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_descriptions` rename to `"..tbl_sql ["midesc"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_tags` rename to `"..tbl_sql ["mitag"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_connections` rename to `"..tbl_sql ["miconn"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_emails` rename to `"..tbl_sql ["miemail"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_shares` rename to `"..tbl_sql ["mishare"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_miips` rename to `"..tbl_sql ["miip"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_myinfoexceptions` rename to `"..tbl_sql ["miex"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_authorization` rename to `"..tbl_sql ["auth"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_releases` rename to `"..tbl_sql ["rel"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_welcomemessages` rename to `"..tbl_sql ["wm"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_customnicks` rename to `"..tbl_sql ["cust"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_chatrooms` rename to `"..tbl_sql ["chat"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_reminders` rename to `"..tbl_sql ["rem"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_hubnews` rename to `"..tbl_sql ["news"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_mcresponder` rename to `"..tbl_sql ["mcresp"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_respexceptions` rename to `"..tbl_sql ["respex"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_chatranks` rename to `"..tbl_sql ["chran"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_opranks` rename to `"..tbl_sql ["opran"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_shareranks` rename to `"..tbl_sql ["shran"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_wordranks` rename to `"..tbl_sql ["wdran"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_rankexceptions` rename to `"..tbl_sql ["ranex"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_offline` rename to `"..tbl_sql ["off"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_mchistory` rename to `"..tbl_sql ["mchist"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_ophistory` rename to `"..tbl_sql ["ophist"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_ledocommands` rename to `"..tbl_sql ["ledocmd"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_commands` rename to `"..tbl_sql ["cmd"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_cmdexceptions` rename to `"..tbl_sql ["cmdex"].."`")
VH:SQLQuery ("alter ignore table `script_ledokol_userlog` rename to `"..tbl_sql ["ulog"].."`")
end

----- ---- --- -- -

function altertables ()
-- settings
VH:SQLQuery ("alter ignore table `"..tbl_sql ["conf"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["conf"].."` change column `variable` `variable` varchar(255) not null") -- variable
VH:SQLQuery ("alter ignore table `"..tbl_sql ["conf"].."` change column `value` `value` text not null") -- value

-- antispam
VH:SQLQuery ("alter ignore table `"..tbl_sql ["anti"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["anti"].."` change column `antispam` `antispam` varchar(255) not null") -- antispam
VH:SQLQuery ("alter ignore table `"..tbl_sql ["anti"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred
VH:SQLQuery ("alter ignore table `"..tbl_sql ["anti"].."` add column `priority` tinyint(1) unsigned not null default '0' after `occurred`") -- priority
VH:SQLQuery ("alter ignore table `"..tbl_sql ["anti"].."` change column `action` `action` tinyint(1) unsigned not null default '0'") -- action
VH:SQLQuery ("alter ignore table `"..tbl_sql ["anti"].."` add column `flags` tinyint(1) unsigned not null default '3' after `action`") -- flags

VH:SQLQuery ("alter ignore table `"..tbl_sql ["antiex"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["antiex"].."` change column `exception` `exception` varchar(255) not null") -- exception
VH:SQLQuery ("alter ignore table `"..tbl_sql ["antiex"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

-- search filter
VH:SQLQuery ("alter ignore table `"..tbl_sql ["sefi"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["sefi"].."` change column `filter` `filter` varchar(255) not null") -- filter
VH:SQLQuery ("alter ignore table `"..tbl_sql ["sefi"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred
VH:SQLQuery ("alter ignore table `"..tbl_sql ["sefi"].."` add column `priority` tinyint(1) unsigned not null default '0' after `occurred`") -- priority
VH:SQLQuery ("alter ignore table `"..tbl_sql ["sefi"].."` change column `action` `action` tinyint(1) unsigned not null default '0'") -- action
VH:SQLQuery ("alter ignore table `"..tbl_sql ["sefi"].."` add column `type` tinyint(1) unsigned not null default '1' after `action`") -- type

VH:SQLQuery ("alter ignore table `"..tbl_sql ["sefiex"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["sefiex"].."` change column `exception` `exception` varchar(255) not null") -- exception
VH:SQLQuery ("alter ignore table `"..tbl_sql ["sefiex"].."` change column `occurred` `occurred` bigint(20) unsigned not null default '0'") -- occurred

-- myinfo
VH:SQLQuery ("alter ignore table `"..tbl_sql ["minick"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["minick"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter ignore table `"..tbl_sql ["minick"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter ignore table `"..tbl_sql ["midesc"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["midesc"].."` change column `description` `description` varchar(255) not null") -- description
VH:SQLQuery ("alter ignore table `"..tbl_sql ["midesc"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter ignore table `"..tbl_sql ["mitag"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mitag"].."` change column `tag` `tag` varchar(255) not null") -- tag
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mitag"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter ignore table `"..tbl_sql ["miconn"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["miconn"].."` change column `connection` `connection` varchar(255) not null") -- connection
VH:SQLQuery ("alter ignore table `"..tbl_sql ["miconn"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter ignore table `"..tbl_sql ["miemail"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["miemail"].."` change column `email` `email` varchar(255) not null") -- email
VH:SQLQuery ("alter ignore table `"..tbl_sql ["miemail"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter ignore table `"..tbl_sql ["mishare"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mishare"].."` change column `share` `share` varchar(255) not null") -- share
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mishare"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter ignore table `"..tbl_sql ["miip"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["miip"].."` change column `ip` `ip` varchar(255) not null") -- ip
VH:SQLQuery ("alter ignore table `"..tbl_sql ["miip"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter ignore table `"..tbl_sql ["miex"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["miex"].."` change column `exception` `exception` varchar(255) not null") -- exception
VH:SQLQuery ("alter ignore table `"..tbl_sql ["miex"].."` change column `occured` `occurred` bigint(20) unsigned not null default '0'") -- occurred

-- ip authorization
VH:SQLQuery ("alter ignore table `"..tbl_sql ["auth"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["auth"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter ignore table `"..tbl_sql ["auth"].."` change column `ip` `ip` varchar(15) not null") -- ip
VH:SQLQuery ("alter ignore table `"..tbl_sql ["auth"].."` add column `badip` varchar(15) not null default 'none' after `ip`") -- badip
VH:SQLQuery ("alter ignore table `"..tbl_sql ["auth"].."` change column `badip` `badip` varchar(15) not null default 'none'") -- badip
VH:SQLQuery ("alter ignore table `"..tbl_sql ["auth"].."` change column `good` `good` bigint(20) unsigned not null default '0'") -- good
VH:SQLQuery ("alter ignore table `"..tbl_sql ["auth"].."` change column `bad` `bad` bigint(20) unsigned not null default '0'") -- bad

-- releases
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rel"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rel"].."` change column `release` `release` varchar(255) not null") -- release
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rel"].."` change column `category` `category` varchar(255) not null") -- category
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rel"].."` add column `tth` varchar(255) not null after `category`") -- tth
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rel"].."` change column `by` `by` varchar(255) not null") -- by
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rel"].."` change column `date` `date` int(10) unsigned not null") -- date

-- welcome messages
VH:SQLQuery ("alter ignore table `"..tbl_sql ["wm"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["wm"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter ignore table `"..tbl_sql ["wm"].."` change column `in` `in` text not null") -- in
VH:SQLQuery ("alter ignore table `"..tbl_sql ["wm"].."` change column `out` `out` text not null") -- out

-- custom nicks
VH:SQLQuery ("alter ignore table `"..tbl_sql ["cust"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["cust"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter ignore table `"..tbl_sql ["cust"].."` change column `custom` `custom` varchar(255) not null") -- custom

-- chatrooms
VH:SQLQuery ("alter ignore table `"..tbl_sql ["chat"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["chat"].."` change column `room` `room` varchar(255) not null") -- room
VH:SQLQuery ("alter ignore table `"..tbl_sql ["chat"].."` change column `description` `description` varchar(255) not null") -- description
VH:SQLQuery ("alter ignore table `"..tbl_sql ["chat"].."` change column `minclass` `minclass` tinyint(2) unsigned not null default '0'") -- minclass
VH:SQLQuery ("alter ignore table `"..tbl_sql ["chat"].."` change column `maxclass` `maxclass` tinyint(2) unsigned not null default '10'") -- maxclass

-- reminders
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rem"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rem"].."` change column `id` `id` varchar(255) not null") -- id
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rem"].."` change column `content` `content` text not null") -- content
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rem"].."` change column `minclass` `minclass` tinyint(2) unsigned not null default '0'") -- minclass
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rem"].."` change column `maxclass` `maxclass` tinyint(2) unsigned not null default '10'") -- maxclass
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rem"].."` change column `pm` `pm` tinyint(1) unsigned not null default '0'") -- pm
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rem"].."` change column `interval` `interval` smallint(5) unsigned not null default '10080'") -- interval
VH:SQLQuery ("alter ignore table `"..tbl_sql ["rem"].."` change column `timer` `timer` smallint(5) unsigned not null default '0'") -- timer

-- news
VH:SQLQuery ("alter ignore table `"..tbl_sql ["news"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["news"].."` change column `id` `id` bigint(20) unsigned auto_increment") -- id
VH:SQLQuery ("alter ignore table `"..tbl_sql ["news"].."` change column `date` `date` int(10) unsigned not null") -- date
VH:SQLQuery ("alter ignore table `"..tbl_sql ["news"].."` change column `by` `by` varchar(255) not null") -- by
VH:SQLQuery ("alter ignore table `"..tbl_sql ["news"].."` change column `item` `item` text not null") -- item

-- chat responder
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mcresp"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mcresp"].."` drop primary key")
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mcresp"].."` add column `id` bigint(20) unsigned auto_increment first, add primary key (`id`)") -- id
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mcresp"].."` change column `message` `message` varchar(255) not null") -- message
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mcresp"].."` change column `reply` `reply` text not null") -- reply
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mcresp"].."` add column `maxclass` tinyint(2) unsigned not null default '10' after `reply`") -- maxclass
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mcresp"].."` change column `occurred` `occurred` bigint(20) unsigned not null default '0'") -- occurred

VH:SQLQuery ("alter ignore table `"..tbl_sql ["respex"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["respex"].."` change column `nick` `exception` varchar(255) not null") -- exception
VH:SQLQuery ("alter ignore table `"..tbl_sql ["respex"].."` change column `occurred` `occurred` bigint(20) unsigned not null default '0'") -- occurred

-- ranks
VH:SQLQuery ("alter ignore table `"..tbl_sql ["chran"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["chran"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter ignore table `"..tbl_sql ["chran"].."` change column `rank` `rank` bigint(20) unsigned not null default '1'") -- rank

VH:SQLQuery ("alter ignore table `"..tbl_sql ["opran"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["opran"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter ignore table `"..tbl_sql ["opran"].."` change column `rank` `rank` bigint(20) unsigned not null default '1'") -- rank

VH:SQLQuery ("alter ignore table `"..tbl_sql ["shran"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["shran"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter ignore table `"..tbl_sql ["shran"].."` change column `rank` `rank` bigint(20) unsigned not null default '1'") -- rank

VH:SQLQuery ("alter ignore table `"..tbl_sql ["wdran"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["wdran"].."` change column `word` `word` varchar(255) not null") -- word
VH:SQLQuery ("alter ignore table `"..tbl_sql ["wdran"].."` change column `rank` `rank` bigint(20) unsigned not null default '1'") -- rank

VH:SQLQuery ("alter ignore table `"..tbl_sql ["ranex"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["ranex"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter ignore table `"..tbl_sql ["ranex"].."` add column `occurred` bigint(20) unsigned not null default '0' after `nick`") -- occurred

-- offline messenger
VH:SQLQuery ("alter ignore table `"..tbl_sql ["off"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["off"].."` change column `id` `id` bigint(20) unsigned auto_increment") -- id
VH:SQLQuery ("alter ignore table `"..tbl_sql ["off"].."` change column `from` `from` varchar(255) not null") -- from
VH:SQLQuery ("alter ignore table `"..tbl_sql ["off"].."` change column `ip` `ip` varchar(15) not null") -- ip
VH:SQLQuery ("alter ignore table `"..tbl_sql ["off"].."` change column `to` `to` varchar(255) not null") -- to
VH:SQLQuery ("alter ignore table `"..tbl_sql ["off"].."` change column `date` `date` int(10) unsigned not null") -- date
VH:SQLQuery ("alter ignore table `"..tbl_sql ["off"].."` change column `message` `message` text not null") -- message

-- chat history
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mchist"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mchist"].."` change column `id` `id` bigint(20) unsigned auto_increment") -- id
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mchist"].."` add column `realnick` varchar(255) not null after `id`") -- realnick
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mchist"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mchist"].."` change column `date` `date` int(10) unsigned not null") -- date
VH:SQLQuery ("alter ignore table `"..tbl_sql ["mchist"].."` change column `message` `message` text not null") -- message

VH:SQLQuery ("alter ignore table `"..tbl_sql ["ophist"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["ophist"].."` change column `id` `id` bigint(20) unsigned auto_increment") -- id
VH:SQLQuery ("alter ignore table `"..tbl_sql ["ophist"].."` change column `nick` `nick` varchar(255) not null") -- nick
VH:SQLQuery ("alter ignore table `"..tbl_sql ["ophist"].."` change column `date` `date` int(10) unsigned not null") -- date
VH:SQLQuery ("alter ignore table `"..tbl_sql ["ophist"].."` change column `message` `message` text not null") -- message

-- commands
VH:SQLQuery ("alter ignore table `"..tbl_sql ["ledocmd"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["ledocmd"].."` change column `original` `original` varchar(255) not null") -- original
VH:SQLQuery ("alter ignore table `"..tbl_sql ["ledocmd"].."` change column `new` `new` varchar(255) not null") -- new

VH:SQLQuery ("alter ignore table `"..tbl_sql ["cmd"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["cmd"].."` change column `command` `command` varchar(255) not null") -- command
VH:SQLQuery ("alter ignore table `"..tbl_sql ["cmd"].."` change column `class` `class` tinyint(2) unsigned not null default '11'") -- class
VH:SQLQuery ("alter ignore table `"..tbl_sql ["cmd"].."` add column `occurred` bigint(20) unsigned not null default '0' after `class`") -- occurred

VH:SQLQuery ("alter ignore table `"..tbl_sql ["cmdex"].."` engine = myisam") -- engine
VH:SQLQuery ("alter ignore table `"..tbl_sql ["cmdex"].."` change column `exception` `exception` varchar(255) not null") -- exception
VH:SQLQuery ("alter ignore table `"..tbl_sql ["cmdex"].."` change column `occurred` `occurred` bigint(20) unsigned not null default '0'") -- occurred

-- user log
-- not added
end

----- ---- --- -- -

function createsettings ()
for k, v in pairs (table_sets) do -- create settings
VH:SQLQuery ("insert ignore into `"..tbl_sql ["conf"].."` (`variable`, `value`) values ('"..repsqlchars (k).."', '"..repsqlchars (v).."')")
end

for k, v in pairs (table_cmnds) do -- create commands
VH:SQLQuery ("insert ignore into `"..tbl_sql ["ledocmd"].."` (`original`, `new`) values ('"..repsqlchars (k).."', '"..repsqlchars (v).."')")
end

-- own stuff begin

--local _, rows = VH:SQLQuery ("select `variable` from `"..tbl_sql ["conf"].."` where `variable` = 'cmdinstalled' limit 1") -- add commands i prefer to forbid

--if rows == 0 then
--VH:SQLQuery ("insert ignore into `"..tbl_sql ["cmd"].."` (`command`) values "..
--"('"..repsqlchars ("^$").."')")
--end

local _, rows = VH:SQLQuery ("select `variable` from `"..tbl_sql ["conf"].."` where `variable` = 'cmdexinstalled' limit 1") -- add commands i prefer to except

if rows == 0 then
VH:SQLQuery ("insert ignore into `"..tbl_sql ["cmdex"].."` (`exception`) values "..

"('"..repsqlchars ("^!drop .+$").."'), "..
"('"..repsqlchars ("^!rpass .+$").."'), "..
"('"..repsqlchars ("^!rpasswd .+$").."'), "..
"('"..repsqlchars ("^!regpass .+$").."'), "..
"('"..repsqlchars ("^!regpasswd .+$").."'), "..
"('"..repsqlchars ("^%+msgsend .+$").."'), "..
"('"..repsqlchars ("^%+report .+$").."'), "..
"('"..repsqlchars ("^%+passwd .*$").."'), "..
"('"..repsqlchars ("^%+regme").."')")
end

-- own stuff end

for k, v in pairs (table_hidsets) do -- create hidden settings
VH:SQLQuery ("insert ignore into `"..tbl_sql ["conf"].."` (`variable`, `value`) values ('"..repsqlchars (k).."', '"..repsqlchars (v).."')")
end

-- update variables
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '"..table_othsets ["ver_ledo"].."' where `variable` = 'ver_ledo' limit 1")

return 0
end

----- ---- --- -- -

function loadsettings ()
for k, _ in pairs (table_sets) do -- load settings
local _, rows = VH:SQLQuery ("select `value` from `"..tbl_sql ["conf"].."` where `variable` = '"..repsqlchars (k).."' limit 1")

if rows > 0 then
local _, val = VH:SQLFetch (0)
table_sets [k] = tonumber (val) or val
end
end

for k, _ in pairs (table_cmnds) do -- load commands
_, rows = VH:SQLQuery ("select `new` from `"..tbl_sql ["ledocmd"].."` where `original` = '"..repsqlchars (k).."' limit 1")

if rows > 0 then
local _, val = VH:SQLFetch (0)
table_cmnds [k] = val
end
end

return 0
end

----- ---- --- -- -

function loadlangfile (nick)
table_lang = table_lang_def -- load default table to begin with

if string.len (table_sets ["langfileprefix"]) > 0 then
local l = loadfile (table_othsets ["dif_vhcfg"].."scripts/ledo_"..table_sets ["langfileprefix"]..".txt") -- try to load the file

if not l then -- file not found, or has syntax errors?
table_sets ["langfileprefix"] = ""
VH:SQLQuery ("update `"..tbl_sql ["conf"].."` set `value` = '' where `variable` = 'langfileprefix' limit 1")

if nick then
commandanswer (nick, getlang (466))
end

else
l () -- define the chunk
table_lang = f () -- return the function as a global table
end
end

return 0
end

----- ---- --- -- -

function getlang (var)
local str = repnmdcoutchars (table_lang [var] or table_lang_def [var] or "[error]") -- fall back

return str
end

----- ---- --- -- -

function convtranslit (str, mode)
local cnv = str

for _, v in pairs (tbl_translit) do
if mode == 1 then -- cyr -> lat
cnv = string.gsub (cnv, v.cyr, v.lat)
elseif mode == 2 then -- lat -> cyr
cnv = string.gsub (cnv, v.lat, v.cyr)
end
end

return cnv
end

----- ---- --- -- -

function addhubrobot (nick, desc, share)
VH:AddRobot (nick, 10, desc, string.char (1), "", share)

return 0
end

----- ---- --- -- -

function delhubrobot (nick)
VH:DelRobot (nick)

return 0
end

----- ---- --- -- -

function getownsize ()
local sz = 0
local f = io.open (table_othsets ["dif_vhcfg"].."scripts/ledokol.lua", "r")

if f then
sz = f:seek ("end")
f:close ()
end

return sz
end

----- ---- --- -- -

function getmemusg ()
local sz = 0

if string.sub (table_othsets ["ver_lua"], 1, 3) == "5.0" then
collectgarbage ()
sz, _ = gcinfo ()
else
collectgarbage ("collect")
sz = collectgarbage ("count")
end

return sz * 1024 -- return in bytes
end

----- ---- --- -- -

function loadcomponents ()

-- configuration directory
local res, _ = pcall (function () _, table_othsets ["dif_vhcfg"] = VH:GetVHCfgDir () end)

if not res then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to run VH:GetVHCfgDir|", 5, 10)
table_othsets ["dif_vhcfg"] = os.getenv ("VERLIHUB_CFG")

if not table_othsets ["dif_vhcfg"] then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to get VERLIHUB_CFG|", 5, 10)
local paths = {"", "/usr/local/bin/", "/usr/bin/"}

for _, v in pairs (paths) do
os.execute (v.."vh_getcfg > \""..table_othsets ["ledotmpdir"]..table_othsets ["ledotmpfile"].."\"")
local f = io.open (table_othsets ["ledotmpdir"]..table_othsets ["ledotmpfile"], "r")

if f then
local line = f:read ("*line") -- read only first line

if (line) and (string.len (line) > 0) then
table_othsets ["dif_vhcfg"] = line
break
end

f:close ()
os.remove (table_othsets ["ledotmpdir"]..table_othsets ["ledotmpfile"])
end
end

if (not table_othsets ["dif_vhcfg"]) or (string.len (table_othsets ["dif_vhcfg"]) == 0) then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Error: Unable to run vh_getcfg.sh|", 5, 10)

return true
end
end
end

if string.sub (table_othsets ["dif_vhcfg"], string.len (table_othsets ["dif_vhcfg"]), -1) ~= "/" then
table_othsets ["dif_vhcfg"] = table_othsets ["dif_vhcfg"].."/" -- small modification
end

-- nicklist
if not getnicklist () then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Error: Unable to run VH:GetNickList|", 5, 10)

return true
end

-- lua version
table_othsets ["ver_lua"] = string.sub (_VERSION, 5, -1)

if not table_othsets ["ver_lua"] then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to detect Lua version|", 5, 10)
else -- ok

if string.sub (table_othsets ["ver_lua"], 1, 3) == "5.0" then
string.gmatch = string.gfind -- lua 5.0 fix
end
end

-- mysql version
VH:SQLQuery ("select version()")
_, table_othsets ["ver_sql"] = VH:SQLFetch (0)

if not table_othsets ["ver_sql"] then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to detect MySQL version|", 5, 10)
end

-- load socket
local res, err = pcall (function () lsock = require ("socket") end)

if not res then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to load LuaSocket module: "..repnmdcoutchars (err).."|", 5, 10)
else

-- luasocket version
table_othsets ["ver_sock"] = string.sub (lsock._VERSION, 11, -1)

if not table_othsets ["ver_sock"] then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to detect LuaSocket version|", 5, 10)
end

-- load socket.http
local res, err = pcall (function () lsockhttp = require ("socket.http") end)

if not res then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to load LuaSocket HTTP module: "..repnmdcoutchars (err).."|", 5, 10)
end

-- load ltn12
local res, err = pcall (function () lsockltn12 = require ("ltn12") end)

if not res then
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> Warning: Unable to load LuaSocket LTN12 module: "..repnmdcoutchars (err).."|", 5, 10)
end
end

return false
end

----- ---- --- -- -

function getstatus (nick)
local nl = getnicklist ()
local lusr = string.lower (nick)

for user in string.gmatch (nl, "([^$]+)%$%$") do
if string.lower (user) == lusr then
return 1
end
end

return 0
end

----- ---- --- -- -

function getrandomnick (nick)
local nl = getnicklist ()
local users = {}

for user in string.gmatch (nl, "([^$]+)%$%$") do
table.insert (users, user)
end

return users [math.random (table.getn (users))]
end

----- ---- --- -- -

function getregclass (nick)
local _, rows = VH:SQLQuery ("select `class` from `reglist` where `nick` = '"..repsqlchars (nick).."' limit 1")

if rows > 0 then
local _, val = VH:SQLFetch (0)
return tonumber (val) or -2
else
return nil
end
end

----- ---- --- -- -

function getclass (nick)
local res, cls = VH:GetUserClass (nick)

if res and cls then
return cls
else
return -2
end
end

----- ---- --- -- -

function getmyinfo (nick)
local _, mi = VH:GetMyINFO (nick)

if mi and (string.len (mi) > 0) then
return mi
else
return nil
end
end

----- ---- --- -- -

function getusercount ()
local _, cnt = VH:GetUsersCount ()

if cnt then
return cnt
else
return 0
end
end

----- ---- --- -- -

function gettotsharesize ()
local _, sz = VH:GetTotalShareSize ()

if sz then
return makesize (sz)
else
return makesize (0)
end
end

----- ---- --- -- -

function getnicklist ()
local _, nl = VH:GetNickList ()

if nl and (string.len (nl) > 13) then
return string.sub (nl, 11)
else
return nil
end
end

----- ---- --- -- -

function getip (nick)
local _, ip = VH:GetUserIP (nick)

if ip and (string.len (ip) > 0) then
return ip
else
return "[unknown]"
end
end

----- ---- --- -- -

function getcc (nick)
local _, cc = VH:GetUserCC (nick)

if cc and (string.len (cc) > 0) then
return cc
else
return "[unknown]"
end
end

----- ---- --- -- -

function gethost (nick)
if getconfig ("dns_lookup") == 1 then -- enabled
local _, host = VH:GetUserHost (nick)

if host and (string.len (host) > 0) then
return host
else
return "[unknown]"
end

else
return "[disabled]"
end
end

----- ---- --- -- -

function getconfig (var)
local _, cfg = VH:GetConfig ("config", var)

if cfg then
if cfg == "Error calling GetConfig API" then return nil else return tonumber (cfg) or cfg end
else
return nil
end
end

----- ---- --- -- -

function repsqlchars (txt)
local ret = string.gsub (txt, string.char (92), string.char (92)..string.char (92)) -- backslash
ret = string.gsub (ret, string.char (34), string.char (92)..string.char (34)) -- double quote
ret = string.gsub (ret, string.char (39), string.char (92)..string.char (39)) -- single quote

return ret
end

----- ---- --- -- -

function repdatechars (txt)
local str = string.gsub (txt, "%-", "%%-")

return str
end

----- ---- --- -- -

function reprexpchars (txt)
local str = string.gsub (txt, "%%", "%%%%")

return str
end

----- ---- --- -- -

function repsrchchars (txt)
local str = string.gsub (txt, "%$", " ")

return str
end

----- ---- --- -- -

function repnmdcoutchars (txt)
local ret = string.gsub (txt, "%$", "&#36;")
ret = string.gsub (ret, "|", "&#124;")

return ret
end

----- ---- --- -- -

function repnmdcinchars (txt)
local ret = string.gsub (txt, "&#36;", "%$")
ret = string.gsub (ret, "&#124;", "|")

return ret
end

----- ---- --- -- -

function repnickchars (txt)
local ret = string.gsub (txt, "<", "_")
ret = string.gsub (ret, ">", "_")
ret = string.gsub (ret, string.char (32), string.char (160)) -- space to non breaking space

return ret
end

----- ---- --- -- -

function repwordranchars (str, stage)
local txt = ""

if stage == 0 then
txt = string.gsub (str, string.char (190), "%$") -- three fourths
txt = string.gsub (txt, string.char (189), "%$") -- one half
txt = string.gsub (txt, string.char (188), "%$") -- one fourth
txt = string.gsub (txt, string.char (187), "%$") -- right angle quote
txt = string.gsub (txt, string.char (182), "%$") -- paragraph sign
txt = string.gsub (txt, string.char (174), "%$") -- registered trademark
txt = string.gsub (txt, string.char (171), "%$") -- left angle quote
txt = string.gsub (txt, string.char (169), "%$") -- copyright
txt = string.gsub (txt, string.char (167), "%$") -- section sign
txt = string.gsub (txt, string.char (166), "%$") -- broken vertical bar
txt = string.gsub (txt, string.char (164), "%$") -- general currency sign
txt = string.gsub (txt, string.char (163), "%$") -- pound sterling
txt = string.gsub (txt, string.char (162), "%$") -- cent sign
txt = string.gsub (txt, string.char (126), "%$") -- tilde
txt = string.gsub (txt, string.char (125), "%$") -- right curly brace
txt = string.gsub (txt, string.char (124), "%$") -- vertical bar
txt = string.gsub (txt, string.char (123), "%$") -- left curly brace
txt = string.gsub (txt, "%"..string.char (94), "%$") -- caret
txt = string.gsub (txt, "%"..string.char (93), "%$") -- right square bracket
txt = string.gsub (txt, string.char (92), "%$") -- backslash
txt = string.gsub (txt, "%"..string.char (91), "%$") -- left square bracket
txt = string.gsub (txt, string.char (64), "%$") -- at sign
txt = string.gsub (txt, "%"..string.char (63), "%$") -- question mark
txt = string.gsub (txt, string.char (62), "%$") -- greater than sign
txt = string.gsub (txt, string.char (61), "%$") -- equals sign
txt = string.gsub (txt, string.char (60), "%$") -- less than sign
txt = string.gsub (txt, string.char (59), "%$") -- semicolon
txt = string.gsub (txt, string.char (58), "%$") -- colon
txt = string.gsub (txt, string.char (47), "%$") -- slash
txt = string.gsub (txt, string.char (44), "%$") -- comma
txt = string.gsub (txt, "%"..string.char (43), "%$") -- plus sign
txt = string.gsub (txt, "%"..string.char (42), "%$") -- asterisk
txt = string.gsub (txt, "%"..string.char (41), "%$") -- right parenthesis
txt = string.gsub (txt, "%"..string.char (40), "%$") -- left parenthesis
txt = string.gsub (txt, "%"..string.char (37), "%$") -- percent sign
txt = string.gsub (txt, string.char (35), "%$") -- number sign
txt = string.gsub (txt, string.char (34), "%$") -- double quotation mark
txt = string.gsub (txt, string.char (33), "%$") -- exclamation mark
txt = string.gsub (txt, string.char (32), "%$") -- space
txt = string.gsub (txt, "\r", "%$")
txt = string.gsub (txt, "\n", "%$")
txt = string.gsub (txt, "\t", "%$")
else
txt = string.gsub (str, "^["..string.char (160).."]+", "") -- non breaking space
txt = string.gsub (txt, "["..string.char (160).."]+$", "")
txt = string.gsub (txt, "^["..string.char (95).."]+", "") -- underscore
txt = string.gsub (txt, "["..string.char (95).."]+$", "")
txt = string.gsub (txt, "^[%"..string.char (46).."]+", "") -- period
txt = string.gsub (txt, "[%"..string.char (46).."]+$", "")
txt = string.gsub (txt, "^[%"..string.char (45).."]+", "") -- hyphen
txt = string.gsub (txt, "[%"..string.char (45).."]+$", "")
txt = string.gsub (txt, "^["..string.char (38).."]+", "") -- ampersand
txt = string.gsub (txt, "["..string.char (38).."]+$", "")
txt = string.gsub (txt, "%"..string.char (36), "") -- dollar sign
end

return txt
end

----- ---- --- -- -

function reptextvars (str, var_nick, var_message)
local ntime = os.time () + table_sets ["srvtimediff"]
local var_date = os.date (table_sets ["dateformat"], ntime)
local var_time = os.date (table_sets ["timeformat"], ntime)
local txt = str

if var_nick ~= nil then -- skip for reminder
txt = string.gsub (txt, "<nick>", reprexpchars (var_nick))
txt = string.gsub (txt, "<message>", reprexpchars (var_message))
end

txt = string.gsub (txt, "<date>", reprexpchars (var_date))
txt = string.gsub (txt, "<time>", reprexpchars (var_time))
txt = string.gsub (txt, "<hubname>", reprexpchars (getconfig ("hub_name")))
txt = string.gsub (txt, "<topic>", reprexpchars (table_othsets ["topicvalue"] or ""))
txt = string.gsub (txt, "<hubdesc>", reprexpchars (getconfig ("hub_desc")))
txt = string.gsub (txt, "<hubcat>", reprexpchars (getconfig ("hub_category")))
txt = string.gsub (txt, "<hubown>", reprexpchars (getconfig ("hub_owner")))
txt = string.gsub (txt, "<hubver>", reprexpchars (getconfig ("hub_version")))
txt = string.gsub (txt, "<hubbot>", reprexpchars (getconfig ("hub_security")))
txt = string.gsub (txt, "<hubopch>", reprexpchars (getconfig ("opchat_name")))
txt = string.gsub (txt, "<hubhost>", reprexpchars (getconfig ("hub_host")))
txt = string.gsub (txt, "<hubport>", reprexpchars (getconfig ("listen_port")))
txt = string.gsub (txt, "<hubmaxusr>", reprexpchars (getconfig ("max_users")))
txt = string.gsub (txt, "<hubminsh>", reprexpchars (getconfig ("min_share")))
txt = string.gsub (txt, "<hubmaxsh>", reprexpchars (getconfig ("max_share")))
txt = string.gsub (txt, "<ledover>", reprexpchars (table_othsets ["ver_ledo"]))
txt = string.gsub (txt, "<suptshrt>", reprexpchars (formatuptime (true)))
txt = string.gsub (txt, "<suptlong>", reprexpchars (formatuptime (false)))
txt = string.gsub (txt, "<usercnt>", reprexpchars (getusercount ()))
txt = string.gsub (txt, "<totshare>", reprexpchars (gettotsharesize ()))
txt = string.gsub (txt, "<memusg>", reprexpchars (makesize (getmemusg ())))

return txt
end

----- ---- --- -- -

function fromunixtime (nixtime)
local ntm = tonumber (nixtime) or 0

return os.date (table_sets ["dateformat"].." "..table_sets ["timeformat"], ntm)
end

----- ---- --- -- -

function inleadingzeroes (ml, cl)
local zr = ""

for x = 1, ml - string.len (cl) do
zr = zr.."0"
end

return zr..cl
end

----- ---- --- -- -

function makespace (num)
local sspc = ""

for x = 1, num do
sspc = sspc.." "
end

return sspc
end

----- ---- --- -- -

function roundint (int, len)
local nint = tonumber (string.format ("%."..(len or 0).."f", int))

return nint
end

----- ---- --- -- -

function makesize (bytes)
local b = tonumber (bytes) or 0

if b >= 1152921504606846976 then -- eib
local sz = roundint (b / 1152921504606846976, 2)
return sz.." "..getlang (366)
end

if b >= 1125899906842624 then -- pib
local sz = roundint (b / 1125899906842624, 2)
return sz.." "..getlang (360)
end

if b >= 1099511627776 then -- tib
local sz = roundint (b / 1099511627776, 2)
return sz.." "..getlang (361)
end

if b >= 1073741824 then -- gib
local sz = roundint (b / 1073741824, 2)
return sz.." "..getlang (362)
end

if b >= 1048576 then -- mib
local sz = roundint (b / 1048576, 2)
return sz.." "..getlang (363)
end

if b >= 1024 then -- kib
local sz = roundint (b / 1024, 2)
return sz.." "..getlang (364)
end

return b.." "..getlang (365)
end

----- ---- --- -- -

function formatuptime (fmt)
local t = os.date ("!*t", os.time () - table_othsets ["uptime"])
t.month = t.month - 1
t.day = t.day - 1
local ret = ""

if fmt == true then -- short
ret = t.month..":"..t.day..":"..t.hour..":"..t.min..":"..t.sec
else -- long

if t.month > 0 then
if t.month == 1 then ret = ret..t.month.." month " else ret = ret..t.month.." months " end
end

if t.day > 0 then
if t.day == 1 then ret = ret..t.day.." day " else ret = ret..t.day.." days " end
end

if t.hour > 0 then
if t.hour == 1 then ret = ret..t.hour.." hour " else ret = ret..t.hour.." hours " end
end

if t.min > 0 then
if t.min == 1 then ret = ret..t.min.." minute " else ret = ret..t.min.." minutes " end
end

if t.sec == 1 then ret = ret..t.sec.." second" else ret = ret..t.sec.." seconds" end
end

return ret
end

----- ---- --- -- -

function counttable (tbl)
local _, rows = VH:SQLQuery ("select count(*) from `"..tbl.."`")
local num = 0

if rows > 0 then
_, num = VH:SQLFetch (0)
num = tonumber (num)
end

return num
end

----- ---- --- -- -

function cleantablebyclass (limit, tbl)
local _, rows = VH:SQLQuery ("select `nick` from `"..tbl.."`")

if rows > 0 then
local table_delete = {}

for x = 0, rows - 1 do
local _, usr = VH:SQLFetch (x)

if getclass (usr) < limit then
table_delete [usr] = x
end
end

for k, _ in pairs (table_delete) do
VH:SQLQuery ("delete from `"..tbl.."` where `nick` = '"..repsqlchars (k).."' limit 1")
end
end

return 0
end

----- ---- --- -- -

function isbot (nick)
if (nick == table_othsets ["botnick"]) or (nick == table_othsets ["opchatnick"]) or (nick == table_othsets ["lasttimenick"]) or (nick == table_sets ["ledobotnick"]) or (ischatroom (nick) == 1) then

return 1
end

return 0
end

--[[

function isbot (nick) -- verlihub 0.9.8e and later
local _, bot = VH:GetConfig ("config", "hub_security") -- security bot
if nick == bot then return true end
_, bot = VH:GetConfig ("config", "opchat_name") -- operators chat
if nick == bot then return true end
local bots = VH:GetBots () -- other registered bots

for _, v in pairs (bots) do
if nick == v ["sNick"] then return true end
end

return false
end

]]--

----- ---- --- -- -

function antiscan (nick, cls, msg, tp, to, sts) -- tp: 1 = mc, 2 = pm, 3 = offline, 4 = report
if table_sets ["enableantispam"] == 0 then return 1 end
if cls >= table_sets ["scanbelowclass"] then return 1 end
if ((tp == 2) or (tp == 3)) and (table_sets ["allowspamtoops"] == 1) and (getclass (to) >= 3) then return 1 end
if string.len (msg) == 0 then return 1 end
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["antiex"].."`")
local exlist = {} -- prepare exceptions

for x = 0, rows - 1 do
local _, ent = VH:SQLFetch (x)
table.insert (exlist, ent)
end

local lmsg = string.lower (repnmdcinchars (msg))
local flag = 1
if (tp == 2) or (tp == 3) then flag = 2 end
_, rows = VH:SQLQuery ("select `antispam`, `priority`, `action` from `"..tbl_sql ["anti"].."` where `flags` = "..flag.." or `flags` = 3 order by `priority` desc, `occurred` desc")

for x = 0, rows - 1 do
local _, ent, prio, act = VH:SQLFetch (x)

if string.find (lmsg, ent) then
VH:SQLQuery ("update `"..tbl_sql ["anti"].."` set `occurred` = `occurred` + 1 where `antispam` = '"..repsqlchars (ent).."' limit 1")

if tonumber (prio) < 7 then -- skip for 7, 8 and 9
for _, v in pairs (exlist) do
if string.find (lmsg, v) then
VH:SQLQuery ("update `"..tbl_sql ["antiex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (v).."' limit 1")
local note = 540

if tp == 2 then note = 541
elseif tp == 3 then note = 542
elseif tp == 4 then note = 543
end

opsnotify (table_sets ["classnotiex"], string.format (getlang (note), nick, getip (nick), cls, msg))
return 1
end
end
end

act = tonumber (act)

if act == 5 then
local note = 544

if tp == 2 then note = 545
elseif tp == 3 then note = 546
elseif tp == 4 then note = 547
end

opsnotify (table_sets ["classnotianti"], string.format (getlang (note), nick, getip (nick), cls, msg))
return 1
end

if act == 4 then -- special action
if tp == 1 then
maintoself (nick, msg)
elseif tp == 3 then
if sts == 1 then
commandanswer (nick, string.format (getlang (27), to))
else
commandanswer (nick, string.format (getlang (28), to))
end
end

else

if tp == 1 then
maintouser (nick, table_sets ["antimessage"])
elseif tp == 2 then
pmtouser (nick, to, table_sets ["antimessage"])
elseif (tp == 3) or (tp == 4) then
commandanswer (nick, table_sets ["antimessage"])
end
end

local note = 548

if tp == 2 then note = 549
elseif tp == 3 then note = 550
elseif tp == 4 then note = 551
end

opsnotify (table_sets ["classnotianti"], string.format (getlang (note), nick, getip (nick), cls, msg))

if act == 1 then
opsnotify (table_sets ["classnotianti"], string.format (getlang (203), nick))
VH:CloseConnection (nick)
elseif act == 2 then
local rsn = string.gsub (table_sets ["antikreason"], "%*", reprexpchars (msg))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn)
elseif act == 3 then
local rsn = string.gsub (table_sets ["antikreason"], "%*", reprexpchars (msg))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["thirdacttime"])
elseif act == 4 then
opsnotify (table_sets ["classnotianti"], string.format (getlang (52), nick))
elseif act == 6 then
opsnotify (table_sets ["classnotianti"], string.format (getlang (356), nick))
VH:SendDataToUser ("$ForceMove "..table_sets ["sixthactaddr"].."|", nick)
VH:CloseConnection (nick)
elseif act == 7 then
local rsn = string.gsub (table_sets ["antikreason"], "%*", reprexpchars (msg))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["seventhacttime"])
end

return 0
end
end

return 1
end

----- ---- --- -- -

function sefiscan (nick, srch)
if table_sets ["enablesearfilt"] == 0 then return 1 end
local cls = getclass (nick)
if cls >= table_sets ["scanbelowclass"] then return 1 end
local _, _, tp, str = string.find (srch, "^%$Search .* .*%?.*%?.*%?(.*)%?(.*)$")
if not str then return 1 end
if string.len (str) == 0 then return 1 end -- shouldnt be allowed by hub
if not tp then tp = 1 else tp = tonumber (tp) or 1 end
if (tp < 1) or (tp > 9) then tp = 1 end
local _, rows = VH:SQLQuery ("select `exception` from `"..tbl_sql ["sefiex"].."`")
local exlist = {} -- prepare exceptions

for x = 0, rows - 1 do
local _, ent = VH:SQLFetch (x)
table.insert (exlist, ent)
end

str = repsrchchars (repnmdcinchars (str))
if tp == 9 then str = string.sub (str, 5, -1) end -- truncate
local lsr = str
if tp ~= 9 then lsr = string.lower (lsr) end
_, rows = VH:SQLQuery ("select `filter`, `priority`, `action` from `"..tbl_sql ["sefi"].."` where `type` = "..tp.." or `type` = 1 order by `priority` desc, `occurred` desc")

for x = 0, rows - 1 do
local _, ent, prio, act = VH:SQLFetch (x)

if string.find (lsr, ent) then
VH:SQLQuery ("update `"..tbl_sql ["sefi"].."` set `occurred` = `occurred` + 1 where `filter` = '"..repsqlchars (ent).."' limit 1")

if tonumber (prio) < 7 then -- skip for 7, 8 and 9
for _, v in pairs (exlist) do
if string.find (lsr, v) then
VH:SQLQuery ("update `"..tbl_sql ["sefiex"].."` set `occurred` = `occurred` + 1 where `exception` = '"..repsqlchars (v).."' limit 1")
local note = 558

if tp == 2 then note = 559
elseif tp == 3 then note = 560
elseif tp == 4 then note = 561
elseif tp == 5 then note = 562
elseif tp == 6 then note = 563
elseif tp == 7 then note = 564
elseif tp == 8 then note = 565
elseif tp == 9 then note = 566
end

opsnotify (table_sets ["classnotiex"], string.format (getlang (note), nick, getip (nick), cls, str))
return 1
end
end
end

act = tonumber (act)

if act == 5 then
local note = 567

if tp == 2 then note = 568
elseif tp == 3 then note = 569
elseif tp == 4 then note = 570
elseif tp == 5 then note = 571
elseif tp == 6 then note = 572
elseif tp == 7 then note = 573
elseif tp == 8 then note = 574
elseif tp == 9 then note = 575
end

opsnotify (table_sets ["classnotisefi"], string.format (getlang (note), nick, getip (nick), cls, str))
return 1
end

if act ~= 4 then
local rsn = string.gsub (table_sets ["searfiltmsg"], "%*", reprexpchars (str))
commandanswer (nick, rsn)
end

local note = 576

if tp == 2 then note = 577
elseif tp == 3 then note = 578
elseif tp == 4 then note = 579
elseif tp == 5 then note = 580
elseif tp == 6 then note = 581
elseif tp == 7 then note = 582
elseif tp == 8 then note = 583
elseif tp == 9 then note = 584
end

opsnotify (table_sets ["classnotisefi"], string.format (getlang (note), nick, getip (nick), cls, str))

if act == 1 then
opsnotify (table_sets ["classnotisefi"], string.format (getlang (127), nick))
VH:CloseConnection (nick)
elseif act == 2 then
local rsn = string.gsub (table_sets ["sefireason"], "%*", reprexpchars (str))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn)
elseif act == 3 then
local rsn = string.gsub (table_sets ["sefireason"], "%*", reprexpchars (str))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["thirdacttime"])
elseif act == 4 then
opsnotify (table_sets ["classnotisefi"], string.format (getlang (151), nick))
elseif act == 6 then
opsnotify (table_sets ["classnotisefi"], string.format (getlang (357), nick))
VH:SendDataToUser ("$ForceMove "..table_sets ["sixthactaddr"].."|", nick)
VH:CloseConnection (nick)
elseif act == 7 then
local rsn = string.gsub (table_sets ["sefireason"], "%*", reprexpchars (str))
VH:KickUser (table_othsets ["sendfrom"], nick, rsn.."     #_ban_"..table_sets ["seventhacttime"])
end

return 0
end
end

return 1
end

----- ---- --- -- -

function maintoself (nick, message)
VH:SendDataToUser ("<"..nick.."> "..message.."|", nick)
end

----- ---- --- -- -

function offlinepm (from, to, message)
VH:SendDataToUser ("$To: "..to.." From: "..from.." $<"..from.."> "..message.."|", to)
end

----- ---- --- -- -

function pmtouser (to, from, message)
VH:SendDataToUser ("$To: "..to.." From: "..from.." $<"..table_othsets ["sendfrom"].."> "..message.."|", to)
end

----- ---- --- -- -

function maintouser (to, message)
VH:SendDataToUser ("<"..table_othsets ["sendfrom"].."> "..message.."|", to)
end

----- ---- --- -- -

function maintoall (message, mincl, maxcl)
VH:SendDataToAll ("<"..table_othsets ["sendfrom"].."> "..message.."|", mincl, maxcl)
addmchistoryline (table_othsets ["sendfrom"], table_othsets ["sendfrom"], message)
end

----- ---- --- -- -

function commandanswer (to, message)
if table_sets ["commandstopm"] == 0 then
VH:SendDataToUser ("<"..table_othsets ["sendfrom"].."> "..message.."|", to)
else
VH:SendDataToUser ("$To: "..to.." From: "..table_othsets ["botnick"].." $<"..table_othsets ["sendfrom"].."> "..message.."|", to)
end
end

----- ---- --- -- -

function opsnotify (mincls, msg)
if mincls == 11 then return nil end
VH:SendPMToAll ("["..inleadingzeroes (2, mincls).."] "..msg, table_othsets ["feednick"], mincls, 10)

if (table_sets ["histbotmsg"] == 1) and (table_sets ["addledobot"] == 0) and (table_sets ["useextrafeed"] == 0) then
addophistoryline (table_othsets ["opchatnick"], msg)
end
end

---------------------------------------------------------------------
-- ledokol functions <<
---------------------------------------------------------------------

---------------------------------------------------------------------
-- end of file <<
---------------------------------------------------------------------